// BmpPropDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "nukey.h"
#include "compone\include\compone.h"
#include "NukeyDlg.h"
#include "CustomSaverDlg.h"
#include "BmpPropDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBmpPropDlg _CAO


CBmpPropDlg::CBmpPropDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBmpPropDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBmpPropDlg)
	//}}AFX_DATA_INIT
}


void CBmpPropDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBmpPropDlg)
	DDX_Control(pDX, IDC_TimeSpin, m_TimeSpin);
	DDX_Control(pDX, IDC_Time, m_Time);
	DDX_Control(pDX, IDC_Preview, m_Preview);
	DDX_Control(pDX, IDC_Path, m_Path);
	DDX_Control(pDX, IDC_LogOffTop, m_LogOffTop);
	DDX_Control(pDX, IDC_LogOffRight, m_LogOffRight);
	DDX_Control(pDX, IDC_LogOffLeft, m_LogOffLeft);
	DDX_Control(pDX, IDC_LogOffBottom, m_LogOffBottom);
	DDX_Control(pDX, IDC_Align, m_Align);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBmpPropDlg, CDialog)
	//{{AFX_MSG_MAP(CBmpPropDlg)
	ON_BN_CLICKED(IDC_PathBrowse, OnPathBrowse)
	ON_EN_CHANGE(IDC_Path, OnChangePath)
	ON_CBN_SELCHANGE(IDC_Align, OnSelchangeAlign)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBmpPropDlg bZ[W nh

BOOL CBmpPropDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
  RECT  rc;

  CNukeyDlg*  p = m_parent->m_parent;
  int  i = m_iBmp;
  bool  bText = m_parent->m_EnableText.GetCheck() != 0;
  CString  s;

  m_dc = ::GetDC( m_Preview.m_hWnd ); 
  m_Preview.GetClientRect( &rc );
  m_bmp = CreateCompatibleBitmap( m_dc, rc.right, rc.bottom );

  m_Path.SetWindowText( p->m_bmpPath[i] );
  m_Align.SetCurSel( p->m_bmpDrawType[i] );
  s.Format( "%d", p->m_bmpTime[i]/1000 );
  m_Time.SetWindowText( s );
  m_TimeSpin.SetRange( 1, 9999 );

  s.Format( "%d", p->m_unlockRect[i].left );
  m_LogOffLeft.SetWindowText( s );
  m_LogOffLeft.EnableWindow( ! bText );
  s.Format( "%d", p->m_unlockRect[i].top );
  m_LogOffTop.SetWindowText( s );
  m_LogOffTop.EnableWindow( ! bText );
  s.Format( "%d", p->m_unlockRect[i].right );
  m_LogOffRight.SetWindowText( s );
  m_LogOffRight.EnableWindow( ! bText );
  s.Format( "%d", p->m_unlockRect[i].bottom );
  m_LogOffBottom.SetWindowText( s );
  m_LogOffBottom.EnableWindow( ! bText );

  loadPreview();

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CBmpPropDlg::OnOK() 
{
  CNukeyDlg*  p = m_parent->m_parent;
  int  i = m_iBmp;
  CString  s;
  RECT  rc;
  char  path2[_MAX_PATH];

  m_Path.GetWindowText( s );
  StrX_getExeFullPath( path2, s, sizeof(path2) );
  if ( ! FileX_isExist( path2 ) ) {
    MessageBox( "t@C݂ȂpX𐳂ݒ肵Ă", "G[", MB_OK );
    return;
  }
  m_Time.GetWindowText( s );
  if ( atoi( s ) <= 0 ) {
    MessageBox( "\ԂPȏɂĂ", "G[", MB_OK );
    return;
  }

  m_LogOffLeft.GetWindowText( s );
  rc.left = atoi( s );
  m_LogOffTop.GetWindowText( s );
  rc.top = atoi( s );
  m_LogOffRight.GetWindowText( s );
  rc.right = atoi( s );
  m_LogOffBottom.GetWindowText( s );
  rc.bottom = atoi( s );
  if ( rc.left < -1 || rc.right < -1 || rc.top < -1 || rc.bottom < -1 ) {
    MessageBox( "OIt{^ʒu𐳂ݒ肵Ă", "G[", MB_OK );
    return;
  }

  m_Path.GetWindowText( p->m_bmpPath[i] );
  p->m_bmpDrawType[i] = m_Align.GetCurSel();
  m_Time.GetWindowText( s );
  p->m_bmpTime[i] = atoi( s ) * 1000;
  p->m_unlockRect[i] = rc;

  FinishDialog();

	CDialog::OnOK();
}


void CBmpPropDlg::OnCancel() 
{
  FinishDialog();
	CDialog::OnCancel();
}


void CBmpPropDlg::FinishDialog()
{
  DeleteObject( m_bmp );
  ::ReleaseDC( m_Preview.m_hWnd, m_dc );
}


void CBmpPropDlg::OnPathBrowse() 
{
  CFileDialog  dlg( TRUE, "bmp", NULL, OFN_HIDEREADONLY | OFN_EXPLORER,
    "rbg}bv(*.bmp)|*.bmp|ׂẴt@C (*.*)|*.*||", this );

  #ifdef  NDEBUG
    dlg.m_ofn.Flags &= ~OFN_ENABLEHOOK;  /* Win2000ȍ~̐Vt@C_CAOɂ */
  #endif

  if ( dlg.DoModal() == IDOK ) {
    m_Path.SetWindowText( dlg.GetPathName() );
  }
}


void CBmpPropDlg::loadPreview() 
{
  CNukeyDlg*  p = m_parent->m_parent;
  CString  s;
  int  type = m_Align.GetCurSel();
  char  path2[_MAX_PATH];

  m_Path.GetWindowText( s );
  StrX_getExeFullPath( path2, s, sizeof(path2) );
  if ( FileX_isExist( s ) && ! FileX_isDir( s ) ) {
    HDC  bmp_dc = CreateCompatibleDC( m_dc );
    RECT  rc;
    HGDIOBJ  old;
    HBRUSH  brush = CreateSolidBrush( RGB(0,0,0) );

    m_Preview.GetClientRect( &rc );
    old = SelectObject( bmp_dc, m_bmp );
    FillRect( bmp_dc, &rc, brush );
    DrawBitmap( bmp_dc, s, &rc, type );
    SelectObject( bmp_dc, old );
    ::DeleteObject( brush );
    ::DeleteDC( bmp_dc );

    m_Preview.SetBitmap( m_bmp );  // bmp_dc Ƃ̊֘A𖳂ĂłȂƃ_݂
  }
}

void CBmpPropDlg::OnChangePath() 
{
  loadPreview();
}

void CBmpPropDlg::OnSelchangeAlign() 
{
  loadPreview();
}
