/*************************************************************************
*  <<< PXg\ (ListX) >>> 
*yz
*E쐬ҁFMasanori Toda
*E쐬JnFApr.13.1999
**************************************************************************/

#ifndef __LISTX_H
#define __LISTX_H

 
/*************************************************************************
*  <<< W[EvpeB >>> 
**************************************************************************/
/*----------------------------------------------------------------------
[Module Property]
name = ListX
title = PXg\
category =
src = ListX.c
depend = Types
priority =
accord =
----------------------------------------------------------------------*/


 
/*************************************************************************
*  <<< W[ݒ >>> 
**************************************************************************/
#ifndef  LISTX_SETTING
#define  LISTX_SETTING

  #define  LISTX_USE_MALLOC

#endif

 
/*************************************************************************
*  <<< Dwb_ >>> 
**************************************************************************/
#ifndef USES_PRIORITY_HEADER
/*[START_OF_PRIORITY_HEADER]*/

#define  USES_LISTX

typedef struct _ListX  ListX;
typedef void*  ListX_Elem;
typedef struct _ListX_ElemX  ListX_ElemX;

typedef void** ListX_Builder;
typedef void** ListX_Adder;

typedef struct _ListX_Plus  ListX_Plus;
typedef void*  ListX_PlusElem;

typedef struct _ListX_Dic  ListX_Dic;

/*[END_OF_PRIORITY_HEADER]*/
#endif /* USES_PRIORITY_HEADER */



 
/*-----------------------------------------------------------------*/
/* <<< Interface Area ---------------------------------------- >>> */ 
/*-----------------------------------------------------------------*/

#ifdef __cplusplus
extern "C" {
#endif

 
/*************************************************************************
*  <<< [ListX] PXg\ERei >>> 
*y⑫z
*E̐ɂ́Avf̌^LqĂł傤B
*EListX_Dic ͑dpΉ̃ReiԁiCOOLjłB
**************************************************************************/
struct _ListX {
  void*  first;
};

void  ListX_init( ListX* );
/*void  ListX_finish2( ListX*, elem_type, Elem_finish ); */
ListX_Builder  ListX_initForBuilder( ListX* );
#ifdef  USES_ARRX
 /*void  ListX_init_byAble( ListX*, ArrX_Able*, elem_type );*/
 /*void  ListX_init_byArrXBuf( ListX*, ArrX_Buf*, elem_type );*/
#endif
bool  ListX_isEmpty( ListX* );
void  ListX_toEmpty( ListX* );
/* void  ListX_toEmptyFinish( ListX*, elem_type, Elem_finish ); */
/* void  ListX_toEmptyDelete( ListX*, elem_type, Elem_finish ); */
/* void  ListX_toEmptyOfsDelete( ListX*, elem_type, elem_inherit, Elem_finish ); */
void  ListX_addFirst( ListX*, ListX_Elem* );
void  ListX_addLast( ListX*, ListX_Elem* );
void  ListX_insert( ListX*, ListX_Elem* pos, ListX_Elem* ins );
void  ListX_move( ListX*, ListX_Elem* pos, ListX_Elem* moving );
void  ListX_moveStep( ListX*, ListX_Elem* moving, int plus );
void  ListX_moveSet( ListX*, ListX_Elem* from_start, ListX_Elem* from_endNext,
  ListX_Elem* to );
/* elem_type*  ListX_addFirstMalloc( ListX*, elem_type ); */
/* elem_type*  ListX_addLastMalloc( ListX*, elem_type ); */
/* elem_type*  ListX_insertMalloc( ListX*, pos, elem_type ); */
void  ListX_remove( ListX*, ListX_Elem* );
void  ListX_remove2( ListX*, ListX_Elem*, ListX_Adder* );
void  ListX_removeFree( ListX*, ListX_Elem* );
/* void  ListX_removeDelete( ListX*, ListX_Elem*, elem_type_finish ); */
/* void  ListX_reverse( ListX*, elem_type ); */
/* elem_type*  ListX_getFirst( ListX*, elem_type ); */
/* elem_type*  ListX_getLast( ListX*, elem_type ); */
/* elem_type*  ListX_get( ListX*, int i, elem_type ); */
int       ListX_getI( ListX*, ListX_Elem* );
/* int    ListX_getN( ListX*, elem_type ); */
/* elem_type*  ListX_getPrev( ListX*, elem_type*, elem_type ); */

/* ListX_search_s( ListX*, Offset_Key*, const char* kword, elem_type ); */
/* ListX_searchOfs_s( ListX*, Offset_Key*, const char* kword, elem_type,
     elem_inherit ); */
/*    ListX_forEach( ListX*, elem_type**, elem_type ); */
/*    ListX_forEachFree( ListX*, elem_type**, elem_type, elem_type** work, _free ); */

/* void  ListX_printElem( ListX*, elem_type, const char* title ); */

#ifdef  USES_SYM
  bool  ListX_doLoopFunc( Sym_Ref* container, Sym_Ref* elem );
  void  ListX_doReadMemb( Sym_Ref* obj, char* name, Sym_Ref* ret );
  extern  Sym_Struct*  ListX_registSymStruct( Sym* );
  extern  Sym_Struct   ListX_symStruct;
  #define  ListX_SymElem_new( container_type, elem_type )  Offset_init(elem_type, inherit_ListX_Elem)
  #define  ListX_SymElem_delete  NULL
#endif

/* p */
#ifdef  USES_ARRX
void  ListX_init_byAble_imp( ListX*, ArrX_Able*, Offset list_elem,
  Offset able_elem, int elem_size );
void  ListX_init_byArrXBuf_imp( ListX*, ArrX_Buf*, Offset elem_list,
  int elem_size );
#endif
#ifdef  USES_INF
void  ListX_toEmptyDelete_imp( ListX*, Offset elem_offset,
  Inf_FinishFunc Elem_finish );
#endif
void  ListX_insert_imp( ListX*, void* pos, void* ins, Offset ofs );
#ifdef LISTX_USE_MALLOC
 void*  ListX_addFirstMalloc_imp( ListX*, Offset elem_offset, int size );
 void*  ListX_insertMalloc_imp( ListX*, void* pos, Offset elem_offset, int size );
#endif
void  ListX_move_imp( ListX*, void* pos, void* moving, Offset elem_offset );
void  ListX_moveStep_imp( ListX*, void* moving, Offset elem_offset, int plus );
void  ListX_moveSet_imp( ListX*, void* from_start, void* from_endNext,
  void* to, Offset elem_offset );
void  ListX_remove_imp( ListX*, void* elem, Offset ofs );
void  ListX_reverse_imp( ListX*, Offset ofs );
void* ListX_getLast_imp( ListX*, Offset elem_offset );
void* ListX_get_imp( ListX*, int i, Offset elem_offset );
int   ListX_getI_imp( ListX*, void* elem, Offset elem_offset );
int   ListX_getN_imp( ListX*, Offset elem_offset );
void* ListX_getPrev_imp( ListX*, void* elem, Offset elem_offset );
void* ListX_search_s_imp( ListX*, Offset_Key* key, const char* kword,
  Offset elem_offset );
void  ListX_printElem_imp( ListX*, Offset elem_offset, const char* title );

 
/*************************************************************************
*  <<< [ListX_Elem] PXg\EvfiۃNXj >>> 
*y⑫z
*EdpIȈϏɑΉĂ܂B
*Einherit_ListX_Elem ́AListX_Builder ܂B
*  ȊÕoϐĂB
*ẼXgɓɏ邱Ƃ͂ł܂B
*  ̂Ƃ́AListX_PlusElem gp܂B
*EXgvf́Aׂē^łKv܂B
**************************************************************************/
void  ListX_Elem_insertNext( ListX_Elem*, ListX_Elem* );
ListX_Elem*  ListX_Elem_getNext( ListX_Elem* );
/* type*  ListX_Elem_getNextT( ListX_Elem*, type ); */
#ifdef  USES_ARRX
/*ListX_Elem*  ListX_Elem_allocNext( ListX_Elem*, ArrX_Buf*, elem_type );*/
#endif
/* ListX_Elem_forEachFrom( ListX_Elem*, elem_type**, elem_type ); */

 
/*************************************************************************
*  <<< [ListX_ElemX] PXg\E|C^Xg̗vf >>> 
**************************************************************************/
struct _ListX_ElemX {
  ListX_Elem  inherit_ListX_Elem;
  void*  p;
};

/* type*  ListX_ElemX_refP( ListX_ElemX*, type ); */
 
/*************************************************************************
*  <<< [ListX_Builder] PXg\E\zq >>> 
*y⑫z
*ERei\zƂɎgp܂B
*E\zq́AListX_initForBuilder ֐pď܂B
*Ec[\\zƂ́Aꂼ̃m[hƂɍ\zqpӂ܂B
*y⑫z
*EéAListX ܂́Ainherit_ListX_Elem ̃AhXłB
**************************************************************************/
void  ListX_Builder_add( ListX_Builder*, ListX_Elem* );
void  ListX_Builder_add2( ListX_Builder*, void* elem, Offset elem_list );
#ifdef  USES_ARRX
 /* ListX_Elem*  ListX_Builder_alloc( ListX_Builder*, ArrX_Buf*, type ); */
#endif
void  ListX_Builder_finish( ListX_Builder* );


 
/*************************************************************************
*  <<< [ListX_Adder] PXg\Eǉq >>> 
*y⑫z
*EListX_Elem_insertNext őpł̂ŁAp~ɂȂ邩܂B
*EReiXg̖ɒǉĂƂɎgp܂B
*  擪ɒǉƂ ListX_addFirst gpĂB
*E\zq́AListX_initForAdder ֐pď܂B
*EListX_remove ōŌ̗vf폜Ƃ́AsɂȂ܂B
*  ListX_remove2 gpĂB
*yz
*EListX_Adder  ArrX_Buf păXg\ǉ܂
*    ListX        list;
*    ListX_Adder  p;
*    ArrX_Buf*    buf;
*
*    ListX_init( &list );
*    ListX_Adder_init( &p, &list );
*    ListX_Adder_add( &p, ArrX_Buf_alloc(&buf, Elem), Elem );
*y⑫z
*EéAListX ܂́Ainherit_ListX_Elem ̃AhXłB
**************************************************************************/
#ifdef  USES_OFFSET

void  ListX_Adder_init( ListX_Adder*, ListX* );
/* void  ListX_Adder_add( ListX_Adder*, elem ); */

#endif

 
/*************************************************************************
*  <<< [ListX_Plus] PXg\EǉXgpERei >>> 
*y⑫z
*ẼXgɓɏƂɎgpAǉpXgEReiłB
*Evf̌^́AListX_PlusElem ^̐QƂĂB
*EXgvf́Aׂē^łKv܂B
*E̐ɂ́Avf̌^ ListX_PlusElem ^̗vfoLq
*  ł傤B
*EListX_Dic ͏dpΉ̃ReiԁiCOOLjłB
**************************************************************************/
#ifdef  USES_OFFSET

struct _ListX_Plus {
  void*  first;
  Offset  next;    /* ListX_PlusElem ^̃oϐւ̃ItZbg */
};
/* void  ListX_Plus_init( ListX_Plus*, elem_type, elem_member_name );*/
#ifdef  USES_ARRX
 /*void  ListX_Plus_init_byAble( ListX_Plus*, ArrX_Able*, elem_type,
     member_name );*/
#endif
   void  ListX_Plus_toEmpty( ListX_Plus* );
/* void  ListX_Plus_addFirst( ListX_Plus*, elem_type* );*/
/* void  ListX_Plus_addLast( ListX_Plus*, elem_type* );*/
/* void  ListX_Plus_insert( ListX_Plus*, elem_type* pos, elem_type* ins );*/
/* void  ListX_Plus_insertNext( ListX_Plus*, elem_type* pos, elem_type* ins );*/
/* void  ListX_Plus_remove( ListX_Plus*, elem_type* );*/
/* void  ListX_Plus_reverse( ListX_Plus*, type ); */
/* type* ListX_Plus_getFirst( ListX_Plus*, elem_type ); */
/* elem_type*  ListX_Plus_getNext( ListX_Plus*, elem_type* elem, elem_type ); */
/* type* ListX_Plus_get( ListX_Plus*, int i, elem_type ); */
/* int   ListX_Plus_getN( ListX_Plus*, elem_type );*/
/*       ListX_Plus_forEach( ListX_Plus*, type**, elem_type ); */


#endif /* USES_OFFSET */

 
/*************************************************************************
*  <<< [ListX_PlusElem] PXg\EǉXgpEvf̃o >>> 
*y⑫z
*ẼXgɓɏƂɁAXgvf̃oϐɎgp܂B
*EXgvf̍\̂ ListX_PlusElem ^̃oϐǉ܂B
*  ϐ͔Cӂō\܂BAϐ́AListX_Plus_init ֐
*  w肷̂ŒӂĂB
*EListX_Elem_insertNext ɑ}ŃAListX_Plus_insertNext łB
*yz
* typedef  struct _Data {
*   ListX_Elem  inherit_ListX_Elem;
*   ListX_PlusElem  forXContainer;
*   int  data;
* } Data;
*
* void  func()
* {
*   ListX_Plus_init( xlist, Data, forXContainer );
* }
**************************************************************************/

 
/***********************************************************************
*  <<< [ListX_Dic] nbVe[upiq[vgpj >>> 
*y⑫z
*EListX_Dic ̃q[vłłBq[v莫傫ł܂B
*EListX_Dic ̓ReiԁiCOOLjłB
************************************************************************/
#if defined(USES_INF) && defined(USES_ARRX) && defined(USES_STRX) && defined(USES_STDPLUS)
struct _ListX_Dic {
  ArrX   table;     /* nbVe[u, ListX_Plus ^, q[vL */
  int    width;     /* nbVe[u̕ */
  Offset_Key  key;   /* L[ */
  StrX_HashFunc  hash;  /* nbV֐ */
};

/* void   ListX_Dic_init( ListX_Dic*, int width, elem_type, Offset_Key* key,
  StrX_HashFunc hash ); */
/* void   ListX_Dic_toEmpty( ListX_Dic*, elem_type, Inf_FinishFunc finish ); */
/* void   ListX_Dic_finish( ListX_Dic*, elem_type, Inf_FinishFunc finish ); */
/* elem_type*  ListX_Dic_search( ListX_Dic*, const char* kword, elem_type ); */
/* elem_type*  ListX_Dic_searchNext( ListX_Dic*, elem_type* prev, elem_type ); */
/* elem_type*  ListX_Dic_alloc( ListX_Dic*, const char* kword, elem_type ); */
int   ListX_Dic_getN( ListX_Dic* );
void  ListX_Dic_print( ListX_Dic*, const char* title );

/* ȉ͓p */
void  ListX_Dic_init_imp( ListX_Dic*, int width, Offset_Key* key,
  StrX_HashFunc hash, Offset ofsElem );
void   ListX_Dic_finish_imp( ListX_Dic*, Offset elem_offset,
  /* Inf_FinishFunc */ void* Elem_finish );
void*  ListX_Dic_search_imp( ListX_Dic*, const char* kword, Offset ofsElem );
void*  ListX_Dic_searchNext_imp( ListX_Dic*, void* prev, Offset ofsElem );
void*  ListX_Dic_alloc_imp( ListX_Dic*, const char* kword,
  Offset ofsElem, size_t elem_size );

#endif
 
#ifdef __cplusplus
}
#endif

/*-----------------------------------------------------------------*/
/* <<< Mapping Area ------------------------------------------ >>> */ 
/*-----------------------------------------------------------------*/


 
/*-----------------------------------------------------------------------*/
/*  <<<< (ListX) PXg\ERei >>>> */ 
/*-----------------------------------------------------------------------*/


 
/*************************************************************************
*  <<< [ListX_init] ̃Xgɏ >>> 
*y⑫z
*ElƂăXgvfꍇ́AListX_initForBuilder 
*  pƍɂȂ܂B
*y^z
*Evoid  ListX_init( ListX* );
**************************************************************************/
#define  ListX_init( this ) \
  (this)->first = NULL

 
/*************************************************************************
*  <<< [ListX_finish2] vf܂߂Čn >>> 
*yz
*  EListX*  this;                   PXg
*  Eelem_inherit;                   ListX_Elem ^X[p[NXEoϐ
*  EInf_FinishFunc  Elem_finish;    vf̌ni폜j֐iNULLj
*y⑫z
*EListX_addFirstMalloc Ȃ malloc gpvfǉ֐gpƂ̂݁A
*  {}NgČnKv܂B
**************************************************************************/
#ifdef LISTX_USE_MALLOC
#define  ListX_finish2( this, elem_type, Elem_finish ) \
  ListX_toEmptyDelete_imp( this, Offset_init( elem_type, inherit_ListX_Elem ), \
   (Inf_FinishFunc) Elem_finish )
#endif
 
/*************************************************************************
*  <<< [ListX_initForBuilder] \zqpďJn >>> 
*y⑫z
*E{}NĂяoĂA\zqɑ΂ ListX_Builder_finish }N
*  Ăяo܂ŃXg̏ĂȂ̂ŁA܂ł ListX_...
*  ̃}N͎gpȂłB
*y^z
*EListX_Builder  ListX_initForBuilder( ListX* );
**************************************************************************/
#define   ListX_initForBuilder( this ) \
  (&(this)->first)

 
/*************************************************************************
*  <<< [ListX_init_byAble] ArrX_Able z񂩂珉 >>> 
*y⑫z
*EArrX_Able ^̔z񂩂LȗvfvfԍɃXgɂ܂B
*Evf́AArrX_AbleElem  ListX_Elem ÓIdp܂B
*y^z
*Evoid  ListX_init_byAble( ListX*, ArrX_Able*, elem_type );
**************************************************************************/
#ifdef  USES_ARRX
#define  ListX_init_byAble( list, able, elem_type ) \
  ListX_init_byAble_imp( list, able, \
    Offset_init( elem_type, inherit_ListX_Elem ), \
    Offset_init( elem_type, inherit_ArrX_AbleElem ), \
    sizeof( elem_type ) )
#endif

 
/*************************************************************************
*  <<< [ListX_init_byArrXBuf] ArrX_Buf z񂩂珉 >>> 
*y⑫z
*EArrX_Buf ^̔z񂩂LȗvfvfԍɃXgɂ܂B
*y^z
*Evoid  ListX_init_byArrXBuf( ListX*, ArrX_Buf*, elem_type );
**************************************************************************/
#ifdef  USES_ARRX
#define  ListX_init_byArrXBuf( list, buf, elem_type ) \
  ListX_init_byArrXBuf_imp( list, buf, \
    Offset_init( elem_type, inherit_ListX_Elem ), \
    sizeof( elem_type ) )
#endif

 
/*************************************************************************
*  <<< [ListX_isEmpty] Xg󂩂ǂԂ >>> 
*y^z
*Ebool  ListX_isEmpty( ListX* );
**************************************************************************/
#define  ListX_isEmpty( this ) \
  ( (this)->first == NULL )

 
/*************************************************************************
*  <<< [ListX_toEmpty] ̃Xgɂ >>> 
*y^z
*Evoid  ListX_toEmpty( ListX* );
**************************************************************************/
#define  ListX_toEmpty( this ) \
  (this)->first = NULL

 
/*************************************************************************
*  <<< [ListX_toEmptyFinish] SvfɌn֐ĂяoȂ̃Xgɂ >>> 
*yz
*  EListX*  this;   PXg
*  Etype;           vf̌^
*  Etype_finish;    vf̌ni폜j֐i^́Avoid  type_delete( type* ); j
*y⑫z
*E{֐́ASvf StdPlus_delete Ăяo܂B
**************************************************************************/
#define  ListX_toEmptyFinish( this, type, type_finish ) \
  { \
    type*  pp;  type*  work; \
    for ( ListX_forEachFree( this, &pp, type, &(work), (Inf_FinishFunc)(type_finish) ) ); \
    ListX_toEmpty( this ); \
  }
 
/*************************************************************************
*  <<< [ListX_toEmptyDelete] SvfɌn֐ĂяoȂ̃Xgɂ >>> 
*  <<< [ListX_toEmptyOfsDelete] SvfɌn֐ĂяoȂ̃XgɂiOffsetgpj >>>
*yz
*  EListX*  this;                   PXg
*  Eelem_inherit;                   ListX_Elem ^X[p[NXEoϐ
*  EInf_FinishFunc  Elem_finish;    vf̌ni폜j֐iNULLj
*y⑫z
*E{֐́ASvf StdPlus_delete ĂяoƂƓʂ܂B
**************************************************************************/
#define  ListX_toEmptyDelete( this, elem_type, Elem_finish ) \
  ListX_toEmptyDelete_imp( this, Offset_init( elem_type, inherit_ListX_Elem ), \
   (Inf_FinishFunc) Elem_finish )

#define  ListX_toEmptyOfsDelete( this, elem_type, elem_inherit, Elem_finish ) \
  ListX_toEmptyDelete_imp( this, Offset_init( elem_type, elem_inherit ), \
   (Inf_FinishFunc) Elem_finish )



 
/*************************************************************************
*  <<< [ListX_addFirst] Xg̐擪ɗvfǉ >>> 
*  <<< [ListX_addFirstMalloc] malloc ăXg̐擪ɗvfǉ >>>
*y⑫z
*Emalloc Ŋmۂ̈ ListX_toEmptyDelete gpĊJĂB
*y^z
*Evoid  ListX_addFirst( ListX*, ListX_Elem* );
*Eelem_type*  ListX_addFirstMalloc( ListX*, elem_type );
**************************************************************************/
#define  ListX_addFirst( this, elem ) \
  ListX_addFirst_imp( this, elem, Offset_init2( elem, inherit_ListX_Elem ) )

#define  ListX_addFirst_imp( this, elem, elem_offset ) \
  ( Offset_ref( elem_offset, elem, ListX_Elem ) = (this)->first, \
    (this)->first = (elem) )

#ifdef LISTX_USE_MALLOC
 #define  ListX_addFirstMalloc( this, type ) \
   ( (type*) ListX_addFirstMalloc_imp( this, \
     Offset_init( type, inherit_ListX_Elem ), sizeof(type) ) )
#endif

 
/*************************************************************************
*  <<< [ListX_addLast] Xg̖ɗvfǉ >>> 
*  <<< [ListX_addLastMalloc] malloc ăXg̖ɗvfǉ >>>
*y⑫z
*EŖ̗vf`Ă܂B
*Emalloc Ŋmۂ̈ ListX_toEmptyDelete gpĊJĂB
*y^z
*Evoid  ListX_addLast( ListX*, ListX_Elem* );
*Eelem_type*  ListX_addLastMalloc( ListX*, elem_type );
**************************************************************************/
#define  ListX_addLast( this, elem ) \
  ListX_insert_imp( this, NULL, elem, Offset_init2( elem, inherit_ListX_Elem ) )


#ifdef LISTX_USE_MALLOC
 #define  ListX_addLastMalloc( this, type ) \
  ( (type*) ListX_insertMalloc_imp( \
     this, NULL, Offset_init( type, inherit_ListX_Elem ), sizeof(type) ) )
#endif
 
/*************************************************************************
*  <<< [ListX_insert] ẅʒuɃXgvfǉ >>> 
*  <<< [ListX_insertMalloc] malloc ĎẅʒuɃXgvfǉ >>>
*yz
*  EListX_Elem*  pos;  ǉʒu
*  EListX_Elem*  ins;  ǉvf
*y⑫z
*EXg̖ɒǉƂ́Apos=NULL ɂ܂B
*EŒǉ钼O̗vf`Ă܂B
*Emalloc Ŋmۂ̈ ListX_toEmptyDelete gpĊJĂB
*y^z
*Evoid  ListX_insert( ListX*, ListX_Elem* pos, ListX_Elem* ins );
*Eelem_type*  ListX_insertMalloc( ListX*, ListX_Elem* pos, elem_type );
**************************************************************************/
#define  ListX_insert( this, pos, ins ) \
  ListX_insert_imp( this, pos, ins, Offset_init2( ins, inherit_ListX_Elem ) )


#ifdef LISTX_USE_MALLOC
 #define  ListX_insertMalloc( this, pos, type ) \
  ( (type*) ListX_insertMalloc_imp( \
     this, pos, Offset_init( type, inherit_ListX_Elem ), sizeof(type) ) )
#endif



 
/*************************************************************************
*  <<< [ListX_remove] vfXg珜O >>> 
*  <<< [ListX_removeFree] free ėvfXg珜O >>>
*  <<< [ListX_removeDelete] free ƌnėvfXg珜O >>>
*y⑫z
*EŏO钼O̗vf`Ă܂B
*Eelem ɂ́AListX_getFirst Ȃǂ this ̃XgɊւ֐
*  gpƕʂ̃Xgvf free  delete ̂ŒӂĂB
*y^z
*Evoid  ListX_remove( ListX*, ListX_Elem* );
*Evoid  ListX_removeDelete( ListX*, ListX_Elem*, Inf_FinishFunc );
**************************************************************************/
#define  ListX_remove( this, elem ) \
  ListX_remove_imp( this, elem, Offset_init2( elem, inherit_ListX_Elem ) )

#define  ListX_removeFree( this, elem ) \
  ListX_remove_imp( this, elem, Offset_init2( elem, inherit_ListX_Elem ) ), \
  free( elem )

#define  ListX_removeDelete( this, elem, type_finish ) \
  ListX_remove_imp( this, elem, Offset_init2( elem, inherit_ListX_Elem ) ), \
  StdPlus_delete( elem, type_finish )

 
/*************************************************************************
*  <<< [ListX_reverse] Xg̏Ԃtɂ >>> 
*yz
*  EListX*  this;    PXg\ERei
**************************************************************************/
#define  ListX_reverse( this, type ) \
  ListX_reverse_imp( this, Offset_init( type, inherit_ListX_Elem ) );


 
/*************************************************************************
*  <<< [ListX_move] w肵vf̃Xg̈ʒuړi}wj >>> 
*yz
*  EListX*  this;         PXg\ERei
*  EListX_Elem*  pos;     ړʒuiNULLj
*  EListX_Elem*  moving;  ړvf
**************************************************************************/
#define  ListX_move( this, pos, moving ) \
  ListX_move_imp( this, pos, moving, Offset_init2( moving, inherit_ListX_Elem ) )

 
/*************************************************************************
*  <<< [ListX_moveStep] w肵vf̃Xg̈ʒuړiΒlwj >>> 
*yz
*  EListX*  this;         PXg\ERei
*  EListX_Elem*  moving;  ړvf
*  Eint  plus;            ړ̔ԍ̑Βl
*y⑫z
*Eplus ́A傫菬肵Ƃ́A[ɖOa܂B
**************************************************************************/
#define  ListX_moveStep( this, moving, plus ) \
  ListX_moveStep_imp( this, moving, Offset_init2( moving, inherit_ListX_Elem ), plus )

 
/*************************************************************************
*  <<< [ListX_moveSet] w肵vf̏Ẅʒuړ >>> 
*yz
*  EListX*  this;         PXg\ERei
*  EListX_Elem*  from_start;    ړvfW̊Jnvf
*  EListX_Elem*  from_endNext;  ړvfW̍Ō̗̎vf
*  EListX_Elem*  to;            ړ̗vf
**************************************************************************/
#define  ListX_moveSet( this, from_start, from_endNext, to ) \
  ListX_moveSet_imp( this, from_start, from_endNext, to, \
    Offset_init2( from_start, inherit_ListX_Elem ) )

 
/*************************************************************************
*  <<< [ListX_getFirst] Xg̐擪̗vfQƂ >>> 
*yz
*  EListX*  this;         PXg\ERei
*  Etype;    Xgvf̌^
*y^z
*Etype*  ListX_getFirst( ListX*, type );
**************************************************************************/
#define  ListX_getFirst( this, type ) \
  ((type*)(this)->first)

 
/*************************************************************************
*  <<< [ListX_getLast] Xg̖̗vfQƂ >>> 
*yz
*  EListX*  this;         PXg\ERei
*  Etype;    Xgvf̌^
*y^z
*Etype*  ListX_getLast( ListX*, type );
**************************************************************************/
#define  ListX_getLast( this, type ) \
  ((type*)ListX_getLast_imp( this, Offset_init( type, inherit_ListX_Elem ) ) )

 
/*************************************************************************
*  <<< [ListX_get] wԖڂ̗vfQƂ >>> 
*yz
*  EListX*  this;         PXg\ERei
*  Eint  i;         vfԍi擪Oj
*  Etype;           Xgvf̌^
*  Etype*  Ԃl;  vf̃AhX
*y⑫z
*E{}Ngp邽тɃXg̐擪瑖Ă̂ŁAׂĂ̗vf
*  QƂꍇ́AsȂ܂BListX_forEach gpĂB
*Ew肵vfԍ i 傫ƃG[ɂȂ܂B{֐ĂяoO
*  ListX_getN ֐gpă`FbNĂB
*y^z
*Etype*  ListX_get( ListX*, int i, type );
**************************************************************************/
#define  ListX_get( this, i, type ) \
  ((type*)ListX_get_imp( this, i, Offset_init( type, inherit_ListX_Elem ) ))

 
/*************************************************************************
*  <<< [ListX_getI] wvf̗vfԍԂ >>> 
*yz
*  EListX*  this;         PXg\ERei
*  EListX_Elem*  elem;    vf̃AhX
*  Eint  Ԃl;          vfԍi擪OAȂ-1j
**************************************************************************/
#define  ListX_getI( this, elem ) \
  ListX_getI_imp( this, elem, Offset_init2( elem, inherit_ListX_Elem ) )

 
/*************************************************************************
*  <<< [ListX_getN] vfԂ >>> 
*yz
*  Etype;           vf̌^
*  Eint  Ԃl;    vf
*y^z
*Eint  ListX_getN( ListX*, type );
**************************************************************************/
#define  ListX_getN( this, type ) \
  ListX_getN_imp( this, Offset_init( type, inherit_ListX_Elem ) )

 
/*************************************************************************
*  <<< [ListX_getPrev] Xg̒O̗vfԂ >>> 
*yz
*  Eelem_type* elem;      ƂȂvf
*  Eelem_type;            vf̌^
*  Eelem_type*  Ԃl;   Xg̒O̗vf
*y⑫z
*Eelem ɐ擪̗vfw肵Ƃ NULL Ԃ܂B
**************************************************************************/
#define  ListX_getPrev( this, elem, elem_type ) \
  ( (elem_type*) ListX_getPrev_imp( this, elem, \
                  Offset_init( elem_type, inherit_ListX_Elem ) ) )

 
/***********************************************************************
*  <<< [ListX_search_s]  >>> 
*yz
*  EOffset_Key*  key;   vf̃L[
*  Echar*  kword;       L[
*  Eelem_type;          vf̌^
*  Eelem_type*  Ԃl; qbgvf̃AhXiNULL=qbgȂj
************************************************************************/
#define  ListX_search_s( this, key, kword, elem_type ) \
  ( (elem_type*) ListX_search_s_imp( this, key, kword, \
     Offset_init( elem_type, inherit_ListX_Elem ) ) )


/***********************************************************************
*  <<< [ListX_searchOfs_s]  >>>
*yz
*  EOffset_Key*  key;   vf̃L[
*  Echar*  kword;       L[
*  Eelem_type;          vf̌^
*  Eelem_inherit;       vf ListX_Elem NXEoϐ
*  Eelem_type*  Ԃl; qbgvf̃AhXiNULL=qbgȂj
************************************************************************/
#define  ListX_searchOfs_s( this, key, kword, elem_type, elem_inherit ) \
  ( (elem_type*) ListX_search_s_imp( this, key, kword, \
     Offset_init( elem_type, elem_inherit ) ) )
 
/*************************************************************************
*  <<< [ListX_forEach] Xg𑖍 >>> 
*yz
*  ListX*  this;  XgiReij
*  Elem*   p;     ̗vf̃AhX
*
*  for ( ListX_forEach( this, &p, Elem ) );
**************************************************************************/
#define  ListX_forEach( list, pp, elem_type ) \
  *(pp) = (elem_type*)((list)->first);  \
  *(pp) != NULL;  \
  *(pp) = (elem_type*)((elem_type*)*(pp))->inherit_ListX_Elem

 
/*************************************************************************
*  <<< [ListX_forEachOfs] Xg𑖍 >>> 
*  <<< [ListX_forEachOfs_imp] Xg𑖍 >>>
*yz
*  ListX*     this;   XgiReij
*  ListX_Elem*   p;   ̗vf̃AhXĩAhXwj
*  elem_inherit;      vf ListX_Elem NXEoϐ
*
*  for ( ListX_forEachOfs( this, &p, elem_type, elem_inherit ) );
*  for ( ListX_forEach_imp( this, &p, elem_offset ) );
**************************************************************************/
#define  ListX_forEachOfs( this, pp, elem_type, elem_inherit ) \
  *(pp) = (elem_type*)((this)->first);  \
  *(pp) != NULL;  \
  *(pp) = (elem_type*)(*(pp))->elem_inherit


#define  ListX_forEach_imp( this, pp, elem_offset ) \
  *(pp) = (ListX_Elem*)((this)->first);  \
  *(pp) != NULL;  \
  *(pp) = Offset_ref( elem_offset, *(pp), ListX_Elem* )
 
/*************************************************************************
*  <<< [ListX_forEachFree] Xg𑖍ėvf free  >>> 
*y⑫z
*EXgvf폜Ƃ́AListX_toEmptyDelete gpĂB
*Epł
**************************************************************************/
#define  ListX_forEachFree( this, pp, type, pWork, _free ) \
  *(pp) = (type*)((this)->first);  \
  *(pp) != NULL;  \
  *(pWork)=*(pp), *(pp) = (*(pp))->inherit_ListX_Elem, (_free)(*(pWork))

 
/*************************************************************************
*  <<< [ListX_forEachOfsFree] Xg𑖍ėvf free iOffset wj >>> 
*y⑫z
*EListX_forEachFree }N̐QƂĂB
*yz
*  ListX*  this;         XgiReij
*  void*   p;            ̗vf̃AhXĩAhXwj
*  Offset  ofsElem;      Xgvf ListX_Elem ^ۃNX̃ItZbg
*  void*   work;         [Npi[U͎QƂł܂j
*  void    free(void*);  free ֐
*
*  for ( ListX_forEachOfsFree( this, &p, ofsElem, &work, free ) );
**************************************************************************/
#define  ListX_forEachOfsFree( this, pp, ofsElem, pWork, _free ) \
  *(pp) = ((this)->first);  \
  *(pp) != NULL;  \
  *(pWork)=*(pp), *(pp) = Offset_ref( ofsElem, *(pp), ListX_Elem ), (_free)(*(pWork))

 
/*************************************************************************
*  <<< [ListX_printElem] Xg̗vf̃AhX񋓁A\ >>> 
*yz
*  ListX*  this;         XgiReij
*  type;                 Xgvf̌^
*  Offset  elem_offset;  Xgvf ListX_Elem ^ۃNX̃ItZbg
*y^z
* void  ListX_printElem( ListX*, type, const char* title );
**************************************************************************/
#define  ListX_printElem( this, type, title ) \
  ListX_printElem_imp( this, Offset_init( type, inherit_ListX_Elem ), title )

 
/*-----------------------------------------------------------------------*/
/*  <<<< (ListX_Elem) PXg\Evf >>>> */ 
/*-----------------------------------------------------------------------*/


 
/*************************************************************************
*  <<< [ListX_Elem_insertNext] wvf̎ɗvfǉ >>> 
*yz
*  EListX_Elem*  sub;     ǉ钼O̗vf
*  EListX_Elem*  add;     ǉvf
*  EListX_Elem*  Ԃl;  ǉvfiadd Ɠj
*y^z
*EListX_Elem*  ListX_Elem_insertNext( ListX_Elem*, ListX_Elem* );
**************************************************************************/
#define  ListX_Elem_insertNext( sub, add ) \
( \
  (add)->inherit_ListX_Elem = (sub)->inherit_ListX_Elem, \
  (sub)->inherit_ListX_Elem = (add), \
  (add) \
)

 
/*************************************************************************
*  <<< [ListX_Elem_getNext] ̗vfԂiLXgȂj >>> 
*yz
*  EListX_Elem*  elem;     ƂȂvf
*  EListX_Elem*  Ԃl;   elem ̗̎vfiNULL=̗vf̎j
**************************************************************************/
#define  ListX_Elem_getNext( elem ) \
  (elem)->inherit_ListX_Elem
 
/*************************************************************************
*  <<< [ListX_Elem_getNextT] ̗vfԂi^w肠j >>> 
*yz
*  Etype*  elem;     ƂȂvf
*  Etype;            vf̌^
*  Etype*  Ԃl;   elem ̗̎vfiNULL=̗vf̎j
**************************************************************************/
#define  ListX_Elem_getNextT( elem, type ) \
  ((type*)(elem)->inherit_ListX_Elem)
 
/*************************************************************************
*  <<< [ListX_Elem_allocNext] ̈mۂāAwvf̎ɗvfǉ >>> 
*yz
*  EListX_Elem*  sub;     ǉꏊ̒ÕXgvf
*  EArrX_Buf*    buf;     ǉ郊Xgvf̋L̈
*  Etype;                 ǉ郊Xgvf̌^
*  EListX_Elem*  Ԃl;  ǉXgvf̃AhX
*y^z
*EListX_Elem*  ListX_Elem_allocNext( ListX_Elem*, ArrX_Buf*, type );
**************************************************************************/
#ifdef  USES_ARRX
#define  ListX_Elem_allocNext( sub, buf, type ) \
    ( ((type*)(buf)->last)->inherit_ListX_Elem = (sub)->inherit_ListX_Elem, \
      (sub)->inherit_ListX_Elem = ArrX_Buf_alloc( buf, type ) )
#endif

 
/*************************************************************************
*  <<< [ListX_Elem_forEachFrom] w̃Xgvfȍ~𑖍 >>> 
*yz
*  EListX_Elem*  prevElem;  Jn钼O̗vf
*  Eelem_type**  pp;        ̗vfւ̃|C^̃AhX
*  Eelem_type;              vf̌^
**************************************************************************/
#define  ListX_Elem_forEachFrom( prevElem, pp, elem_type ) \
  *(pp) = (elem_type*)((prevElem)->inherit_ListX_Elem);  \
  *(pp) != NULL;  \
  *(pp) = (elem_type*)((elem_type*)*(pp))->inherit_ListX_Elem
 
/*-----------------------------------------------------------------------*/
/*  <<<< (ListX_ElemX) PXg\E|C^Xg̗vf >>>> */ 
/*-----------------------------------------------------------------------*/


 
/*************************************************************************
  <<< [ListX_ElemX_refP] |C^QƂ >>> 
yz
  EListX_ElemX*  this;   PXg\E|C^Xg̗vf
  Etype;                 Xgvf̌^i|C^^j
  Etype  Ԃl;         |C^̎Q
y⑫z
EQƂłȂł܂B
**************************************************************************/
#define  ListX_ElemX_refP( this, type ) \
  ((type)((this)->p))
 
/*-----------------------------------------------------------------------*/
/*  <<< (ListX_Builder) PXg\E\zq >>> */ 
/*-----------------------------------------------------------------------*/


 
/*************************************************************************
*  <<< [ListX_Builder_add] Xg̖ɗvfǉ >>> 
*yz
*  EListX_Builder*  this;    ǉꏊ̒ÕXgvf
*  EListX_Elem*     elem;    ǉ郊Xgvf
*y^z
*Evoid  ListX_Builder_add( ListX_Builder*, elem );
*y⑫z
*E{}ŃAǉ悤ƂĂ钼O̗vf inherit_ListX_Elem oϐ
*  i擪̗vf̏ꍇ ListX ^̃oϐjĂ܂B
**************************************************************************/
#define  ListX_Builder_add( this, elem ) \
    **(this) = elem, \
    *(this) = &(elem)->inherit_ListX_Elem
 
/*************************************************************************
*  <<< [ListX_Builder_add2] Xg̖ɗvfǉiOffsetŁj >>> 
*yz
*  EListX_Builder*  this;    ǉꏊ̒ÕXgvf
*  EListX_Elem*     elem;    ǉ郊Xgvf
*  Einherit_ListX_Elem;      X[p[NXֈϏϐ
*y^z
*Evoid  ListX_Builder_add2( ListX_Builder*, elem, inherit_ListX_Elem );
*y⑫z
*E{}ŃAǉ悤ƂĂ钼O̗vf inherit_ListX_Elem oϐ
*  i擪̗vf̏ꍇ ListX ^̃oϐjĂ܂B
**************************************************************************/
#define  ListX_Builder_add2( this, elem, elem_list ) \
  **(this) = (void*)(elem), *(this) = &Offset_ref( elem_list, elem, ListX_Elem )
 
/*************************************************************************
*  <<< [ListX_Builder_alloc] ̈mۂāAXg̖ɗvfǉ >>> 
*yz
*  EListX_Builder*  this;    ǉꏊ̒ÕXgvf
*  EArrX_Buf*       buf;     ǉ郊Xgvf̋L̈
*  Etype;                    ǉ郊Xgvf̌^
*  EListX_Elem*     Ԃl;  ǉXgvf̃AhX
*y^z
*EListX_Elem*  ListX_Builder_alloc( ListX_Builder*, ArrX_Buf*, type );
*y⑫z
*E{}ŃAǉ悤ƂĂ钼O̗vf inherit_ListX_Elem oϐ
*  i擪̗vf̏ꍇ ListX ^̃oϐjĂ܂B
**************************************************************************/
#ifdef  USES_ARRX
#define  ListX_Builder_alloc( this, buf, type ) \
    ( **(this) = (buf)->last, \
      *(this) = &((type*)(buf)->last)->inherit_ListX_Elem, \
      ArrX_Buf_alloc( buf, type ) )
#endif

 
/*************************************************************************
*  <<< [ListX_Builder_finish] \zqnāAXg >>> 
*y^z
*Evoid  ListX_Builder_finish( ListX_Builder* );
*y⑫z
*E{}ŃAŌɒǉvf inherit_ListX_Elem oϐ
*  Ă܂B
**************************************************************************/
#define  ListX_Builder_finish( this ) \
    **(this) = NULL

 
/*-----------------------------------------------------------------------*/
/*  <<<< (ListX_Adder) PXg\Eǉq >>>> */ 
/*-----------------------------------------------------------------------*/


 
/*************************************************************************
*  <<< [ListX_Adder_init]  >>> 
*yz
*  EListX_Adder*  this;   PXg\Eǉq
*  EListX*        list;   vfǉ郊XgERei
*  EtypeOfElem;           Xgvf̌^
*y^z
*Evoid  ListX_Adder_init( ListX_Adder*, ListX*, typeOfElem );
**************************************************************************/
#ifdef  USES_OFFSET

#define  ListX_Adder_init( this, list, type ) \
  ListX_Adder_init_imp( this, list, Offset_init( type, inherit_ListX_Elem ) )

void  ListX_Adder_init_imp( ListX_Adder*, ListX* list, Offset elemOfs );

#endif
 
/*************************************************************************
*  <<< [ListX_Adder_add] ɃXgvfǉ >>> 
*yz
*  EListX_Adder*  this;    PXg\Eǉq
*  EListX_Elem*   elem;    ǉ郊Xgvf
*y^z
*Evoid  ListX_Adder_add( ListX_Adder*, elem );
*y⑫z
*E{}ŃAǉ悤ƂĂ钼O̗vf inherit_ListX_Elem oϐ
*  i擪̗vf̏ꍇ ListX ^̃oϐjĂ܂B
**************************************************************************/
#ifdef  USES_OFFSET

#define  ListX_Adder_add( this, elem ) \
    *(this)->first = elem, \
    (this)->first = &(elem)->inherit_ListX_Elem, \
    *(this)->first = NULL

#endif
 
/*-----------------------------------------------------------------------*/
/*  <<<< (ListX_Plus) PXg\EǉXgpERei >>>> */ 
/*-----------------------------------------------------------------------*/

 
/*************************************************************************
*  <<< [ListX_Plus_init] ivf͋ɂj >>> 
*yz
*  EListX_Plus*  this;    PXg\EǉXgpERei
*  Eelem_type;            vf̌^
*  Eelem_member_name;     elem_type  ListX_PlusElem ^oϐ
*y⑫z
*EXgɒǉłvf́A{}NŎw肵 elem_type ^݂̂
*  ܂B
**************************************************************************/
#define   ListX_Plus_init( this, elem_type, elem_member_name ) \
  ( (this)->first = NULL, \
    (this)->next = Offset_init( elem_type, elem_member_name ) )


 
/*************************************************************************
*  <<< [ListX_Plus_init2] ivf͋ɂjiOffsetgpj >>> 
*yz
*  EListX_Plus*  this;    PXg\EǉXgpERei
*  EOffset  ofsPlusElem;  ListX_PlusElem ^oϐ̃ItZbg
*y⑫z
*EXgɒǉłvf́A{}N ofsPlusElem Ŏw肵̂
*  ItZbǧ^Ɍ܂B
*EofsPlusElem  ListX_Elem ^̃oϐw肵Ă\܂񂪁A
*  ̂Ƃ ListX_init g܂B
**************************************************************************/
#define   ListX_Plus_init2( this, ofsPlusElem ) \
  ( (this)->first = NULL, (this)->next = (ofsPlusElem) )


 
/*************************************************************************
*  <<< [ListX_Plus_init_byAble] ArrX_Able z񂩂珉 >>> 
*y⑫z
*EArrX_Able ^̔z񂩂LȗvfvfԍɃXgɂ܂B
*Evf́AArrX_AbleElem  ListX_PlusElem ÓIdp܂B
*y^z
*Evoid  ListX_Plus_init_byAble( ListX_Plus*, ArrX_Able*, elem_type,
*     member_name );
**************************************************************************/
#ifdef  USES_ARRX
#define  ListX_Plus_init_byAble( list, able, elem_type, member_name ) \
  ListX_init_byAble_imp( &(list)->first, able, \
    Offset_init( elem_type, member_name ), \
    Offset_init( elem_type*, inherit_ArrX_AbleElem ), \
    sizeof( elem_type ) ), \
  (list)->next = Offset_init( elem_type, member_name )
#endif

 
/*************************************************************************
*  <<< [ListX_Plus_toEmpty] ̃Xgɂ >>> 
*y^z
*Evoid  ListX_Plus_toEmpty( ListX_Plus* );
**************************************************************************/
#define  ListX_Plus_toEmpty( this ) \
  (this)->first = NULL

 
/*************************************************************************
*  <<< [ListX_Plus_addFirst] Xg̐擪ɒǉ >>> 
*yz
*  EListX_Plus*  this;    PXg\EǉXgpERei
*  Eelem_type*  elem;     vf̃AhXielem_type ͗vf̍\̌^j
*y^z
*Evoid  ListX_Plus_addFirst( ListX_Plus*, elem_type* elem );
**************************************************************************/
#define  ListX_Plus_addFirst( this, elem ) \
  ListX_addFirst_imp( this, elem, (this)->next )




 
/*************************************************************************
*  <<< [ListX_Plus_addLast] Xg̖ɒǉ >>> 
*yz
*  EListX_Plus*  this;    PXg\EǉXgpERei
*  Eelem_type*  elem;     vf̃AhXielem_type ͗vf̍\̌^j
*y⑫z
*EŖ̗vf`Ă܂B
*y^z
*Evoid  ListX_Plus_addLast( ListX_Plus*, elem_type* elem );
**************************************************************************/
#define  ListX_Plus_addLast( this, elem ) \
  ListX_insert_imp( (ListX*)&(this)->first, NULL, elem, (this)->next )


 
/*************************************************************************
*  <<< [ListX_Plus_insert] wvf̈ʒuɗvfǉ >>> 
*yz
*  EListX_Plus*  this;    PXg\EǉXgpERei
*  Eelem_type*  pos;      ǉʒuielem_type ͗vf̍\̌^j
*  Eelem_type*  ins;      ǉvfielem_type ͗vf̍\̌^j
*y⑫z
*Epos Ƃ̒O̗vf̊Ԃ ins ǉ܂B
*EXg̖ɒǉƂ́Apos=NULL ɂ܂B
*EŒǉ钼O̗vf`Ă܂B
*y^z
*Evoid  ListX_Plus_insert( ListX_Plus*, elem_type* pos, elem_type* ins );
**************************************************************************/
#define  ListX_Plus_insert( this, pos, ins ) \
  ListX_insert_imp( (ListX*)&(this)->first, pos, ins, (this)->next )



 
/*************************************************************************
*  <<< [ListX_Plus_insertNext] wvf̎ɗvfǉ >>> 
*yz
*  EListX_Plus*      this;    PXg\EǉXgpERei
*  EListX_PlusElem*  pos;     ǉ钼O̗vf
*  EListX_PlusElem*  ins;     ǉvf
*y⑫z
*Epos Ƃ̗̒vf̊Ԃ ins ǉ܂B
*EListX_Plus_insert ɔׁA`ȂłB
*y^z
*Evoid  ListX_Plus_insertNext( ListX_Plus* this, ListX_PlusElem* pos,
*    ListX_PlusElem* ins );
**************************************************************************/
#define  ListX_Plus_insertNext( this, pos, ins ) \
( \
  Offset_ref( (this)->next, ins, void* ) = Offset_ref( (this)->next, pos, void* ), \
  Offset_ref( (this)->next, pos, void* ) = (ins) \
)

 
/*************************************************************************
*  <<< [ListX_Plus_remove] XgwvfO >>> 
*yz
*  EListX_Plus*  this;    PXg\EǉXgpERei
*  Eelem_type*  elem;     Ovfielem_type ͗vf̍\̌^j
*y⑫z
*EŏO钼O̗vf`Ă܂B
*y^z
*Evoid  ListX_Plus_remove( ListX_Plus*, elem_type* elem );
**************************************************************************/
#define  ListX_Plus_remove( this, elem ) \
  ListX_remove_imp( (ListX*)&(this)->first, elem, (this)->next )


 
/*************************************************************************
*  <<< [ListX_Plus_reverse] Xg̏Ԃtɂ >>> 
*yz
*  EListX_Plus*  this;    PXg\EǉXgpERei
**************************************************************************/
#define  ListX_Plus_reverse( this, type ) \
  ListX_reverse_imp( (ListX*)&(this)->first, (this)->next );

 
/*************************************************************************
*  <<< [ListX_Plus_getFirst] 擪̗vfQƂ >>> 
*yz
*  EListX_Plus*  this;    PXg\EǉXgpERei
*  Eelem_type;            vf̍\̌^
*  Eelem_type*  Ԃl;   vf̃AhX
*y^z
*Eelem_type*  ListX_Plus_getFirst( ListX_Plus*, elem_type );
**************************************************************************/
#define  ListX_Plus_getFirst( this, elem_type ) \
  ( (elem_type*)(this)->first )


 
/*************************************************************************
*  <<< [ListX_Plus_getNext] Xg̗̎vfQƂ >>> 
*yz
*  EListX_Plus*  this;    PXg\EǉXgpERei
*  Eelem_type*   elem;    ƂȂvf
*  Eelem_type;            vf̌^
*  Eelem_type*  Ԃl;   ̗vf̃AhX
*y^z
*Eelem_type*  ListX_Plus_getNext( ListX_Plus*, elem_type* elem, elem_type );
**************************************************************************/
#define  ListX_Plus_getNext( this, elem, elem_type ) \
  Offset_ref( (this)->next, (elem), elem_type* )


 
/*************************************************************************
*  <<< [ListX_Plus_get] wԖڂ̗vfQƂ >>> 
*yz
*  EListX_Plus*  this;    PXg\EǉXgpERei
*  Eint  i;               vfԍi擪Oj
*  Eelem_type;            vf̍\̌^
*  Eelem_type*  Ԃl;   vf̃AhX
*y^z
*Eelem_type*  ListX_Plus_get( ListX_Plus*, int i, elem_type );
**************************************************************************/
#define  ListX_Plus_get( this, i, elem_type ) \
  (elem_type*)ListX_get_imp( (ListX*)(this)->first, i, (this)->next )



 
/*************************************************************************
*  <<< [ListX_Plus_getN] vfԂ >>> 
*yz
*  EListX_Plus*  this;    PXg\EǉXgpERei
*  Eelem_type;            vf̍\̌^
*  Eint  Ԃl;          vf
*y^z
*Eint  ListX_Plus_getN( ListX_Plus*, elem_type );
*y⑫z
*Eelem_type ͎gpĂ܂񂪁AListX_getN Ƃ̌݊̂߂
*  ɓĂ܂B
**************************************************************************/
#define  ListX_Plus_getN( this, elem_type ) \
  ListX_getN_imp( (ListX*)(this), (this)->next )


 
/*************************************************************************
*  <<< [ListX_Plus_forEach] Xg𑖍 >>> 
*y⑫z
*Efor ̒Ŏgp܂B
*    ListX*  con;    // Rei
*    Elem*   pp;     // ̗vf̃AhX
*    for ( ListX_Plus_forEach( &pp, con, Elem ) );
**************************************************************************/
#define  ListX_Plus_forEach( list, pp, elem_type ) \
  *(pp) = (elem_type*)((list)->first);  \
  *(pp) != NULL;  \
  *(pp) = Offset_ref( (list)->next, *(pp), elem_type* )

 
/*-----------------------------------------------------------------------*/
/*  <<<< (ListX_PlusElem) PXg\EǉXgpEvf >>>> */ 
/*-----------------------------------------------------------------------*/

 
/*-----------------------------------------------------------------------*/
/*  <<<< (ListX_Dic) nbVe[upiq[vgpj >>>> */ 
/*-----------------------------------------------------------------------*/

#if defined(USES_INF) && defined(USES_ARRX) && defined(USES_STRX) && defined(USES_STDPLUS)
 
/***********************************************************************
*  <<< [ListX_Dic_init]  >>> 
*yz
*  Eint  width;            nbVe[u̕iȂׂfɂ܂j
*  Eelem_type;             vf̌^iListX_Elem 牼zpj
*  EOffset_Key*  key;      L[
*  EStrX_HashFunc  hash;   nbV֐iStrX_getHash Ȃǁj
*y⑫z
*Evf́AListX_Elem 瑽dp܂B
************************************************************************/
#define  ListX_Dic_init( this, width, elem_type, key, hash ) \
  ListX_Dic_init_imp( this, width, key, hash, Offset_init( elem_type, inherit_ListX_Elem ) )

 
/***********************************************************************
*  <<< [ListX_Dic_finish] n >>> 
************************************************************************/
#define  ListX_Dic_finish( this, elem_type, Elem_finish ) \
  ListX_Dic_finish_imp( this, Offset_init( elem_type, inherit_ListX_Elem ), \
    Elem_finish )


 
/***********************************************************************
*  <<< [ListX_Dic_toEmpty] vfɂ >>> 
************************************************************************/
#define  ListX_Dic_toEmpty( this, elem_type, Elem_finish ) \
  ListX_Dic_toEmpty_imp( this, Offset_init( elem_type, inherit_ListX_Elem ), \
    Elem_finish )


 
/***********************************************************************
*  <<< [ListX_Dic_search]  >>> 
*yz
*  Echar*  kword;         L[
*  Eelem_type;            vf̌^
*  Eelem_type*  Ԃl;   qbgvf̃AhXiNULL=qbgȂj
************************************************************************/
#define  ListX_Dic_search( this, kword, elem_type ) \
  ( (elem_type*)ListX_Dic_search_imp( this, kword, \
    Offset_init( elem_type, inherit_ListX_Elem ) ) )


 
/***********************************************************************
*  <<< [ListX_Dic_searchNext] Ƀqbg鎫vf >>> 
*yz
*  Eelem_type*  prev;     Oqbgvf
*  Eelem_type;            vf̌^
*  Eelem_type*  Ԃl;   qbgvf̃AhXiNULL=qbgȂj
************************************************************************/
#define  ListX_Dic_searchNext( this, prev, elem_type ) \
  ( (elem_type*)ListX_Dic_searchNext_imp( this, prev, \
    Offset_init( elem_type, inherit_ListX_Elem ) ) )


 
/**************************************************************************
*  <<< [ListX_Dic_alloc] w肵L[[h̎ڂ̗̈mۂ >>> 
*yz
*  Echar*  kword;         L[[h
*  Eelem_type;            vf̌^
*  Eelem_type*  Ԃl;   mۂ̈̃AhXAiNULL=ɂj
*y⑫z
*Evf̃L[[ĥ߂̈̊̕mۂ͖{}Nōs܂B
*EL[[ḧ̗ malloc Ƃ́AListX_Dic_finish Ŏw肷
*  n֐ɃL[[ḧ̕ free ĂB
***************************************************************************/
#define  ListX_Dic_alloc( this, kword, elem_type ) \
  ( (elem_type*)ListX_Dic_alloc_imp( this, kword, \
     Offset_init( elem_type, inherit_ListX_Elem ), sizeof(elem_type) ) )


 
#endif  /* ListX_Dic */ 
 
#endif /* __LISTX_H */ 
 
