/**************************************************************************
*  <<< 傫X^bN (BigStack) >>> 
*
*E[JX^bNi[JϐɊ蓖ĂX^bN̈jƂ͕ʂɁA
*  傫̈KvƂꍇ̃X^bNłB
*ẼX^bN̈́AO[oϐ̗̈Ɏ܂B
*EBigStack_max ϐɁAő̎gpTCYi[܂B
*  ABIGSTACK_CHKSIZE ݒ肵ĂB
*
*y⑫z
* --- X^bN̍\ ---
*EBigStack ̃X^bŃAX^bNEubNJԂĂB
*EBigStack ́AX^bNEubNPʂƂăX^bNJB
*EX^bNEubŃÂ悤ȍ\ɂȂĂB
*    [PÕX^bNEubN̐擪AhX][X^bN̈]
*  ̐}͖Ă܂܂ (^^;
*  <IMG src="bigstac1.gif">
*
*E1.BigStack_start ֐ŁAPÕX^bNEubN̐擪AhXL^āA
*   ݂̃X^bNE|C^̈ʒuoϐɎĂA X^bNE|C
*   ^X^bN̈ɈړB
*E2.BigStack_alloc ֐ŁAX^bN̈[Û߂ɊmۂāA X^bNE
*   |C^i߂B
*E3.BigStack_end ֐ŁAoϐɎĂlpāA X^bNE
*  |C^݂̃X^bNEubN̐擪ɈړA ̈ʒuɋL^Ă
*  uPÕX^bNEubN̐擪AhXv oϐɎĂB
*
*Eŏ̃X^bNEubŃuPÕX^bNEubN̐擪AhXv́A
*  NULL B
***************************************************************************/

#include "mixer_precomp.h"  /* Auto precompiled header, Look at mixer-... folder */
// #pragma hdrstop ("mixer_precomp")

#define   STDLIBS_INCLUDE
#define   STDLIBS_INCLUDE_STDIO_H
#define   STDLIBS_INCLUDE_STDLIB_H

#if defined(USES_MXP_AUTOINC)
 #include "bigstack.ah"  /* Auto include header, Look at mixer-... folder */
#endif

#ifdef  count
#undef  count
#endif
#ifdef  sp
#undef  sp
#endif

 
/*---------------------------------------------------------------------*/
/* <<< rbOX^bNEVXe >>> */ 
/*---------------------------------------------------------------------*/

BigStack   BigStack_Sys_arrX;       /* ftHg */

#ifdef  USES_MULTASK
BigStack*  BigStack_Sys_arr = &BigStack_Sys_arrX;  /* z */
int        BigStack_Sys_mArr = 1;
#endif



 
/**************************************************************************
*  <<< [BigStack_Sys_init] BisStack VXe >>> 
*yz
*  EBigStack*   works;   [N̈̐擪AhX
*  Eint         mWork;   z work ̍ővf
*y⑫z
*EVO^XNł͌ĂяoKv͂܂B
*E{֐ĂяoOɁAMulTask_Sys_init ĂяoĂB
***************************************************************************/
#ifdef  USES_MULTASK
void  BigStack_Sys_init( BigStack* works, int mWork )
{
  ASSERT( MulTask_Sys_isEnable() );

  BigStack_Sys_arr = works;
  BigStack_Sys_mArr = mWork;
}
#endif


 
/*---------------------------------------------------------------------*/
/* <<< rbOX^bN̈ >>> */ 
/*---------------------------------------------------------------------*/




 
/**************************************************************************
*  <<< [BigStack_init_imp]  >>> 
*yz
*  Echar*   mem;         傫X^bN̈̐擪AhX
*  Esize_t  mem_sizeof;  mem ̃TCYioCgj
*y⑫z
*EBigStack_init }NĂ΂܂B
*E}`^XNEVXeł́AMulTask_Sys_init ֐ĂяoĂ
*  BigStack_init }NsĂB
***************************************************************************/
void  BigStack_init_imp( BigStack* m, char* mem, size_t mem_sizeof )
{
  ERRORS_INITCHK( m, 0 );
  ASSERT( ((int)mem & 3) == 0 );  /* |C^i[邽 */

  m->mem = mem;
  m->size = mem_sizeof;
  m->sp = mem;
  m->block1 = NULL;
}


 
/**************************************************************************
*  <<< [BigStack_start_imp] X^bNubN̊Jn̎w >>> 
***************************************************************************/
void  BigStack_start_imp( BigStack* m )
{
  ERRORS_INITCHK( m, 1 );

  #ifndef  NDEBUG
    m->count ++;
  #endif

  /* BigStack_block1  mem ɑҔ */
  *(char**)m->sp = m->block1;

  /* X^bNubN̋؂̃ʒuL^ */
  m->block1 = m->sp;

  m->sp += sizeof( char* );
}


 
/**************************************************************************
*  <<< [BigStack_alloc_imp] X^bN烁̈mۂ >>> 
*y⑫z
*Echar* ^ȊṎƂĎgꍇ́ALXgĂB
*y⑫z
*Evoid* ^ԂĂLXg͕KvłB
***************************************************************************/
char*  BigStack_alloc_imp( BigStack* m, unsigned int size )
{
  char*  ret = m->sp;

  ERRORS_INITCHK( m, 2 );

  #ifdef  FOR_32BIT
    size = ( (size + 3) & 0xFFFFFFFC );  /* S̔{ɐ؏グ */
  #else
    size = ( (size + 3) & 0xFFFC );  /* S̔{ɐ؏グ */
  #endif

  if ( (m->sp - m->mem) + size > m->size ) {
    error2_2( BigStack_Full, "BigStack sł (usable=%d, request=%d)",
      m->size - (m->sp - m->mem), size );
  }

  m->sp += size;

  #ifdef  BIGSTACK_CHKSIZE
    if ( m->sp > m->mem + m->max ) {
      m->max = m->sp - m->mem;
    }
  #endif

  return  ret;
}


 
/**************************************************************************
*  <<< [BigStack_end_imp] X^bNubN̏I̎w >>> 
***************************************************************************/
void  BigStack_end_imp( BigStack* m )
{
  #ifndef  NDEBUG
    m->count --;
  #endif
  ERRORS_INITCHK( m, 1 );
  ASSERT( m->block1 != NULL );  /* QdG[̂PxڂŃu[N΃qgɂȂ܂ */

  /* X^bN|C^ sp ߂ */
  m->sp = m->block1;

  /* m->block1 ߂ */
  m->block1 = *(char**)m->sp;
}


 
/**************************************************************************
*  <<< [BigStack_print_imp] fobO\ >>> 
***************************************************************************/
#ifndef  ERRORS_CUT_DEBUG_TOOL
void  BigStack_print_imp( BigStack* m )
{
  Errors_printf( "BigStack: mem=%p, size=0x%X, sp=%p, block1=%p",
    m->mem, m->size, m->sp, m->block1 );
  #ifdef  BIGSTACK_CHKSIZE
    Errors_printf( "BigStack: max=0x%X", m->max );
  #endif
  #ifndef  NDEBUG
    Errors_printf( "BigStack: count=%d", m->count );
  #endif
}
#endif

 
