/*************************************************************************
*  <<< \tgEFAOR (Except3) >>> 
**************************************************************************/

#ifndef __EXCEPT3_H
#define __EXCEPT3_H

#ifdef  count
 #undef count
#endif
 
/*************************************************************************
*  <<< W[EvpeB >>> 
**************************************************************************/

/*----------------------------------------------------------------------
[Module Property]
name = Except3
title = Ov3
category = G[
src = except3.c
depend =
priority =
accord =
----------------------------------------------------------------------*/
/* depend = Types, Inf, StdLibs, Errors */

 
/*************************************************************************
*  <<< Dwb_ >>> 
**************************************************************************/

#ifndef USES_PRIORITY_HEADER
/*[START_OF_PRIORITY_HEADER]*/

#define  USES_EXCEPT3
typedef struct _Except3      Except3;
typedef struct _Except3_Try  Except3_Try;
#ifdef  USES_INF
 INF_TYPEDEF( _Except3_MsgStack, Except3_MsgStack );
#endif

#define  STDLIBS_INCLUDE_SETJMP_H

#define  Except3_Err_NoInit       (5282)  /* ĂȂ */
#define  Except3_Err_OutOfTry     (5283)  /* ObZ[W try ubN̊Oɏo */
#define  Except3_Err_TryStackOver (5284)  /* try ubÑX^bNI[o[ */
#define  Except3_Err_DupTry       (5285)  /* catch, finally  try ꂽ */
#define  Except3_Err_FinallyThrow (5286)  /* finally  throw ꂽ */

/*[END_OF_PRIORITY_HEADER]*/
#endif /* USES_PRIORITY_HEADER */


 
/*************************************************************************
*  <<< W[ݒ >>> 
**************************************************************************/
#ifndef  EXCEPT3_SETTING
#define  EXCEPT3_SETTING

  /* #define EXCEPT3_NO_EXIT_CHK */ /* ُIɌn`FbNsȂ */

#endif

#ifdef  ERRORS_NO_EXIT_CHK
  #define  EXCEPT3_NO_EXIT_CHK
#endif


 
/*-----------------------------------------------------------------*/
/* <<< Interface Area ---------------------------------------- >>> */ 
/*-----------------------------------------------------------------*/

#ifdef __cplusplus
extern "C" {
#endif

 
/*************************************************************************
*  <<< [Except3] \tgEFAOR >>> 
*y⑫z
*E{NX try, catch, throw ȂǂKXgp܂B
*Emain ֐̍ŏie^XÑX^[gAbvj Except3_init 
*  sĂB
*EExcept3_Try::bNoJumpAreaTop ́AOWvȂ̈̃gbv
*  try ubNǂłB
**************************************************************************/

void  Except3_init( Except3_Try* trys, int trys_size );
/* void  Except3_initEasy( errName ); */
/* EXCEPT3_DECLARE_EASY_ERROR_HANDLER( errName ); */
/* c_try {} */
/* c_catch( type, arg ) {} */
/* c_finally {} */
/* c_end_finally; */
/* c_throw( void* ); */
/* c_throw_again(); */
/* c_if_error { } c_then { } c_endif; */
void  Except3_startNoJumpArea(void);
void  Except3_endNoJumpArea(void);
bool  Except3_isNoJumpArea(void);
bool  Except3_isError(void);
bool  Except3_isDblError(void);
int   Except3_getErrorCode(void);
void  Except3_print(void);


#define  Except3_m        3     /* VXei^XNj */

struct _Except3 {
  void*    msg;            /* G[bZ[W̃AhX */
  bool     bExcept;        /* Oǂ */
  bool     bAgain;         /* ăX[(finally)ǂ */
  bool     bCatch;         /* Lb`ǂ */
  bool     bNoJumpArea;    /* OWvȂ̈ǂ */
  int      nTry;           /* try ubÑlXg */
  int      mTry;           /* try ubÑlXg̍ő */
  Except3_Try*   tryInfo;  /* tryInfo ̃̈ */
  ERRORS_INITCHK_VAR
};
struct _Except3_Try {
  jmp_buf  longjmp_buf;  /* OEWv */
  bool     bNoJumpAreaTop;  /* ⑫ */
  char*    file;     /* try ubNJnt@C */
  int      line;     /* try ubNJnsԍ */
};


#ifdef  USES_MULTASK
  extern  Except3  Except3_con[Except3_m];
#else
  extern  Except3  Except3_con;
#endif

/* p */
void  Except3_init_imp( Except3*, Except3_Try*, int );
void  Except3_try_imp( Except3*, char* file, int line );
int   Except3_catch_imp( Except3* );
void  Except3_end_finally_imp( Except3* );
void  Except3_throw_imp( Except3*, void* );
void  Except3_startNoJumpArea_imp( Except3* );
void  Except3_endNoJumpArea_imp( Except3* );
bool  Except3_isNoJumpArea_imp( Except3* );
bool  Except3_isError_imp( Except3* );
void  Except3_print_imp( Except3* );
void  Except3_error_imp( int code, const char* msg, char* file, int line );

 
/*************************************************************************
*  <<< [Except3_MsgStack] bZ[WEX^bNی^ >>> 
**************************************************************************/
#ifdef  USES_INF
void*  Except3_MsgStack_push( Except3_MsgStack, void* msg );
void*  Except3_MsgStack_pop( Except3_MsgStack, void* msg );

struct _Except3_MsgStack_Sc {
  void*  (*push)( void* obj, void* elem );
  void*  (*pop)( void* obj, void* elem );
};

#ifdef  NDEBUG
#define  Except3_MsgStack_push(t,a)  INF_MACRO_1( Except3_MsgStack, push, void*, Except3_MsgStack_push, Except3_MsgStack,void*,t,a )
#define  Except3_MsgStack_pop(t,a)  INF_MACRO_1( Except3_MsgStack, pop, void*, Except3_MsgStack_pop, Except3_MsgStack, int, char*,t,a )
#endif

#endif
 
#ifdef __cplusplus
}
#endif

/*-----------------------------------------------------------------*/
/* <<< Mapping Area ------------------------------------------ >>> */ 
/*-----------------------------------------------------------------*/


 
/*--------------------------------------------------------------------*/
/* <<<(Except3) OVXe >>> */ 
/*--------------------------------------------------------------------*/
 
/*************************************************************************
*  <<< [Except3_init] OVXȅ >>> 
**************************************************************************/
#ifdef  USES_MULTASK

  #define  Except3_init( tryInfo, tryInfo_size )  \
    Except3_init_imp( &Except3_con[MulTask_Sys_getCurIndex()], \
      tryInfo, tryInfo_size )

#else

  #define  Except3_init( tryInfo, tryInfo_size )  \
    Except3_init_imp( &Except3_con, \
      tryInfo, tryInfo_size )

#endif


 
/***********************************************************************
*  <<< [Except3_initEasy] ȈՓIɗOVXe >>> 
*yz
*  EerrName;   G[nh̖O
*y⑫z
*EvO̊JnɌĂяoĂB
*Etry ̐[͌ŒłBςƂ Except3_init gpĂB
*EerrName Ɏw肷G[nh́AEXCEPT3_DECLARE_EASY_ERROR_HANDLER
*  gĊȈՓIɒ`邱Ƃł܂B
************************************************************************/
#define  Except3_initEasy( errName ) \
 { \
  static Errors_Msg  msgs[5]; \
  static Except3_Try  trys[10]; \
 \
  Errors_MsgPool_init( Errors_MsgPool_getGlobl(), msgs, sizeof(msgs) ); \
  Except3_init( trys, sizeof(trys) ); \
  Errors_setErrorHandler( errName ); \
 }
 
/***********************************************************************
*  <<< [EXCEPT3_DECLARE_EASY_ERROR_HANDLER] ȈՃG[nh` >>> 
*yz
*  EerrName;   G[nh̖O
*y⑫z
*EO[öɎ̂悤ȋLqƁAerr ƂG[nh炪`܂B
*  EXCEPT3_EASY_ERROR_HANDLER( err )      iZ~R͖j
************************************************************************/
#define  EXCEPT3_DECLARE_EASY_ERROR_HANDLER( errName ) \
 int  errName( int id, int code, char* msg ) \
 { \
  if ( code != Errors_ASSERT && code != Except3_Err_OutOfTry ) \
    c_throw( Errors_Msg_getGlobl() ); \
 \
  id, msg;  \
 \
  return  ERRORS_EXIT; \
 }

 
/*************************************************************************
*  <<< [EXCEPT3_INITCHK] Except3 p`FbN >>> 
*y⑫z
*EpłB
**************************************************************************/
#ifdef  NDEBUG
  #define  EXCEPT3_INITCHK( this )
#else
  #define  EXCEPT3_INITCHK( this ) \
    if ( (this)->__initchk.var != ERRORS_INITCHK_MAGIC( &(this)->__initchk, \
        (this)->__initchk.order, (this)->__initchk.key, \
        (this)->__initchk.count ) ) { \
      char msg[256]; \
      sprintf( msg, "%s(%d)  c_try Ă΂܂ Except3 Ă܂", \
        __FILE__, __LINE__ ); \
      Except3_error( Except3_Err_NoInit, msg ); \
    }
#endif

 
/*************************************************************************
*  <<< [Except3_error] OVXëُI >>> 
**************************************************************************/
#define  Except3_error( code, msg ) \
  Except3_error_imp( code, msg, __FILE__, __LINE__ )

 
/*************************************************************************
*  <<< [Except3_getGlobl] VXë̃AhXԂ >>> 
**************************************************************************/
#ifdef  USES_MULTASK
  #define  Except3_getGlobl()  (&Except3_con[MulTask_Sys_getCurIndex()])
#else
  #define  Except3_getGlobl()  (&Except3_con)
#endif

 
/*************************************************************************
*  <<< [c_try] try ubN >>> 
*y⑫z
*ẼubN̓ŗOAcatch ubNic_catchj
*  Wv܂Bu\O̓Tvv
**************************************************************************/
#ifdef  USES_MULTASK

  #define  c_try  \
    EXCEPT3_INITCHK( &Except3_con[MulTask_Sys_getCurIndex()] ); \
    if ( setjmp( Except3_con[MulTask_Sys_getCurIndex()]. \
         tryInfo[Except3_con.nTry].longjmp_buf ) == 0 ) { \
      Except3_try_imp( &Except3_con[MulTask_Sys_getCurIndex()], \
      __FILE__, __LINE__ ); {

#else

  #define  c_try  \
    EXCEPT3_INITCHK( &Except3_con ); \
    if ( setjmp( Except3_con.tryInfo[Except3_con.nTry].longjmp_buf ) == 0 ) { \
      Except3_try_imp( &Except3_con, __FILE__, __LINE__ ); {

#endif


 
/*************************************************************************
*  <<< [c_catch, c_end_catch] catch ubN >>> 
*y⑫z
*Etry ubNic_tryj̓ŗOÃubN
*  Wv܂Bu\O̓Tvv
*Emsg ɂ́Athrow ƂɎw肵AhXi[A
*  w肵 type ^i|C^^jɂȂ܂B
*Ecatch ubŇɂ́Ac_end_catch  finally ubNLqĂB
*Ecatch ubN break  return  goto gȂłB
*y⑫z
*Etype ɂ́AʏAErrors_Msg* ^w肵܂B
**************************************************************************/
#ifdef  USES_MULTASK

  #define  c_catch( type, arg )  \
    } } else if ( Except3_catch_imp( &Except3_con[MulTask_Sys_getCurIndex()] ) ) \
    {  type arg = (type)Except3_con.msg; \
    {

  #define  c_end_catch \
    c_finally {} c_end_finally

#else

  #define  c_catch( type, arg )  \
    } } else if ( Except3_catch_imp( &Except3_con ) ) \
    {  type arg = (type)Except3_con.msg; \
    {

  #define  c_end_catch \
    c_finally {} c_end_finally

#endif


 
/*************************************************************************
*  <<< [c_finally, c_end_finally] finally ubN >>> 
*y⑫z
*Ecatch ubŇɋLqĂB
*Efinally ubN̏I end_finally LqĂB
*Efinally ubN̓ŗO𔭐Ă\܂񂪁A
*  G[bZ[W㏑\̂ŒӂĂB
*  return  break ɂĔƂ͖̓mFłB
*yz
* c_finally {
*   if ( obj != NULL )   Obj_finish( obj );
*   if ( err )  error();
* } c_end_finally;
**************************************************************************/
#define   c_finally  \
  } } \
  {


#ifdef  USES_MULTASK

  #define  c_end_finally  \
    } \
    Except3_end_finally_imp( &Except3_con[MulTask_Sys_getCurIndex()] );

#else

  #define  c_end_finally  \
    } \
    Except3_end_finally_imp( &Except3_con );

#endif

 
/*************************************************************************
*  <<< [c_throw, c_throw_again] O𓊂 >>> 
*yz
*  Evoid*  msg;   G[bZ[Wicatch ցj
*y⑫z
*Emsg ɂ́AʏAErrors_Msg* ^w肵܂B
*EOVXe msg QƂĂԂ́Acatch ubN
*  ɗOI܂łłB
**************************************************************************/
#ifdef  USES_MULTASK

  #define  c_throw( msg ) \
    Except3_throw_imp( &Except3_con[MulTask_Sys_getCurIndex()], msg )

  #define  c_throw_again() \
    Except3_throw_imp( &Except3_con[MulTask_Sys_getCurIndex()], \
      Except3_con[MulTask_Sys_getCurIndex()].msg )

#else

  #define  c_throw( msg ) \
    Except3_throw_imp( &Except3_con, msg )

  #define  c_throw_again() \
    Except3_throw_imp( &Except3_con, Except3_con.msg )

#endif


 
/*************************************************************************
*  <<< [c_if_error, c_then, c_endif] G[mFX^C >>> 
*yz
*  Evoid*  msg;   G[bZ[Wicatch ցj
*y⑫z
*EuG[mFX^Cł̗Ov͂̕QƁB
**************************************************************************/
#define  c_if_error   c_try
#define  c_then       c_catch( Errors_Msg*, err )
#define  c_endif      c_end_catch

 
/*************************************************************************
*  <<< [Except3_startNoJumpArea] OWvȂ̈Jn >>> 
**************************************************************************/
#ifdef  USES_MULTASK

  #define  Except3_startNoJumpArea() \
    Except3_startNoJumpArea_imp( &Except3_con[MulTask_Sys_getCurIndex()] )

#else

  #define  Except3_startNoJumpArea() \
    Except3_startNoJumpArea_imp( &Except3_con )

#endif
 
/*************************************************************************
*  <<< [Except3_endNoJumpArea] OWvȂ̈I >>> 
**************************************************************************/
#ifdef  USES_MULTASK

  #define  Except3_endNoJumpArea() \
    Except3_endNoJumpArea_imp( &Except3_con[MulTask_Sys_getCurIndex()] )

#else

  #define  Except3_endNoJumpArea() \
    Except3_endNoJumpArea_imp( &Except3_con )

#endif
 
/*************************************************************************
*  <<< [Except3_isNoJumpArea] OWvȂ̈悩ǂԂ >>> 
*y⑫z
*EExcept3_startNoJumpArea ̓܂́Ac_try ̊OȂ true Ԃ܂B
**************************************************************************/
#ifdef  USES_MULTASK

  #define  Except3_isNoJumpArea() \
    Except3_isNoJumpArea_imp( &Except3_con[MulTask_Sys_getCurIndex()] )

#else

  #define  Except3_isNoJumpArea() \
    Except3_isNoJumpArea_imp( &Except3_con )

#endif
 
/*************************************************************************
*  <<< [Except3_isError] OĂ邩ǂԂ >>> 
*y⑫z
*EOiŔƁAÕG[bZ[W㏑ďĂ܂
*  Ƃ̂ŁA{}Ngpď㏑Ȃ悤ɂĂB
**************************************************************************/
#ifdef  USES_MULTASK

  #define  Except3_isError() \
    Except3_isError_imp( &Except3_con[MulTask_Sys_getCurIndex()] )

#else

  #define  Except3_isError() \
    Except3_isError_imp( &Except3_con )

#endif

 
/*************************************************************************
*  <<< [Except3_isDblError] OdɔǂԂ >>> 
*y⑫z
*EOdɔƂ́A̗ÕbZ[Wx
*  X^bNĂƂłB
*EOdɔꍇAɗO邱Ƃł܂B
*  ȂȂ悤ɃvOHvĂB
*Ecatch ubN finally ubN ̒ try ubNŗO
*  ĂAɑΉ catch ubNŗO΁A
*  dɗOƂɂ͂Ȃ܂BȀꍇA
*  O݂uԂ̂ŃG[bZ[W͈ꎞI
*  X^bNɊi[Kv܂B
**************************************************************************/
#ifdef  USES_MULTASK

  #define  Except3_isDblError() \
    Except3_con[MulTask_Sys_getCurIndex()].bDblError

#else

  #define  Except3_isDblError() \
    Except3_con.bDblError

#endif

 
/*************************************************************************
*  <<< [Except3_print] OVXȅԂfobO\ >>> 
**************************************************************************/
#ifdef  USES_MULTASK

  #define  Except3_print() \
    Except3_print_imp( &Except3_con[MulTask_Sys_getCurIndex()], \
      MulTask_Sys_getCurIndex() )

#else

  #define  Except3_print() \
    Except3_print_imp( &Except3_con )

#endif

 
/*--------------------------------------------------------------------*/
/* <<<(Except3_MsgMng) G[bZ[W̊Ǘ >>> */ 
/*--------------------------------------------------------------------*/

 
/*************************************************************************
*  <<< [Except3_MsgStack_push] bZ[WvbV >>> 
*yz
*  Evoid*  msg;     vbV郁bZ[W
*  Evoid*  Ԃl;  Ɏgp郁bZ[W̋L̈̃AhX
*y⑫z
*Ethrow ƂɌĂяo܂B
*EʏAG[bZ[Wi[Ă throw ̂ŁÃ݂G[
*  bZ[W̃Rs[炩߃vbVĂ܂B
**************************************************************************/

 
/*************************************************************************
*  <<< [Except3_MsgStack_pop] bZ[W|bv >>> 
*yz
*  Evoid*  msg;     gpIL̈̃AhX
*  Evoid*  Ԃl;  Ɏgp郁bZ[W̋L̈̃AhX
*y⑫z
*Ecatch ubNiG[jIƂɌĂяo܂B
*E|bvG[bZ[W݂̃G[bZ[Wɐݒ肵āA
*  Ԃlɂ܂B
**************************************************************************/

 
#endif /* __EXCEPT3_H */ 
 
