/**************************************************************************
*  <<< C^[tFCX (Inf) >>> 
***************************************************************************/

#ifndef  __INF_H
#define  __INF_H

/*----------------------------------------------------------------------
[Module Property]
name = Inf
title = C^[tFCX
category = {^
src =
depend =
priority =
accord =
----------------------------------------------------------------------*/


 
/*************************************************************************
*  <<< [Inf Dwb_, Inf_FinishFunc] >>> 
**************************************************************************/
#ifndef USES_PRIORITY_HEADER
/*[START_OF_PRIORITY_HEADER]*/

#ifndef  USES_INF
#define  USES_INF

#define  INF_TYPEDEF( _Inf, Inf ) \
 \
  typedef struct _Inf##_Sc   Inf##_Sc; \
 \
  typedef struct _Inf { \
    Inf##_Sc*  sc;  /* XL[}̃AhX */ \
    void*  obj;     /* IuWFNg̃AhX */ \
  } Inf; \
  typedef struct _Inf##_Pac { \
    Inf##_Sc*  sc;  /* XL[}̃AhX */ \
    void*  param;   /* TuNXEp[^̃AhX */ \
  } Inf##_Pac

typedef  void (*Inf_FinishFunc)( void* );

typedef  struct _Inf_Mp  Inf_Mp;

#endif

/*[END_OF_PRIORITY_HEADER]*/
#endif

 
/*************************************************************************
*  <<< G[R[h >>> 
**************************************************************************/
#define  Inf_Err_WrongNumOfParam  5419
 
/*-------------------------------------------------------------------*/
/* <<< C^[tFCX >>> */ 
/*-------------------------------------------------------------------*/

 
/***********************************************************************
*  <<< [Inf_init] C^[tFCXE|C^̏ >>> 
*y⑫z
*Evoid  Inf_init( Inf*, void* obj, void* sc );
*E{֐̂݁AInf ^́u|C^vɎ܂B
************************************************************************/
#define  Inf_init( this, _obj, _sc ) \
  ( (this)->obj = (_obj), (this)->sc = (_sc) )

 
/***********************************************************************
*  <<< [INF_TYPEDEF] C^[tFCX^錾 >>> 
*yz
*  E_Inf;  \̂̃^O
*  EInf;   C^[tFCX̌^
*y⑫z
*EO[ö INF_TYPEDEF( _Inf, Inf ); ̂悤ɐ錾邱ƂŁA
*  Inf ^̃C^[tFCXi|C^j錾ł܂B
*ÉAInf Dwb_ɂ܂B
*EC^[tFCXEXL[}́Aʓr錾Kv܂B
*  hLǵuC^[tFCX̃TvvQlB
************************************************************************/
 
/***********************************************************************
*  <<< [INF_MACRO_0, INF_MACRO_1] C^[tFCXE}N̒` >>> 
*  <<< [INF_MACRO_2, INF_MACRO_3, INF_MACRO_4, INF_MACRO_5] >>>
*  <<< [INF_MACRO_6, INF_MACRO_7] >>>
*yz
*  EInf;    C^[tFCX̌^
*  Emethod; ֐|C^
*  Etype;   Ԃľ^
*  Efunc;   o֐
*  EthisT;  ̌^
*  EargtX;  ̌^
*  Et,a,b..;  i t,a,b... ̂܂܎w肵܂j
*y⑫z
*EC^[tFCX̃wb_t@C̃O[ö #define ̒ɏ܂B
*  ÁAt n܂Aa,b,c,d,... ƑĂB
*EINF_FUNC_0 ȂǂƓ@\Ȃ̂ŁA}Nŏ򂷂ȂǂāA
*  ǂ炩̂ݎgp܂B
*E}Nłɂ́AiAhXj̃G[`FbN܂B
*EL Inf_Sample Q
*yz
*  #ifdef  NDEBUG
*  #define  InfType_method1(t)     INF_MACRO_0( InfType, method1, int, InfType_method1, InfType,t )
*  #define  InfType_method2(t,a,b) INF_MACRO_2( InfType, method2, void, InfType_method2, InfType, int, char*,t,a,b )
*  #define  InfType_method3(t,a)   INF_MACRO_1( InfType, method2, void, InfType_method3, InfType, int,t,a )
*  #endif
************************************************************************/
#define  INF_MACRO_R0  INF_MACRO_0
#define  INF_MACRO_0( Inf, method, type, func, thisT,t ) \
  ((Inf##_Sc*)(t).sc)->method( (t).obj )
#define  INF_MACRO_SR0( Inf, method, type, func, thisScT, t ) \
  ((t)->method( t )) \

#define  INF_MACRO_R1  INF_MACRO_1
#define  INF_MACRO_1( Inf, method, type, func, thist, argt1,t,a ) \
  ((Inf##_Sc*)(t).sc)->method( (t).obj, a )
#define  INF_MACRO_SR1( Inf, method, type, func, thisScT, arg1T, t,a ) \
  ((t)->method(t, a))
#define  INF_MACRO_PR1( Inf, method, type, func, thisScT, arg1T, t,a ) \
  ((t).sc->method( t,a ))

#define  INF_MACRO_R2  INF_MACRO_2
#define  INF_MACRO_2( Inf, method, type, func, thist, argt1, argt2,t,a,b ) \
  ((Inf##_Sc*)(t).sc)->method( (t).obj, a, b )
#define  INF_MACRO_SR2( Inf, method, type, func, thisScT, arg1T, arg2T, t,a,b ) \
  ((t)->method(t, a,b))
#define  INF_MACRO_PR2( Inf, method, type, func, thisScT, arg1T, arg2T, t,a,b ) \
  ((t).sc->method( t,a,b ))

#define  INF_MACRO_R3  INF_MACRO_3
#define  INF_MACRO_3( Inf, method, type, func, thist, argt1, argt2, argt3,t,a,b,c ) \
  ((Inf##_Sc*)(t).sc)->method( (t).obj, a, b, c )
#define  INF_MACRO_SR3( Inf, method, type, func, thisScT, arg1T, arg2T, arg3T, t,a,b,c ) \
  ((t)->method(t, a,b,c))
#define  INF_MACRO_PR3( Inf, method, type, func, thisScT, arg1T, arg2T, arg3T, t,a,b,c ) \
  ((t).sc->method( t,a,b,c ))

#define  INF_MACRO_R4  INF_MACRO_4
#define  INF_MACRO_4( Inf, method, type, func, thist, argt1, argt2, argt3, argt4,t,a,b,c,d ) \
  ((Inf##_Sc*)(t).sc)->method( (t).obj, a, b, c, d )
#define  INF_MACRO_SR4( Inf, method, type, func, thisScT, arg1T, arg2T, arg3T, arg4T, t,a,b,c,d ) \
  ((t)->method(t, a,b,c,d))
#define  INF_MACRO_PR4( Inf, method, type, func, thisScT, arg1T, arg2T, arg3T, arg4T, t,a,b,c,d ) \
  ((t).sc->method( t,a,b,c,d ))

#define  INF_MACRO_R5  INF_MACRO_5
#define  INF_MACRO_5( Inf, method, type, func, thist, argt1, argt2, argt3, argt4, argt5,t,a,b,c,d,e ) \
  ((Inf##_Sc*)(t).sc)->method( (t).obj, a, b, c, d, e )
#define  INF_MACRO_SR5( Inf, method, type, func, thisScT, arg1T, arg2T, arg3T, arg4T, arg5T, t,a,b,c,d,e ) \
  ((t)->method(t, a,b,c,d,e))
#define  INF_MACRO_PR5( Inf, method, type, func, thisScT, arg1T, arg2T, arg3T, arg4T, arg5T, t,a,b,c,d,e ) \
  ((t).sc->method( t,a,b,c,d,e ))

#define  INF_MACRO_R6  INF_MACRO_6
#define  INF_MACRO_6( Inf, method, type, func, thist, argt1, argt2, argt3, argt4, argt5, arg6, t,a,b,c,d,e,f ) \
  ((Inf##_Sc*)(t).sc)->method( (t).obj, a, b, c, d, e, f )
#define  INF_MACRO_SR6( Inf, method, type, func, thisScT, arg1T, arg2T, arg3T, arg4T, arg5T, arg6T, t,a,b,c,d,e,f ) \
  ((t)->method(t, a,b,c,d,e,f))
#define  INF_MACRO_PR6( Inf, method, type, func, thisScT, arg1T, arg2T, arg3T, arg4T, arg5T, arg6T, t,a,b,c,d,e,f ) \
  ((t).sc->method( t,a,b,c,d,e,f ))

#define  INF_MACRO_R7  INF_MACRO_7
#define  INF_MACRO_7( Inf, method, type, func, thisT, argT1, argT2, argT3, argT4, argT5, argT6, argT7, t,a,b,c,d,e,f,g ) \
  ((Inf##_Sc*)(t).sc)->method( (t).obj, a, b, c, d, e, f, g )
#define  INF_MACRO_SR7( Inf, method, type, func, thisScT, arg1T, arg2T, arg3T, arg4T, arg5T, arg6T, arg7T, t,a,b,c,d,e,f,g ) \
  ((t)->method(t, a,b,c,d,e,f,g))
#define  INF_MACRO_PR7( Inf, method, type, func, thisScT, arg1T, arg2T, arg3T, arg4T, arg5T, arg6T, arg7T, t,a,b,c,d,e,f,g ) \
  ((t).sc->method( t,a,b,c,d,e,f,g ))


 
/***********************************************************************
*  <<< [INF_FUNC_0, INF_FUNC_1] C^[tFCX֐̒` >>> 
*  <<< [INF_FUNC_2, INF_FUNC_3, INF_FUNC_4, INF_FUNC_5] >>>
*  <<< [INF_FUNC_6, INF_FUNC_7] >>>
*  <<< [INF_FUNC_R0, INF_FUNC_R1, INF_FUNC_R2, INF_FUNC_R3] >>>
*  <<< [INF_FUNC_R4, INF_FUNC_R5, INF_FUNC_R6, INF_FUNC_R7] >>>
*  <<< [INF_FUNC_SR0, INF_FUNC_SR1, INF_FUNC_SR2, INF_FUNC_SR3] >>>
*  <<< [INF_FUNC_SR4, INF_FUNC_SR5, INF_FUNC_SR6, INF_FUNC_SR7] >>>
*  <<< [INF_FUNC_PR0, INF_FUNC_PR1, INF_FUNC_PR2, INF_FUNC_PR3] >>>
*  <<< [INF_FUNC_PR4, INF_FUNC_PR5, INF_FUNC_PR6, INF_FUNC_PR7] >>>
*yz
*  EInf;    C^[tFCX̌^
*  Emethod; ֐|C^
*  Etype;   Ԃľ^
*  Efunc;   o֐
*  EthisT;  ̌^
*  EargtX;  ̌^
*  EthisScT;  XL[}ւ̃|C^^A܂ Inf_Pac ^
*y⑫z
*EC^[tFCX̃\[Xt@C(*.c)̃O[öɏ܂B
*EINF_MACRO_0 ȂǂƓ@\Ȃ̂ŁA}Nŏ򂷂ȂǂāA
*  ǂ炩̂ݎgp܂B
*E֐ɕԂlꍇAINF_FUNC_R0 Ȃǂgp܂B(R=Return)
*EԐ̂悤ɑPXL[}̏ꍇ INF_FUNC_SR0
*  Ȃǂgp܂B(SR=Schema and Return)
*EPATuNXEp[^ɑΉp^CYhENX
*  ̏ꍇ́AINF_FUNC_PR0 Ȃǂgp܂B(PR=Paramatorized class and Return)
*E֐ł́AAhX̃G[`FbNs܂B
*  G[̏ꍇAINF_SUB_SC_METHOD_NULL ɂāA
*  C^[tFCXsCvgENX̊֐`ĂȂA
*  C^[tFCXĂȂ\܂B
************************************************************************/
#define  INF_FUNC_0( Inf, method, type, func, thisT, t ) \
  type  func( thisT self ) \
  { \
    ASSERT( self.sc != NULL ); \
    ASSERT( self.sc->method != NULL ); \
    ((Inf##_Sc*)self.sc)->method( self.obj ); \
  }

#define  INF_FUNC_1( Inf, method, type, func, thisT,arg1T, t,a ) \
  type  func( thisT self, arg1T arg1 ) \
  { \
    ASSERT( self.sc != NULL ); \
    ASSERT( self.sc->method != NULL ); \
    ((Inf##_Sc*)self.sc)->method( self.obj, arg1 ); \
  }

#define  INF_FUNC_2( Inf, method, type, func, thisT,arg1T,arg2T, t,a,b ) \
  type  func( thisT self, arg1T arg1, arg2T arg2 ) \
  { \
    ASSERT( self.sc != NULL ); \
    ASSERT( self.sc->method != NULL ); \
    ((Inf##_Sc*)self.sc)->method( self.obj, arg1, arg2 ); \
  }

#define  INF_FUNC_3( Inf, method, type, func, thisT,arg1T,arg2T,arg3T, t,a,b,c ) \
  type  func( thisT self, arg1T arg1, arg2T arg2, arg3T arg3 ) \
  { \
    ASSERT( self.sc != NULL ); \
    ASSERT( self.sc->method != NULL ); \
    ((Inf##_Sc*)self.sc)->method( self.obj, arg1, arg2, arg3 ); \
  }

#define  INF_FUNC_4( Inf, method, type, func, thisT,arg1T,arg2T,arg3T,arg4T, t,a,b,c,d ) \
  type  func( thisT self, arg1T arg1, arg2T arg2, arg3T arg3, arg4T arg4 ) \
  { \
    ASSERT( self.sc != NULL ); \
    ASSERT( self.sc->method != NULL ); \
    ((Inf##_Sc*)self.sc)->method( self.obj, arg1, arg2, arg3, arg4 ); \
  }

#define  INF_FUNC_5( Inf, method, type, func, thisT,arg1T,arg2T,arg3T,arg4T,arg5T, t,a,b,c,d,e ) \
  type  func( thisT self, arg1T arg1, arg2T arg2, arg3T arg3, arg4T arg4, arg5T arg5 ) \
  { \
    ASSERT( self.sc != NULL ); \
    ASSERT( self.sc->method != NULL ); \
    ((Inf##_Sc*)self.sc)->method( self.obj, arg1, arg2, arg3, arg4, arg5 ); \
  }

#define  INF_FUNC_6( Inf, method, type, func, thisT,arg1T,arg2T,arg3T,arg4T,arg5T,arg6T, t,a,b,c,d,e,f ) \
  type  func( thisT self, arg1T arg1, arg2T arg2, arg3T arg3, arg4T arg4, arg5T arg5, arg6T arg6 ) \
  { \
    ASSERT( self.sc != NULL ); \
    ASSERT( self.sc->method != NULL ); \
    ((Inf##_Sc*)self.sc)->method( self.obj, arg1, arg2, arg3, arg4, arg5, arg6 ); \
  }

#define  INF_FUNC_7( Inf, method, type, func, thisT,arg1T,arg2T,arg3T,arg4T,arg5T,arg6T,arg7T, t,a,b,c,d,e,f,g ) \
  type  func( thisT self, arg1T arg1, arg2T arg2, arg3T arg3, arg4T arg4, arg5T arg5, arg6T arg6, arg7T arg7 ) \
  { \
    ASSERT( self.sc != NULL ); \
    ASSERT( self.sc->method != NULL ); \
    ((Inf##_Sc*)self.sc)->method( self.obj, arg1, arg2, arg3, arg4, arg5, arg6, arg7 ); \
  }

#define  INF_FUNC_R0( Inf, method, type, func, thisT, t ) \
  type  func( thisT self ) \
  { \
    ASSERT( self.sc != NULL ); \
    ASSERT( self.sc->method != NULL ); \
    return  ((Inf##_Sc*)self.sc)->method( self.obj ); \
  }

#define  INF_FUNC_R1( Inf, method, type, func, thisT, arg1T, t,a ) \
  type  func( thisT self, arg1T arg1 ) \
  { \
    ASSERT( self.sc != NULL ); \
    ASSERT( self.sc->method != NULL ); \
    return  ((Inf##_Sc*)self.sc)->method( self.obj, arg1 ); \
  }

#define  INF_FUNC_R2( Inf, method, type, func, thisT, arg1T, arg2T, t,a,b ) \
  type  func( thisT self, arg1T arg1, arg2T arg2 ) \
  { \
    ASSERT( self.sc != NULL ); \
    ASSERT( self.sc->method != NULL ); \
    return  ((Inf##_Sc*)self.sc)->method( self.obj, arg1, arg2 ); \
  }

#define  INF_FUNC_R3( Inf, method, type, func, thisT,arg1T,arg2T,arg3T, t,a,b,c ) \
  type  func( thisT self, arg1T arg1, arg2T arg2, arg3T arg3 ) \
  { \
    ASSERT( self.sc != NULL ); \
    ASSERT( self.sc->method != NULL ); \
    return  ((Inf##_Sc*)self.sc)->method( self.obj, arg1, arg2, arg3 ); \
  }

#define  INF_FUNC_R4( Inf, method, type, func, thisT,arg1T,arg2T,arg3T,arg4T, t,a,b,c,d ) \
  type  func( thisT self, arg1T arg1, arg2T arg2, arg3T arg3, arg4T arg4 ) \
  { \
    ASSERT( self.sc != NULL ); \
    ASSERT( self.sc->method != NULL ); \
    return  ((Inf##_Sc*)self.sc)->method( self.obj, arg1, arg2, arg3, arg4 ); \
  }

#define  INF_FUNC_R5( Inf, method, type, func, thisT,arg1T,arg2T,arg3T,arg4T,arg5T, t,a,b,c,d,e ) \
  type  func( thisT self, arg1T arg1, arg2T arg2, arg3T arg3, arg4T arg4, arg5T arg5 ) \
  { \
    ASSERT( self.sc != NULL ); \
    ASSERT( self.sc->method != NULL ); \
    return  ((Inf##_Sc*)self.sc)->method( self.obj, arg1, arg2, arg3, arg4, arg5 ); \
  }

#define  INF_FUNC_R6( Inf, method, type, func, thisT,arg1T,arg2T,arg3T,arg4T,arg5T,arg6T, t,a,b,c,d,e,f ) \
  type  func( thisT self, arg1T arg1, arg2T arg2, arg3T arg3, arg4T arg4, arg5T arg5, arg6T arg6 ) \
  { \
    ASSERT( self.sc != NULL ); \
    ASSERT( self.sc->method != NULL ); \
    return  ((Inf##_Sc*)self.sc)->method( self.obj, arg1, arg2, arg3, arg4, arg5, arg6 ); \
  }

#define  INF_FUNC_R7( Inf, method, type, func, thisT,arg1T,arg2T,arg3T,arg4T,arg5T,arg6T,arg7T, t,a,b,c,d,e,f,g ) \
  type  func( thisT self, arg1T arg1, arg2T arg2, arg3T arg3, arg4T arg4, arg5T arg5, arg6T arg6, arg7T arg7 ) \
  { \
    ASSERT( self.sc != NULL ); \
    ASSERT( self.sc->method != NULL ); \
    return  ((Inf##_Sc*)self.sc)->method( self.obj, arg1, arg2, arg3, arg4, arg5, arg6, arg7 ); \
  }


#define  INF_FUNC_SR0( Inf, method, type, func, thisScT, t ) \
  type  func( thisScT self ) \
  { \
    ASSERT( self != NULL ); \
    ASSERT( self->method != NULL ); \
    return  self->method( self ); \
  }

#define  INF_FUNC_SR1( Inf, method, type, func, thisScT, arg1T, t,a ) \
  type  func( thisScT self, arg1T arg1 ) \
  { \
    ASSERT( self != NULL ); \
    ASSERT( self->method != NULL ); \
    return  self->method(self, arg1); \
  }

#define  INF_FUNC_SR2( Inf, method, type, func, thisScT, arg1T, arg2T, t,a,b ) \
  type  func( thisScT self, arg1T arg1, arg2T arg2 ) \
  { \
    ASSERT( self != NULL ); \
    ASSERT( self->method != NULL ); \
    return  self->method(self, arg1, arg2); \
  }

#define  INF_FUNC_SR3( Inf, method, type, func, thisScT, arg1T, arg2T, arg3T, t,a,b,c ) \
  type  func( thisScT self, arg1T arg1, arg2T arg2, arg3T arg3 ) \
  { \
    ASSERT( self != NULL ); \
    ASSERT( self->method != NULL ); \
    return  self->method(self, arg1, arg2, arg3); \
  }

#define  INF_FUNC_SR4( Inf, method, type, func, thisScT, arg1T, arg2T, arg3T, arg4T, t,a,b,c,d ) \
  type  func( thisScT self, arg1T arg1, arg2T arg2, arg3T arg3, arg4T arg4 ) \
  { \
    ASSERT( self != NULL ); \
    ASSERT( self->method != NULL ); \
    return  self->method(self, arg1, arg2, arg3, arg4); \
  }

#define  INF_FUNC_SR5( Inf, method, type, func, thisScT, arg1T, arg2T, arg3T, arg4T, arg5T, t,a,b,c,d,e ) \
  type  func( thisScT self, arg1T arg1, arg2T arg2, arg3T arg3, arg4T arg4, arg5T arg5 ) \
  { \
    ASSERT( self != NULL ); \
    ASSERT( self->method != NULL ); \
    return  self->method(self, arg1, arg2, arg3, arg4, arg5); \
  }

#define  INF_FUNC_SR6( Inf, method, type, func, thisScT, arg1T, arg2T, arg3T, arg4T, arg5T, arg6T, t,a,b,c,d,e,f ) \
  type  func( thisScT self, arg1T arg1, arg2T arg2, arg3T arg3, arg4T arg4, arg5T arg5, arg6T arg6 ) \
  { \
    ASSERT( self != NULL ); \
    ASSERT( self->method != NULL ); \
    return  self->method(self, arg1, arg2, arg3, arg4, arg5, arg6); \
  }

#define  INF_FUNC_SR7( Inf, method, type, func, thisScT, arg1T, arg2T, arg3T, arg4T, arg5T, arg6T, arg7T, t,a,b,c,d,e,f,g ) \
  type  func( thisScT self, arg1T arg1, arg2T arg2, arg3T arg3, arg4T arg4, arg5T arg5, arg6T arg6, arg7T arg7 ) \
  { \
    ASSERT( self != NULL ); \
    ASSERT( self->method != NULL ); \
    return  self->method(self, arg1, arg2, arg3, arg4, arg5, arg6, arg7); \
  }


#define  INF_FUNC_PR1( Inf, method, type, func, thisScT, arg1T, t,a ) \
  type  func( thisScT self, arg1T arg1 ) \
  { \
    ASSERT( self.sc->method != NULL ); \
    return  self.sc->method( self, arg1 ); \
  }

#define  INF_FUNC_PR2( Inf, method, type, func, thisScT, arg1T, arg2T, t,a,b ) \
  type  func( thisScT self, arg1T arg1, arg2T arg2 ) \
  { \
    ASSERT(self.sc->method != NULL ); \
    return self.sc->method(self, arg1, arg2); \
  }

#define  INF_FUNC_PR3( Inf, method, type, func, thisScT, arg1T, arg2T, arg3T, t,a,b,c ) \
  type  func( thisScT self, arg1T arg1, arg2T arg2, arg3T arg3 ) \
  { \
    ASSERT(self.sc->method != NULL ); \
    return self.sc->method(self, arg1, arg2, arg3); \
  }

#define  INF_FUNC_PR4( Inf, method, type, func, thisScT, arg1T, arg2T, arg3T, arg4T, t,a,b,c,d ) \
  type  func( thisScT self, arg1T arg1, arg2T arg2, arg3T arg3, arg4T arg4 ) \
  { \
    ASSERT(self.sc->method != NULL ); \
    return self.sc->method(self, arg1, arg2, arg3, arg4); \
  }

#define  INF_FUNC_PR5( Inf, method, type, func, thisScT, arg1T, arg2T, arg3T, arg4T, arg5T, t,a,b,c,d,e ) \
  type  func( thisScT self, arg1T arg1, arg2T arg2, arg3T arg3, arg4T arg4, arg5T arg5 ) \
  { \
    ASSERT(self.sc->method != NULL ); \
    return self.sc->method(self, arg1, arg2, arg3, arg4, arg5); \
  }

#define  INF_FUNC_PR6( Inf, method, type, func, thisScT, arg1T, arg2T, arg3T, arg4T, arg5T, arg6T, t,a,b,c,d,e,f ) \
  type  func( thisScT self, arg1T arg1, arg2T arg2, arg3T arg3, arg4T arg4, arg5T arg5, arg6T arg6 ) \
  { \
    ASSERT(self.sc->method != NULL ); \
    return self.sc->method(self, arg1, arg2, arg3, arg4, arg5, arg6); \
  }

#define  INF_FUNC_PR7( Inf, method, type, func, thisScT, arg1T, arg2T, arg3T, arg4T, arg5T, arg6T, arg7T, t,a,b,c,d,e,f,g ) \
  type  func( thisScT self, arg1T arg1, arg2T arg2, arg3T arg3, arg4T arg4, arg5T arg5, arg6T arg6, arg7T arg7 ) \
  { \
    ASSERT(self.sc->method != NULL ); \
    return self.sc->method(self, arg1, arg2, arg3, arg4, arg5, arg6, arg7); \
  }
 
/*-------------------------------------------------------------------*/
/* <<< CvgENX >>> */ 
/*-------------------------------------------------------------------*/
 
/***********************************************************************
*  <<< [INF_SUB_FUNC_START] CvgENX̊֐`̊Jn >>> 
*  <<< [INF_SUB_FUNC_END] CvgENX̊֐`̏I >>>
*  <<< [INF_SUB_FUNC_OVERRIDE] ֘Ap >>>
*  <<< [INF_SUB_FUNC_NULL] C^[tFCXƊ֐֘AtȂ >>>
*  <<< [INF_SUB_FUNC_0] C^[tFCXƊ֐̊֘A̋LqiO̊֐j>>>
*  <<< [INF_SUB_FUNC_1, INF_SUB_FUNC_2, INF_SUB_FUNC_3] >>>
*  <<< [INF_SUB_FUNC_4, INF_SUB_FUNC_5, INF_SUB_FUNC_6, INF_SUB_FUNC_7] >>>
*  <<< [INF_SUB_FUNC_R0, INF_SUB_FUNC_R1, INF_SUB_FUNC_R2, INF_SUB_FUNC_R3] >>>
*  <<< [INF_SUB_FUNC_R4, INF_SUB_FUNC_R5, INF_SUB_FUNC_R6, INF_SUB_FUNC_R7] >>>
*  <<< [INF_SUB_FUNC_SR0, INF_SUB_FUNC_SR1, INF_SUB_FUNC_SR2, INF_SUB_FUNC_SR3] >>>
*  <<< [INF_SUB_FUNC_SR4, INF_SUB_FUNC_SR5, INF_SUB_FUNC_SR6, INF_SUB_FUNC_SR7] >>>
*  <<< [INF_SUB_FUNC_PR0, INF_SUB_FUNC_PR1, INF_SUB_FUNC_PR2, INF_SUB_FUNC_PR3] >>>
*  <<< [INF_SUB_FUNC_PR4, INF_SUB_FUNC_PR5, INF_SUB_FUNC_PR6, INF_SUB_FUNC_PR7] >>>
*yz
*  EInf;    C^[tFCX̌^
*  ESub;    CvgENX̌^
*  Emethod; ֐|C^
*  Etype;   Ԃľ^
*  Efunc;   o֐
*  EthisT;  ̌^
*  EargTX;  ̌^
*y⑫z
*Ẽ}NɂāAȉ̂̂`܂B
*  ECvgENX̃XL[}EO[o\
*     Inf_Sc  Sub_sc_Inf;
*  ECvgENX̃XL[}Ԃ֐
*     Inf_Sc*  Sub_getSc_Inf_Sc(void);
*  ECvgENX̐擪AhXC^[tFCXԂ֐
*     Inf  Sub_inf_Inf( SubType* );
*  EC^[tFCXCvgENX̐擪AhXԂ֐
*     Sub*  Sub_by_Inf( Inf inf );
*EINF_SUB_FUNC_OVERRIDE ́ÃC^[tFCX݂̍̂
*  LqƂɎgp܂BINF_SUB_FUNC_START ̒ɋLq܂B
*  ̌ɁACvg̊֐قȂ֐̂݁AINF_SUB_FUNC_...
*  }NLq܂B
*EINF_SUB_FUNC_R0 Ȃǖ̐̑O
*  R tĂ}ŃAԂlԂC^[tFCXɎgp܂B
*  SR tĂ}ŃAPXL[}̃C^[tFCXɎgp܂B
*EINF_SUB_FUNC_NULL Ŏw肵C^[tFCX́ÃC^[tFCX
*  IɎĂ֐|C^ NULL ɂ܂BfobOo[Wł́A
*  ̃C^[tFCXpĂяosƁAASSERT ɂ܂B
*EINF_SUB_FUNC_... ́A֐̓ŋLq邱Ƃł܂B
*  INF_SUB_FUNC_... vZXʂƁAXL[}̃oϐ̒lω܂B
*  XL[}Ԃ֐(getSc)𗬗pāAꕔI[o[ChƂɎg܂B
*ENDEBUG }N`ĂȂꍇAG[`FbN܂B
*  G[̏ꍇAC^[tFCXwĂCvgENXA
*  ŵ̂ƈقȂ邩AC^[tFCXĂȂ
*  \܂B
************************************************************************/
#define  INF_SUB_FUNC_START( Inf, Sub ) \
  Inf##_Sc  Sub##_sc_##Inf; \
 \
  Inf##_Sc*  Sub##_getSc_##Inf##_Sc() \
  { \
    static int  initialized = 0; \
    if ( ! initialized ) {


#define  INF_SUB_FUNC_END( Inf, Sub ) \
      initialized = 1; \
    } \
    return  &Sub##_sc_##Inf; \
  } \
 \
  Sub*  Sub##_by_##Inf( Inf inf )  /* Sub  typedef ĂȂƂŃG[ */ \
  { \
    ASSERT( inf.sc == &Sub##_sc_##Inf ); \
    return  (Sub*)inf.obj; \
  } \
 \
  Inf  Sub##_inf_##Inf( Sub* self ) \
  { \
    Inf  inf; \
  \
    inf.sc = Sub##_getSc_##Inf##_Sc(); \
    inf.obj = self; \
    return  inf; \
  }


#define  INF_SUB_FUNC_OVERRIDE( Inf, Sub, Super ) \
      Sub##_sc_##Inf = *Super##_getSc_##Inf##_Sc();

#define  INF_SUB_FUNC_NULL( Inf, Sub, method ) \
      Sub##_sc_##Inf.method = NULL;

#define  INF_SUB_FUNC_R0  INF_SUB_FUNC_0
#define  INF_SUB_FUNC_0( Inf, Sub, method, type, func, thisT, t ) \
      Sub##_sc_##Inf.method = (type(*)(void*)) func;
#define  INF_SUB_FUNC_SR0( Inf, Sub, method, type, func, thisT, t ) \
      Sub##_sc_##Inf.method = (type(*)(thisT)) func;
#define  INF_SUB_FUNC_PR0  INF_SUB_FUNC_SR0

#define  INF_SUB_FUNC_R1  INF_SUB_FUNC_1
#define  INF_SUB_FUNC_1( Inf, Sub, method, type, func, thisT, argT1, t,a ) \
      Sub##_sc_##Inf.method = (type(*)(void*,argT1)) func;
#define  INF_SUB_FUNC_SR1( Inf, Sub, method, type, func, thisT, argT1, t,a ) \
      Sub##_sc_##Inf.method = (type(*)(thisT,argT1)) func;
#define  INF_SUB_FUNC_PR1  INF_SUB_FUNC_SR1

#define  INF_SUB_FUNC_R2  INF_SUB_FUNC_2
#define  INF_SUB_FUNC_2( Inf, Sub, method, type, func, thisT, argT1, argT2, t,a,b ) \
      Sub##_sc_##Inf.method = (type(*)(void*,argT1,argT2)) func;
#define  INF_SUB_FUNC_SR2( Inf, Sub, method, type, func, thisT, argT1, argT2, t,a,b ) \
      Sub##_sc_##Inf.method = (type(*)(thisT,argT1,argT2)) func;
#define  INF_SUB_FUNC_PR2  INF_SUB_FUNC_SR2

#define  INF_SUB_FUNC_R3  INF_SUB_FUNC_3
#define  INF_SUB_FUNC_3( Inf, Sub, method, type, func, thisT, argT1, argT2, argT3, t,a,b,c ) \
      Sub##_sc_##Inf.method = (type(*)(void*,argT1,argT2,argT3)) func;
#define  INF_SUB_FUNC_SR3( Inf, Sub, method, type, func, thisT, argT1, argT2, argT3, t,a,b,c ) \
      Sub##_sc_##Inf.method = (type(*)(thisT,argT1,argT2,argT3)) func;
#define  INF_SUB_FUNC_PR3  INF_SUB_FUNC_SR3

#define  INF_SUB_FUNC_R4  INF_SUB_FUNC_4
#define  INF_SUB_FUNC_4( Inf, Sub, method, type, func, thisT, argT1, argT2, argT3, argT4, t,a,b,c,d ) \
      Sub##_sc_##Inf.method = (type(*)(void*,argT1,argT2,argT3,argT4)) func;
#define  INF_SUB_FUNC_SR4( Inf, Sub, method, type, func, thisT, argT1, argT2, argT3, argT4, t,a,b,c,d ) \
      Sub##_sc_##Inf.method = (type(*)(thisT,argT1,argT2,argT3,argT4)) func;
#define  INF_SUB_FUNC_PR4  INF_SUB_FUNC_SR4

#define  INF_SUB_FUNC_R5  INF_SUB_FUNC_5
#define  INF_SUB_FUNC_5( Inf, Sub, method, type, func, thisT, argT1, argT2, argT3, argT4, argT5, t,a,b,c,d,e ) \
      Sub##_sc_##Inf.method = (type(*)(void*,argT1,argT2,argT3,argT4,argT5)) func;
#define  INF_SUB_FUNC_SR5( Inf, Sub, method, type, func, thisT, argT1, argT2, argT3, argT4, argT5, t,a,b,c,d,e ) \
      Sub##_sc_##Inf.method = (type(*)(thisT,argT1,argT2,argT3,argT4,argT5)) func;
#define  INF_SUB_FUNC_PR5  INF_SUB_FUNC_SR5

#define  INF_SUB_FUNC_R6  INF_SUB_FUNC_6
#define  INF_SUB_FUNC_6( Inf, Sub, method, type, func, thisT, argT1, argT2, argT3, argT4, argT5, argT6, t,a,b,c,d,e,f ) \
      Sub##_sc_##Inf.method = (type(*)(void*,argT1,argT2,argT3,argT4,argT5,argT6)) func;
#define  INF_SUB_FUNC_SR6( Inf, Sub, method, type, func, thisT, argT1, argT2, argT3, argT4, argT5, argT6, t,a,b,c,d,e,f ) \
      Sub##_sc_##Inf.method = (type(*)(thisT,argT1,argT2,argT3,argT4,argT5,argT6)) func;
#define  INF_SUB_FUNC_PR6  INF_SUB_FUNC_SR6

#define  INF_SUB_FUNC_R7  INF_SUB_FUNC_7
#define  INF_SUB_FUNC_7( Inf, Sub, method, type, func, thisT, argT1, argT2, argT3, argT4, argT5, argT6, argT7, t,a,b,c,d,e,f,g ) \
      Sub##_sc_##Inf.method = (type(*)(void*,argT1,argT2,argT3,argT4,argT5,argT6,argT7)) func;
#define  INF_SUB_FUNC_SR7( Inf, Sub, method, type, func, thisT, argT1, argT2, argT3, argT4, argT5, argT6, argT7, t,a,b,c,d,e,f,g ) \
      Sub##_sc_##Inf.method = (type(*)(thisT,argT1,argT2,argT3,argT4,argT5,argT6,argT7)) func;
#define  INF_SUB_FUNC_PR7  INF_SUB_FUNC_SR7


 
/***********************************************************************
*  <<< [INF_SUB_PACFUNC1] Inf_Pac Ԃ֐̒` >>> 
*  <<< [INF_SUB_PACFUNC2] [INF_SUB_PACFUNC3] [INF_SUB_PACFUNC4]  >>>
*  <<< [INF_SUB_PACFUNC4] [INF_SUB_PACFUNC6] [INF_SUB_PACFUNC7]  >>>
*yz
*  EInf;    C^[tFCX̌^
*  ESub;    CvgENX̌^
*  EparamT;  TuNXEp[^ ̍\̖AiTuNXj{ _Param
*  EargTX;  ̌^
*  Ea,b,c... ;  \̂̃oϐ
*y⑫z
*E{}ŃAINF_SUB_FUNC_END ɐ錾܂B
*Ẽ}NɂāAȉ̊֐`܂B
*     Inf_Pac  Sub_getPac_Inf( Sub_Param*, ... );
************************************************************************/

#define  INF_SUB_PACFUNC1( Inf, Sub, paramT, argT1, a ) \
 Inf##_Pac  Sub##_getPac_##Inf( paramT param, argT1 a ) \
 { \
  Inf##_Pac  pac; \
 \
  pac.sc = Sub##_getSc_##Inf##_Sc(); \
  pac.param = param; \
  param->a = a; \
 \
  return  pac; \
}


#define  INF_SUB_PACFUNC2( Inf, Sub, paramT, argT1, a, argT2, b ) \
 Inf##_Pac  Sub##_getPac_##Inf( paramT param, argT1 a, argT2 b ) \
 { \
  Inf##_Pac  pac; \
 \
  pac.sc = Sub##_getSc_##Inf##_Sc(); \
  pac.param = param; \
  param->a = a; \
  param->b = b; \
 \
  return  pac; \
}


#define  INF_SUB_PACFUNC3( Inf, Sub, paramT, argT1, a, argT2, b, argT3, c ) \
 Inf##_Pac  Sub##_getPac_##Inf( paramT param, argT1 a, argT2 b, argT3 c ) \
 { \
  Inf##_Pac  pac; \
 \
  pac.sc = Sub##_getSc_##Inf##_Sc(); \
  pac.param = param; \
  param->a = a; \
  param->b = b; \
  param->c = c; \
 \
  return  pac; \
}


#define  INF_SUB_PACFUNC4( Inf, Sub, paramT, argT1, a, argT2, b, argT3, c, argT4, d ) \
 Inf##_Pac  Sub##_getPac_##Inf( paramT param, argT1 a, argT2 b, argT3 c, argT4 d ) \
 { \
  Inf##_Pac  pac; \
 \
  pac.sc = Sub##_getSc_##Inf##_Sc(); \
  pac.param = param; \
  param->a = a; \
  param->b = b; \
  param->c = c; \
  param->d = d; \
 \
  return  pac; \
}


#define  INF_SUB_PACFUNC5( Inf, Sub, paramT, argT1, a, argT2, b, argT3, c, argT4, d, argT5, e ) \
 Inf##_Pac  Sub##_getPac_##Inf( paramT param, argT1 a, argT2 b, argT3 c, argT4 d, argT5 e ) \
 { \
  Inf##_Pac  pac; \
 \
  pac.sc = Sub##_getSc_##Inf##_Sc(); \
  pac.param = param; \
  param->a = a; \
  param->b = b; \
  param->c = c; \
  param->d = d; \
  param->e = e; \
 \
  return  pac; \
}


#define  INF_SUB_PACFUNC6( Inf, Sub, paramT, argT1, a, argT2, b, argT3, c, argT4, d, argT5, e, argT6, f ) \
 Inf##_Pac  Sub##_getPac_##Inf( paramT param, argT1 a, argT2 b, argT3 c, argT4 d, argT5 e, argT6 f ) \
 { \
  Inf##_Pac  pac; \
 \
  pac.sc = Sub##_getSc_##Inf##_Sc(); \
  pac.param = param; \
  param->a = a; \
  param->b = b; \
  param->c = c; \
  param->d = d; \
  param->e = e; \
  param->f = f; \
 \
  return  pac; \
}


#define  INF_SUB_PACFUNC7( Inf, Sub, paramT, argT1, a, argT2, b, argT3, c, argT4, d, argT5, e, argT6, f, argT7, g ) \
 Inf##_Pac  Sub##_getPac_##Inf( paramT* param, argT1 a, argT2 b, argT3 c, argT4 d, argT5 e, argT6 f, argT7 g ) \
 { \
  Inf##_Pac  pac; \
 \
  pac.sc = Sub##_getSc_##Inf##_Sc(); \
  pac.param = param; \
  param->a = a; \
  param->b = b; \
  param->c = c; \
  param->d = d; \
  param->e = e; \
  param->f = f; \
  param->g = g; \
 \
  return  pac; \
}


 
/*-------------------------------------------------------------------*/
/* <<< \bhE|C^ >>> */ 
/*-------------------------------------------------------------------*/
 
/***********************************************************************
*  <<< [Inf_Mp] \bhE|C^ >>> 
************************************************************************/
struct _Inf_Mp {
  void*  obj;
  int  (*func)();
  #ifndef  NDEBUG
    int  nArg;
  #endif
};

#ifdef  NDEBUG

#define  Inf_Mp_init( this, _obj, _func, _nArg ) \
  ( (this)->obj = _obj, (this)->func = _func )

#define  Inf_Mp_call0( this ) \
  ( *(this)->func )( (this)->obj )

#define  Inf_Mp_call1( this, a ) \
  ( *(this)->func )( (this)->obj, a )

#define  Inf_Mp_call2( this, a,b ) \
  ( *(this)->func )( (this)->obj, a,b )

#define  Inf_Mp_call3( this, a,b,c ) \
  ( *(this)->func )( (this)->obj, a,b,c )

#define  Inf_Mp_call4( this, a,b,c,d ) \
  ( *(this)->func )( (this)->obj, a,b,c,d )

#define  Inf_Mp_call5( this, a,b,c,d,e ) \
  ( *(this)->func )( (this)->obj, a,b,c,d,e )

#define  Inf_Mp_call6( this, a,b,c,d,e,f ) \
  ( *(this)->func )( (this)->obj, a,b,c,d,e,f )

#define  Inf_Mp_call7( this, a,b,c,d,e,f,g ) \
  ( *(this)->func )( (this)->obj, a,b,c,d,e,f,g )

#else

#define  Inf_Mp_init( this, _obj, _func, _nArg ) \
  ( (this)->obj = _obj, (this)->func = _func, (this)->nArg = _nArg )

#define  Inf_Mp_call0( this ) \
  ( (this)->nArg == 0 ? (*(this)->func)( (this)->obj ) : \
     error2_1( Inf_Err_WrongNumOfParam, "p[^̐Ⴂ܂(%d)", (this)->nArg ) , 0 )

#define  Inf_Mp_call1( this, a ) \
  ( (this)->nArg == 1 ? (*(this)->func)( (this)->obj, a ) : \
     error2_1( Inf_Err_WrongNumOfParam, "p[^̐Ⴂ܂(%d)", (this)->nArg ) , 0 )

#define  Inf_Mp_call2( this, a,b ) \
  ( (this)->nArg == 2 ? (*(this)->func)( (this)->obj, a,b ) : \
     error2_1( Inf_Err_WrongNumOfParam, "p[^̐Ⴂ܂(%d)", (this)->nArg ) , 0 )

#define  Inf_Mp_call3( this, a,b,c ) \
  ( (this)->nArg == 3 ? (*(this)->func)( (this)->obj, a,b,c ) : \
     error2_1( Inf_Err_WrongNumOfParam, "p[^̐Ⴂ܂(%d)", (this)->nArg ) , 0 )

#define  Inf_Mp_call4( this, a,b,c,d ) \
  ( (this)->nArg == 4 ? (*(this)->func)( (this)->obj, a,b,c,d ) : \
     error2_1( Inf_Err_WrongNumOfParam, "p[^̐Ⴂ܂(%d)", (this)->nArg ) , 0 )

#define  Inf_Mp_call5( this, a,b,c,d,e ) \
  ( (this)->nArg == 5 ? (*(this)->func)( (this)->obj, a,b,c,d,e ) : \
     error2_1( Inf_Err_WrongNumOfParam, "p[^̐Ⴂ܂(%d)", (this)->nArg ) , 0 )

#define  Inf_Mp_call6( this, a,b,c,d,e,f ) \
  ( (this)->nArg == 6 ? (*(this)->func)( (this)->obj, a,b,c,d,e,f ) : \
     error2_1( Inf_Err_WrongNumOfParam, "p[^̐Ⴂ܂(%d)", (this)->nArg ) , 0 )

#define  Inf_Mp_call7( this, a,b,c,d,e,f,g ) \
  ( (this)->nArg == 7 ? (*(this)->func)( (this)->obj, a,b,c,d,e,f,g ) : \
     error2_1( Inf_Err_WrongNumOfParam, "p[^̐Ⴂ܂(%d)", (this)->nArg ) , 0 )

#endif
 
#endif  /* __INF_H */ 
 
