/**************************************************************************
*  <<< WCuEW[ [StdLibs] >>> 
*y⑫z
*EǵAstdlibs.htm QƁB
***************************************************************************/

#ifndef __STDLIBS_H
#define __STRLIBS_H

/*----------------------------------------------------------------------
[Module Property]
name = StdLibs
title = WCuEW[
category = {^
src = stdlibs.c
depend =
priority =
accord =
----------------------------------------------------------------------*/

#ifndef USES_PRIORITY_HEADER
/*[START_OF_PRIORITY_HEADER]*/

#define  USES_STDLIBS

/*[END_OF_PRIORITY_HEADER]*/
#endif /* USES_PRIORITY_HEADER */


 
/**************************************************************************
*  <<< W[ݒ(1): ^[Qbg >>> 
***************************************************************************/

#ifndef  STDLIBS_SETTING

 #ifdef  FOR_NSTD
   #define  STDLIBS_NO_STDLIB  /* RpCt̕WCugpȂ */
 #endif

#define  STDLIBS_SETTING
#endif


 
/**************************************************************************
*  <<< W[ݒ(2): CN[ht@C >>> 
*y⑫z
*ÉAʏA[Jݒɂ܂B
*  icompone.h CN[hOɍs܂j
*EɏĂȂwb_t@ĆA{W[͑ΉĂ܂B
*  ʂ #include ĂB
***************************************************************************/

/* CN[hwb_t@Cɑ #define Lɂ܂ */

 #define  STDLIBS_INCLUDE_MATH_H
 #define  STDLIBS_INCLUDE_LIMITS_H
 #define  STDLIBS_INCLUDE_STDIO_H
 #define  STDLIBS_INCLUDE_STDLIB_H
 #define  STDLIBS_INCLUDE_STRING_H
 #define  STDLIBS_INCLUDE_STDARG_H
 #define  STDLIBS_INCLUDE_SETJMP_H
 #define  STDLIBS_INCLUDE_STDDEF_H

#define  STDLIBS_INCLUDE

 
/*------------------------------------------------------------------------*/
/* <<< Interface Area ----------------------------------------------- >>> */ 
/*------------------------------------------------------------------------*/

#ifdef __cplusplus
extern "C" {
#endif

 
/***********************************************************
*  <<< stddef.h: [size_t] >>> 
************************************************************/

#ifdef  STDLIBS_INCLUDE_STDDEF_H
#ifndef  STDLIBS_CUT_STDDEF_H
#ifndef  __INC_VSTDLIBH

#if !defined(STDLIBS_NO_STDLIB) && !defined(FOR_WINCE)
  #include  <stddef.h>
#else
  typedef  unsigned int  size_t;
  #if  !defined(offsetof)  && !defined(FOR_WINCE)
   #define  offsetof(st,memb)  ((int)(&( ((st*)0)->memb )))
  #endif
#endif

#endif
#endif
#endif


 
/***********************************************************
*  <<< limits.h >>> 
************************************************************/

#ifdef  STDLIBS_INCLUDE_LIMITS_H

#ifndef  STDLIBS_NO_STDLIB
  #include  <limits.h>
#else

/* <<< int ^̍őŏ [INT_MAX, INT_MIN] >>> */
#ifdef  INT_MAX
#undef  INT_MAX
#endif
#ifdef  INT_MIN
#undef  INT_MIN
#endif

#ifdef _16BIT
#define  INT_MAX  0x7FFF
#define  INT_MIN  -0x8000
#endif

#ifdef _32BIT
#define  INT_MAX  0x7FFFFFFF
#ifdef _MSC_VER
#define  INT_MIN  -0x7FFFFFFF    /* VC ̏ꍇAxoĂ܂ioOj */
#else
#ifdef FOR_GHS
#define  INT_MIN  -0x7FFFFFFF    /* GHS ̏ꍇAG[oĂ܂ioOj */
#else
#define  INT_MIN  -0x80000000
#endif /* FOR_GHS */
#endif /* _MSC_VER */
#endif /* _32BIT */


#endif

#endif


 
/***********************************************************
*  <<< math.h >>> 
************************************************************/

#ifdef  STDLIBS_INCLUDE_MATH_H

#ifndef  STDLIBS_NO_STDLIB
#ifndef  FOR_CODEW
  #ifdef  abs
    #undef  abs
  #endif
  #if  defined(WIN32) && defined(__cplusplus)
    }
  #endif
  #include  <math.h>
  #if  defined(WIN32) && defined(__cplusplus)
    extern "C" {
  #endif
#endif

#else

  #define  abs(x)    ((x)>=0 ? x : -(x))
  #define  fabs(x)    ((x)>=0 ? x : -(x))

#endif

#endif


 
/***********************************************************
*  <<< setjmp.h >>> 
************************************************************/

#ifdef  STDLIBS_INCLUDE_SETJMP_H

#ifdef  FOR_CODEW
 #ifndef  USES_LONGJMPS
  #error   need LongJmps Module
 #endif
#endif

#ifndef  STDLIBS_NO_STDLIB
#ifndef  FOR_CODEW
  #include  <setjmp.h>
#endif
#endif

#endif


 
/***********************************************************
*  <<< stdarg.h >>> 
************************************************************/

#ifdef  STDLIBS_INCLUDE_STDARG_H

#ifndef  __INC_VSTDARGH
#ifndef  STDLIBS_NO_STDLIB
  #include  <stdarg.h>
#else
  #ifdef  FOR_GHS
    typedef struct { char *va_list; int va_stkmod7; } va_list;
    #define va_start(ap,lstprm) ((ap).va_list= (char *)&__va_ansiarg, \
       ((ap).va_stkmod7 = (int)__va_stkarg&7))
    #define va_arg(p, mode) ((mode *)((p).va_list = (char *)(((int)(p).va_list +\
        (__va_align(mode)>4?(((p).va_stkmod7 !=((int)(p).va_list&7))*4):0)+ 3) & ~3) + \
        sizeof(mode)))[-1]
    #define  va_end(p)
  #endif
#endif
#endif

#endif


 
/***********************************************************
*  <<< stdio.h >>> 
************************************************************/
#ifdef  STDLIBS_INCLUDE_STDIO_H

#ifndef  STDLIBS_NO_STDLIB
#ifndef  FOR_CODEW
#ifndef  FOR_GNU
#ifndef  __INC_VSTDLIBH
  #include  <stdio.h>
  #ifndef  __STDIO_H
  #define  __STDIO_H
  #endif
#endif
#endif
#endif
#endif

#ifndef  __STDIO_H
  #ifndef  FOR_CODEW
    #define   NULL  ((void*)0)
  #endif
#endif

#endif


 
/***********************************************************
*  <<< stdlib.h >>> 
************************************************************/

#ifdef  STDLIBS_INCLUDE_STDLIB_H

#ifndef  __INC_VSTDLIBH
 #ifndef  STDLIBS_NO_STDLIB
  #ifndef  FOR_CODEW
   #ifndef  FOR_GNU
    #include  <stdlib.h>
    #ifndef  __STDLIB_H
     #define  __STDLIB_H
    #endif
    #ifdef  FOR_WINCE
      #include <windef.h>  /* _MAX_PATH ̎ */
    #endif
   #endif
   #ifdef  FOR_GHS
    #define  _MAX_PATH  260
    #define  _MAX_FNAME 260
   #endif
  #endif
 #else
   #define  abs(x)    ((x)>=0 ? x : -(x))
 #endif
#else
 #define  abs(x)    ((x)>=0 ? x : -(x))
 int  inkey(void);
 int  sdvex_inkey(void);
 #define  inkey  sdvex_inkey
#endif

#endif

 
/***********************************************************
*  <<< string.h >>> 
************************************************************/
#ifdef  STDLIBS_INCLUDE_STRING_H

#ifndef  STDLIBS_NO_STDLIB
#ifndef  FOR_GNU
  #include  <string.h>
  #ifndef  __STRING_H
  #define  __STRING_H
  #endif
  #ifdef  FOR_GHS
    int  stricmp( const char* a, const char* b );
  #endif
#endif
#endif

#endif


 
/***********************************************************
*  <<< time.h >>> 
************************************************************/

#ifdef  STDLIBS_INCLUDE_TIME_H

#ifndef  STDLIBS_NO_STDLIB
#ifndef  FOR_GNU
  #include  <time.h>
  #ifndef  __TIME_H
  #define  __TIME_H
  #endif
#endif
#endif

#endif


 
/*------------------------------------------------------------------------*/
/* <<< Mapping Area ------------------------------------------------- >>> */ 
/*------------------------------------------------------------------------*/


 
#ifdef __cplusplus
}
#endif 

#endif

 
