// nukeyDlg.h : wb_[ t@C 
//

#if !defined(AFX_NUKEYDLG_H__36376099_E1F3_4474_B9E1_6AE32BABCB26__INCLUDED_)
#define AFX_NUKEYDLG_H__36376099_E1F3_4474_B9E1_6AE32BABCB26__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CNukeyDlg _CAO

#include "HrefStatic.h"

#define  Nukey_Time_onInterval    1
#define  Nukey_Time_onLateStart   2
#define  Nukey_Time_onTrayIcon    3
#define  Nukey_Time_onLimit      4

#define  Nukey_dataSize    36  /* L[t@CTCYB '\0'܂܂Ȃ */
#define  Nukey_mKeyFile    30  /* PC̃L[̍ő吔 */
#define  Nukey_mDupKeyFile 10  /* ̍ő吔 */
#define  Nukey_mBmp        10

#define  Nukey_ActiveState    1
#define  Nukey_StoppingState  2

#define  Nukey_SavingBaloon      1
#define  Nukey_DeletingBaloon    2
#define  Nukey_ReatestingBaloon  3


#define  Nukey_Cmd_MakeOverlap  (WM_USER+1)
#define  Nukey_Cmd_ClosedOverlap  (WM_USER+3)
#define  WM_TRAYICONMESSAGE  (WM_USER+4)

DWORD WINAPI  Nukey_lockThread( void* param );
DWORD WINAPI  Nukey_dialogThread( void* param );
void  DrawBitmap( HDC dc, const char* path, RECT* rc, int type );


class CNukeyDlg : public CDialog
{
public:
	HANDLE  m_thread;
	HANDLE  m_overlapSema;
	volatile bool  m_bThreadQuit;
	bool m_bSkipConfirm;

	CString  m_baloonText;
	CString  m_baloonText2;
	CString  m_baloonText3;
	int      m_baloonTime;  /* ~b */
	UINT     m_limitTimer;
	UINT     m_lateStartTimer;
	UINT     m_hideInfoTimer;
	DWORD    m_hideInfoTime;
	int      m_iStartMsg;


	/* L[ */
	HANDLE    m_key_file;
	char      m_key_path[_MAX_PATH];
	char      m_key_data[Nukey_dataSize+1];
	DWORD     m_key_filelen;
	FILETIME  m_key_accessTime;
	bool      m_is_read_only_key;

	char      m_folderPath[_MAX_PATH];  /* nukeytH_pXB\\ n܂Ƃ̓lbg̃pX */

	void  saveSetting();
	bool  MakeKey();
	int   CheckDupKey( WIN32_FILE_ATTRIBUTE_DATA* attr );
	void  addDupKey();
	void  removeDupKey( int iKey );

	void  GetKeyFolderPath( char* path );
	int   GetNKeyFile();


	/* ݒl */
	int  m_drive;
	int  m_ecoTime;
	bool m_noEco;
	int  m_saverTime;
	bool m_noSaver;
	bool m_passwordUnlock;
	int    m_lockSpan;  /* bN܂ł̎() */
	CTime  m_lockTime;  /* bN */

	int      m_lockScreen;
	CString  m_message1;
	CString  m_message2;
	int      m_nBmp;
	CString  m_bmpPath[Nukey_mBmp];
	int      m_bmpDrawType[Nukey_mBmp];  /* 0=, 1=_, 2=^C, 3=ʃTCY */
	DWORD    m_bmpTime[Nukey_mBmp];  /* l̓~bǁA͕bP */
	RECT     m_unlockRect[Nukey_mBmp];
	bool     m_bUseFingerCursor;
	HCURSOR  m_Arrow;
	HCURSOR  m_FingerCursor;


	/* ʒm̈⎩N */
	UINT  m_WM_TaskbarRestart;
	void  AddToTaskTray( int iOverMouseMsg );
	void  ShowInfoInTaskTray( int iBaloonMsg );
	void  DeleteTaskTrayIcon();
	void  LoadAutoRun();
	bool  SaveAutoRun();

	/* ʂPC̉L[ */
	int       m_key2_n;
	char*     m_key2_path[Nukey_mKeyFile];
	DWORD     m_key2_filelen[Nukey_mKeyFile];
	FILETIME  m_key2_accessTime[Nukey_mKeyFile];
	HANDLE    m_dialogThread;
	bool      m_bDialogThread;

	/* ߋɉL[ */
	int       m_oldkey_n;
	char**    m_oldkey_path;

	/* L[ */
	int       m_dupKey_n;
	char      m_dupKey_path[Nukey_mDupKeyFile][_MAX_PATH];
	char      m_dupKey_data[Nukey_mDupKeyFile][Nukey_dataSize+1];
	DWORD     m_dupKey_filelen[Nukey_mDupKeyFile];
	FILETIME  m_dupKey_accessTime[Nukey_mDupKeyFile];


// \z
public:
	CNukeyDlg(CWnd* pParent = NULL);  // W̃RXgN^

// _CAO f[^
	//{{AFX_DATA(CNukeyDlg)
	enum { IDD = IDD_NUKEY_DIALOG };
	CStatic m_Count;
	CSpinButtonCtrl m_ReattestTimeSpin;
	CEdit m_ReattestTime;
	CSpinButtonCtrl m_SaverTimeSpin;
	CSpinButtonCtrl m_EcoTimeSpin;
	CHrefStatic m_Help;
	CHrefStatic m_SecurityInfo;
	CButton m_OK;
	CComboBox m_Drive;
	CEdit m_SaverTime;
	CButton m_NoSaver;
	CButton m_AutoRun;
	CButton m_NoEco;
	CEdit m_EcoTime;
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CNukeyDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);  // DDX/DDV ̃T|[g
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	virtual LRESULT DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Cve[V
protected:
	HICON m_hIcon;

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CNukeyDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnOK();
	afx_msg void OnClose();
	afx_msg void OnNoEco();
	afx_msg void OnChangeDrive();
	afx_msg void OnAutoRun();
	afx_msg void OnNoSaver();
	virtual void OnCancel();
	afx_msg void OnLateStart();
	afx_msg void OnSaverNow();
	afx_msg void OnMakeDupKey();
	afx_msg void OnSelchangeDrive();
	afx_msg void OnCustomize();
	afx_msg void OnEcoNow();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnChangeReattestTime();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_NUKEYDLG_H__36376099_E1F3_4474_B9E1_6AE32BABCB26__INCLUDED_)
 
