// CustomSaverDlg.cpp : Cve[V t@C 
//

#include "stdafx.h"
#include "nukey.h"
#include "compone\include\compone.h"
#include "NukeyDlg.h"
#include "CustomSaverDlg.h"
#include "BmpPropDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCustomSaverDlg _CAO


CCustomSaverDlg::CCustomSaverDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCustomSaverDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCustomSaverDlg)
	m_Message1 = _T("");
	m_Message2 = _T("");
	//}}AFX_DATA_INIT
}


void CCustomSaverDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCustomSaverDlg)
	DDX_Control(pDX, IDC_BmpUp, m_BmpUp);
	DDX_Control(pDX, IDC_BmpDown, m_BmpDown);
	DDX_Control(pDX, IDC_BmpDel, m_BmpDel);
	DDX_Control(pDX, IDC_BmpEdit, m_BmpEdit);
	DDX_Control(pDX, IDC_Preview, m_Preview);
	DDX_Control(pDX, IDC_LogOffCursor, m_LogOffCursor);
	DDX_Control(pDX, IDC_EnableText, m_EnableText);
	DDX_Control(pDX, IDC_EnableBmp, m_EnableBmp);
	DDX_Control(pDX, IDC_BmpList, m_BmpList);
	DDX_Text(pDX, IDC_Message1, m_Message1);
	DDX_Text(pDX, IDC_Message2, m_Message2);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCustomSaverDlg, CDialog)
	//{{AFX_MSG_MAP(CCustomSaverDlg)
	ON_BN_CLICKED(IDC_BmpAdd, OnBmpAdd)
	ON_BN_CLICKED(IDC_BmpEdit, OnBmpEdit)
	ON_BN_CLICKED(IDC_BmpDel, OnBmpDel)
	ON_LBN_SELCHANGE(IDC_BmpList, OnSelchangeBmpList)
	ON_LBN_DBLCLK(IDC_BmpList, OnDblclkBmpList)
	ON_BN_CLICKED(IDC_BmpDown, OnBmpDown)
	ON_BN_CLICKED(IDC_BmpUp, OnBmpUp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCustomSaverDlg bZ[W nh

BOOL CCustomSaverDlg::OnInitDialog()
{
  RECT  rc;

  CDialog::OnInitDialog();

  m_dc = ::GetDC( m_Preview.m_hWnd );
  m_Preview.GetClientRect( &rc );
  m_bmp = CreateCompatibleBitmap( m_dc, rc.right, rc.bottom );

  m_EnableText.SetCheck( m_parent->m_lockScreen == 1 || m_parent->m_lockScreen == 3 );
  m_EnableBmp.SetCheck( m_parent->m_lockScreen == 2 || m_parent->m_lockScreen == 3 );
  m_LogOffCursor.SetCheck( m_parent->m_bUseFingerCursor );

  m_BmpEdit.EnableWindow( FALSE );
  m_BmpDel.EnableWindow( FALSE );
  m_BmpUp.EnableWindow( FALSE );
  m_BmpDown.EnableWindow( FALSE );

  loadBmpList();

  return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CCustomSaverDlg::FinishDialog()
{
  DeleteObject( m_bmp );
  ::ReleaseDC( m_Preview.m_hWnd, m_dc );
}

void  CCustomSaverDlg::loadBmpList()
{
  int  i;
  CNukeyDlg*  p = m_parent;
  CString  s;
  int  iBmp = m_BmpList.GetCurSel();

  m_BmpList.ResetContent();
  for ( i = 0; i < m_parent->m_nBmp; i++ ) {
    s.Format( "%d. %s  (%db)", i+1, StrX_refFName( p->m_bmpPath[i] ), p->m_bmpTime[i]/1000 );
    m_BmpList.AddString( s );
  }

  if ( iBmp < i && iBmp != LB_ERR )  m_BmpList.SetCurSel( iBmp );
}



void CCustomSaverDlg::loadPreview()
{
  CNukeyDlg*  p = m_parent;
  int   i = m_BmpList.GetCurSel();
  char  path2[_MAX_PATH];

  if ( i != LB_ERR )
    StrX_getExeFullPath( path2, p->m_bmpPath[i], sizeof(path2) );
  if ( i != LB_ERR && FileX_isExist( path2 ) ) {
    HDC  bmp_dc = CreateCompatibleDC( m_dc );
    RECT  rc;
    HGDIOBJ  old;
    HBRUSH  brush = CreateSolidBrush( RGB(0,0,0) );

    m_Preview.GetClientRect( &rc );
    old = SelectObject( bmp_dc, m_bmp );
    FillRect( bmp_dc, &rc, brush );
    DrawBitmap( bmp_dc, p->m_bmpPath[i], &rc, p->m_bmpDrawType[i] );
    SelectObject( bmp_dc, old );
    ::DeleteObject( brush );
    ::DeleteDC( bmp_dc );

    m_Preview.SetBitmap( m_bmp );  // bmp_dc Ƃ̊֘A𖳂ĂłȂƃ_݂
  }
}


void CCustomSaverDlg::OnBmpAdd()
{
  CNukeyDlg*  p = m_parent;
  CString  s;
  CBmpPropDlg  dlg;
  int  r;

  if ( p->m_nBmp == Nukey_mBmp ) {
    s.Format( "ȏǉł܂Bő %d܂łłB", Nukey_mBmp );
    MessageBox( s, "nukey security", MB_OK );
    return;
  }

  p->m_bmpPath[ p->m_nBmp ] = "";
  p->m_bmpDrawType[ p->m_nBmp ] = 0;
  p->m_bmpTime[ p->m_nBmp ] = 5000;
  p->m_unlockRect[ p->m_nBmp ].left = 0;
  p->m_unlockRect[ p->m_nBmp ].top = 0;
  p->m_unlockRect[ p->m_nBmp ].right = 1;
  p->m_unlockRect[ p->m_nBmp ].bottom = 1;

  dlg.m_parent = this;
  dlg.m_iBmp = p->m_nBmp;
  r = dlg.DoModal();
  if ( r == IDOK ) {
    p->m_nBmp++;
    m_EnableBmp.SetCheck( TRUE );
  }
  loadBmpList();
  if ( r == IDOK )
    m_BmpList.SetCurSel( p->m_nBmp - 1 );
  loadPreview();
}


void CCustomSaverDlg::OnBmpEdit()
{
  CBmpPropDlg  dlg;

  dlg.m_parent = this;
  dlg.m_iBmp = m_BmpList.GetCurSel();
  if ( dlg.DoModal() == IDOK )
    m_EnableBmp.SetCheck( TRUE );
  loadBmpList();
  loadPreview();
}

void CCustomSaverDlg::OnDblclkBmpList()
{
  OnBmpEdit();
}


void CCustomSaverDlg::OnBmpDel()
{
  CString  s;
  int  i = m_BmpList.GetCurSel();
  CNukeyDlg*  p = m_parent;

  s.Format( "%s \Ȃ悤ɂ܂", StrX_refFName( p->m_bmpPath[i] ) );
  if ( MessageBox( s, "폜̊mF", MB_YESNO ) == IDNO )  return;

  p->m_nBmp --;
  for ( i;  i < p->m_nBmp; i++ ) {
    p->m_bmpPath[i] = p->m_bmpPath[i+1];
    p->m_bmpDrawType[i] = p->m_bmpDrawType[i+1];
    p->m_bmpTime[i] = p->m_bmpTime[i+1];
    p->m_unlockRect[i] = p->m_unlockRect[i+1];
  }
  if ( p->m_nBmp == 0 ) {
    m_EnableBmp.SetCheck( FALSE );
    m_BmpEdit.EnableWindow( FALSE );
    m_BmpDel.EnableWindow( FALSE );
  }
  loadBmpList();
  loadPreview();
}


void CCustomSaverDlg::OnSelchangeBmpList()
{
  CNukeyDlg*  p = m_parent;
  int   i = m_BmpList.GetCurSel();
  BOOL  b = ( i != LB_ERR );

  m_BmpEdit.EnableWindow( b );
  m_BmpDel.EnableWindow( b );

  loadPreview();

  m_BmpUp.EnableWindow( i != 0 && i != LB_ERR );
  m_BmpDown.EnableWindow( i != p->m_nBmp - 1 && i != LB_ERR );
}


void CCustomSaverDlg::OnOK()
{
  m_parent->m_lockScreen = ( m_EnableText.GetCheck() ? 1 : 0 ) +
    ( m_EnableBmp.GetCheck() ? 2 : 0 );
  m_parent->m_bUseFingerCursor = m_LogOffCursor.GetCheck() != 0;

  FinishDialog();
  CDialog::OnOK();
}

void CCustomSaverDlg::OnCancel()
{
  FinishDialog();
  CDialog::OnCancel();
}

void CCustomSaverDlg::OnBmpDown()
{
  CNukeyDlg*  p = m_parent;
  int  i = m_BmpList.GetCurSel();
  CString  path;
  int  type;
  int  time;
  RECT  rc;

  path = p->m_bmpPath[i+1];
  p->m_bmpPath[i+1] = p->m_bmpPath[i];
  p->m_bmpPath[i] = path;

  type = p->m_bmpDrawType[i+1];
  p->m_bmpDrawType[i+1] = p->m_bmpDrawType[i];
  p->m_bmpDrawType[i] = type;

  time = p->m_bmpTime[i+1];
  p->m_bmpTime[i+1] = p->m_bmpTime[i];
  p->m_bmpTime[i] = time;

  rc = p->m_unlockRect[i+1];
  p->m_unlockRect[i+1] = p->m_unlockRect[i];
  p->m_unlockRect[i] = rc;

  m_BmpList.SetCurSel( i+1 );

  if ( i+1 == p->m_nBmp )  m_BmpDown.EnableWindow( FALSE );
  if ( i == 0 )  m_BmpUp.EnableWindow( TRUE );
}

void CCustomSaverDlg::OnBmpUp()
{
  CNukeyDlg*  p = m_parent;
  int  i = m_BmpList.GetCurSel();
  CString  path;
  int  type;
  int  time;
  RECT  rc;

  path = p->m_bmpPath[i-1];
  p->m_bmpPath[i-1] = p->m_bmpPath[i];
  p->m_bmpPath[i] = path;

  type = p->m_bmpDrawType[i-1];
  p->m_bmpDrawType[i-1] = p->m_bmpDrawType[i];
  p->m_bmpDrawType[i] = type;

  time = p->m_bmpTime[i-1];
  p->m_bmpTime[i-1] = p->m_bmpTime[i];
  p->m_bmpTime[i] = time;

  rc = p->m_unlockRect[i-1];
  p->m_unlockRect[i-1] = p->m_unlockRect[i];
  p->m_unlockRect[i] = rc;

  m_BmpList.SetCurSel( i-1 );

  if ( i-1 == 0 )  m_BmpUp.EnableWindow( FALSE );
  if ( i == p->m_nBmp - 1 )  m_BmpDown.EnableWindow( TRUE );
}
 
