#include "stdafx.h"
#include "nukey.h"
#include "nukeyDlg.h"
#include <direct.h>
#include "hook\hook.h"
#include "hook\my-winuser.h"
#include "compone\include\compone.h"
#include "CustomSaverDlg.h"
#include  <locale.h>
#include  <sys/types.h>
#include  <sys/stat.h>

#define  Limit_Default  480
#define  Limit_Min        1
#define  Limit_Max     1440


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

LRESULT CALLBACK  Overlap_WndProc( HWND wnd, UINT msg, WPARAM wparam, LPARAM lparam );
void  StrX_getGUIDStr( GUID* guid, char* uuid_str );
void  StrX_getGUIDFromStr( GUID* guid, char* uuid_str );

bool  WinX_getExeFNameByWild( const char* exe_fname_wild, char* out_exe_fname,
	int out_size );
int   WinX_getAllAppHWnd( HWND* hs, int hs_size, const char* exe_fname );
bool  WinX_getExeFNameOfWnd( HWND wnd, char* exe_fname );
bool  WinX_exitWindowsEx( int flag );

extern HANDLE  g_appSema;

#if 0
#define  error()  error_imp(__FILE__, __LINE__)
void  error_imp( char* file, int line ) {
	char s[256];  sprintf( s, "ERROR in (%d) %s", line, file );
	MessageBox( NULL, s, "", MB_OK );
	exit(3);
}
#endif

int  TimeDate_setDiff( time_t* m, int year, int month, int day,
	int hour, int min, int sec );
int  TimeDate_set( time_t* m, int year, int month, int day,
	int hour, int min, int sec );
void  FileX_getUpdate( const char* fName, time_t* date );


/* tbN͂ckkłKv */
HINSTANCE  g_DLL;
HINSTANCE  LoadHookDLL( const char* dll_folder );
typedef  void  (*StartHook_F)( HWND overlap );
typedef  void  (*StopHook_F)(void);
typedef  int   (*GetAltCtrlDel_F)(void);
StartHook_F     g_StartHook;
StopHook_F  g_StopHook;
GetAltCtrlDel_F  g_GetAltCtrlDel;



/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CHrefStatic m_SageP;
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_SageP, m_SageP);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNukeyDlg _CAO

CNukeyDlg::CNukeyDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNukeyDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNukeyDlg)
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_WM_TaskbarRestart = RegisterWindowMessage( TEXT("TaskbarCreated") );
}

void CNukeyDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNukeyDlg)
	DDX_Control(pDX, IDC_COUNT, m_Count);
	DDX_Control(pDX, IDC_ReattestTimeSpin, m_ReattestTimeSpin);
	DDX_Control(pDX, IDC_ReattestTime, m_ReattestTime);
	DDX_Control(pDX, IDC_SaverTimeSpin, m_SaverTimeSpin);
	DDX_Control(pDX, IDC_EcoTimeSpin, m_EcoTimeSpin);
	DDX_Control(pDX, IDC_Help, m_Help);
	DDX_Control(pDX, IDC_SecurityInfo, m_SecurityInfo);
	DDX_Control(pDX, IDOK, m_OK);
	DDX_Control(pDX, IDC_Drive, m_Drive);
	DDX_Control(pDX, IDC_SaverTime, m_SaverTime);
	DDX_Control(pDX, IDC_NoSaver, m_NoSaver);
	DDX_Control(pDX, IDC_AutoRun, m_AutoRun);
	DDX_Control(pDX, IDC_NoEco, m_NoEco);
	DDX_Control(pDX, IDC_EcoTime, m_EcoTime);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CNukeyDlg, CDialog)
	//{{AFX_MSG_MAP(CNukeyDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_NoEco, OnNoEco)
	ON_EN_CHANGE(IDC_Drive, OnChangeDrive)
	ON_BN_CLICKED(IDC_AutoRun, OnAutoRun)
	ON_BN_CLICKED(IDC_NoSaver, OnNoSaver)
	ON_BN_CLICKED(ID_LateStart, OnLateStart)
	ON_BN_CLICKED(ID_SaverNow, OnSaverNow)
	ON_BN_CLICKED(ID_MakeDupKey, OnMakeDupKey)
	ON_CBN_SELCHANGE(IDC_Drive, OnSelchangeDrive)
	ON_BN_CLICKED(IDC_Customize, OnCustomize)
	ON_BN_CLICKED(ID_EcoNow, OnEcoNow)
	ON_WM_TIMER()
	ON_EN_CHANGE(IDC_ReattestTime, OnChangeReattestTime)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNukeyDlg bZ[W nh


 
void CNukeyDlg::OnSysCommand(UINT nID, LPARAM lParam) 
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CNukeyDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CNukeyDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


 
/***********************************************************************
  <<< [CNukeyDlg::OnInitDialog]  >>> 
************************************************************************/
BOOL CNukeyDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);      // 傫ACRݒ
	//SetIcon(m_hIcon, FALSE);    // ACRݒ

	// TODO: ʂȏs͂̏ꏊɒǉĂB
	static char  module_path[_MAX_PATH];
	GetModuleFileName( AfxGetApp()->m_hInstance, module_path, 255 );
	StrX_argv0 = module_path;
	srand( (unsigned)time( NULL ) );

	#ifdef  NDEBUG
	{
		char  path[_MAX_PATH];

		StrX_getExeFullPath( path, "hook\\Release", sizeof(path) );
		g_DLL = LoadHookDLL( path );
	}
	#else
		g_DLL = LoadHookDLL( "hook\\Debug" );
	#endif

	{
		int  i;

		for ( i = 0; i < Nukey_mKeyFile; i++ )
			m_key2_path[i] = (char*)malloc( _MAX_PATH );

		m_oldkey_n = 0;
		m_oldkey_path = (char**)malloc( sizeof(char*) );  /* ŏ0 realloc ̂ */

		m_dupKey_n = 0;

		m_dialogThread = NULL;
		m_bDialogThread = false;
	}

	m_overlapSema = CreateSemaphore( NULL, 1, 1, NULL );
	m_bSkipConfirm = false;
	m_thread = NULL;
	m_limitTimer = NULL;
	m_lateStartTimer = NULL;
	m_hideInfoTimer = NULL;

	//  m_thread = CreateThread( NULL, 0, Nukey_lockThread, NULL, 0, 0 );
	//  CreateThread ƁAWindows nOAbvB

	//PostMessage( WM_COMMAND, IDOK, 0 );
	// OnCreate PostMessage ƁAWindows nOAbvB

	{
		char  path[_MAX_PATH];

		m_SecurityInfo.SetHref( "http://www.sage-p.com/nukey/" );
		StrX_getExeFullPath( path, "nukey.pdf", sizeof(path) );
		m_Help.SetHref( path );
	}

	{
		IniFile_Read  f;
		char  path[_MAX_PATH];
		char  f_buf[256];
		char  s[256];
		int  i;
		int  ver;

		/* nukey.ini t@Cǂݍ */
		StrX_getExeFullPath( path, "nukey.ini", sizeof(path) );
		if ( FileX_isExist( path ) ) {
			IniFile_Read_init( &f, path, f_buf, sizeof(f_buf) );
			IniFile_Read_setSection( &f, "main" );
			IniFile_Read_getPlusVar( &f, "Version", "i", &ver, 100 );
			IniFile_Read_getVar( &f, "Drive", "s", s );
			m_drive = s[0];  if ( m_drive < 'A' || m_drive > 'Z' )  m_drive = 'E';
			IniFile_Read_getPlusVar( &f, "LimitTime", "i", &m_lockSpan, Limit_Default );
			IniFile_Read_getVar( &f, "EcoTime", "i", &m_ecoTime );
			IniFile_Read_getVar( &f, "NoEco", "b", &m_noEco );
			IniFile_Read_getVar( &f, "SaverTime", "i", &m_saverTime );
			IniFile_Read_getVar( &f, "NoSaver", "b", &m_noSaver );
			IniFile_Read_getVar( &f, "UseFingerCursor", "b", &m_bUseFingerCursor );
			IniFile_Read_getVar( &f, "BaloonText", "s", s );  m_baloonText = s;

			if ( ver == 100 ) {
				IniFile_Read_getVar( &f, "BaloonText2", "s", s );  /* _~[ */
				m_baloonText2 = "USB̊Ď𒆎~܂BL[폜 (30b)";
			}
			else
				{ IniFile_Read_getVar( &f, "BaloonText2", "s", s );  m_baloonText2 = s; }
			IniFile_Read_getPlusVar( &f, "BaloonText3", "s", s, "nukey security bN\" );
			m_baloonText3 = s;
			IniFile_Read_getVar( &f, "BaloonTime", "i", &m_baloonTime );
			IniFile_Read_getVar( &f, "LockScreen", "i", &m_lockScreen );
			IniFile_Read_getVar( &f, "Message1", "s", s );  m_message1 = s;
			IniFile_Read_getVar( &f, "Message2", "s", s );  m_message2 = s;
			m_nBmp = 0;
			for ( i = 0; i < Nukey_mBmp; i++ ) {
				if ( IniFile_Read_getCount( &f, "Bmp" ) == 0 )  break;
				IniFile_Read_getVar( &f, "Bmp", "s", s );  m_bmpPath[i] = s;
				IniFile_Read_getVar( &f, "BmpDrawType", "i", &m_bmpDrawType[i] );
				IniFile_Read_getVar( &f, "UnlockRect", "iiii", &m_unlockRect[i].left,
					&m_unlockRect[i].top, &m_unlockRect[i].right, &m_unlockRect[i].bottom );
				IniFile_Read_getVar( &f, "BmpTime", "i", &m_bmpTime[i] );
				m_nBmp++;
			}
			IniFile_Read_getVar( &f, "FolderPath", "s", m_folderPath );
			IniFile_Read_finish( &f );
		}
		else {
			MessageBox( "nukey security gA肪Ƃ܂B\n"
				"L[ۑtH_[́Anukey security IA"
				"ݒt@C nukey.ini ŕύXł܂B", "nukey security" );

			m_drive = 'E';
			m_lockSpan = Limit_Default;
			m_ecoTime = 5;
			m_noEco = false;
			m_saverTime = 0;
			m_noSaver = true;
			m_bUseFingerCursor = true;
			m_baloonText = "L[ۑ (30b)";
			m_baloonText2 = "USB̊Ď𒆎~܂BL[폜 (30b)";
			m_baloonText3 = "nukey security bN\";
			m_baloonTime = 29000;
			m_lockScreen = 3;
			m_message1 = " PC ́AL҂ USB tbV[}Ǝg悤ɂȂ܂";
			m_message2 = "L[𖳂Ƃ͂NbNăpX[h͂Ă";
			m_nBmp = 4;
			m_bmpPath[0] = "bmp\\CGOB001.bmp";
			m_bmpPath[1] = "bmp\\CTY221.bmp";
			m_bmpPath[2] = "bmp\\TEC051.bmp";
			m_bmpPath[3] = "bmp\\tile.bmp";
			m_bmpDrawType[0] = 0;
			m_bmpDrawType[1] = 0;
			m_bmpDrawType[2] = 1;
			m_bmpDrawType[3] = 2;
			m_bmpTime[0] = 5000;
			m_bmpTime[1] = 5000;
			m_bmpTime[2] = 5000;
			m_bmpTime[3] = 5000;
			m_unlockRect[0] = CRect( 0, 0, 2, 2 );
			m_unlockRect[1] = m_unlockRect[0];
			m_unlockRect[2] = m_unlockRect[0];
			m_unlockRect[3] = m_unlockRect[0];
			strcpy( m_folderPath, "\\nukey" );
		}


		/* EBhEɐݒl𔽉f */
		m_Drive.SetCurSel( m_drive - 'A' );

		m_ReattestTime.LimitText( 4 );
		if ( m_lockSpan < Limit_Min || m_lockSpan > Limit_Max )
			m_lockSpan = Limit_Default;
		sprintf( s, "%d", m_lockSpan );
		m_ReattestTime.SetWindowText( s );
		m_ReattestTimeSpin.SetRange( Limit_Min, Limit_Max );

		m_EcoTime.LimitText( 5 );
		sprintf( s, "%d", m_ecoTime );
		m_EcoTime.SetWindowText( s );
		m_EcoTime.EnableWindow( ! m_noEco );

		m_NoEco.SetCheck( m_noEco );
		m_EcoTimeSpin.SetRange( 0, 9999 );

		m_SaverTime.LimitText( 5 );
		sprintf( s, "%d", m_saverTime );
		m_SaverTime.SetWindowText( s );
		m_SaverTime.EnableWindow( ! m_noSaver );

		m_NoSaver.SetCheck( m_noSaver );
		m_SaverTimeSpin.SetRange( 0, 9999 );

		LoadAutoRun();

		if ( m_folderPath[0] == '\\' && m_folderPath[1] == '\\' ) {
			m_Drive.EnableWindow( FALSE );
			m_AutoRun.EnableWindow( FALSE );
		}

		m_Arrow = LoadCursor( NULL, IDC_ARROW );
		m_FingerCursor = CHrefStatic::GetFingerCursor();
	}

	m_lockTime = CTime::GetCurrentTime() + CTimeSpan( 0, 0, m_lockSpan, 0 );
	m_limitTimer = SetTimer( Nukey_Time_onLimit, 1000, NULL );

	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CNukeyDlg::OnAutoRun()
{
	LONG  ret;
	HKEY  key;

	ret = RegOpenKeyEx( HKEY_CURRENT_USER, "Software\\Microsoft\\Windows\\CurrentVersion\\Policies\\Explorer", 0L, KEY_WRITE | KEY_SET_VALUE , &key );
	if ( ret != ERROR_SUCCESS ) {
		MessageBox( "ύX錠ĂȂ߁AOS狑ۂ܂B", "nukey security", MB_OK );
	m_AutoRun.SetCheck( m_AutoRun.GetCheck() == 0 );
	}
	else
		ret = RegCloseKey( key );
}

void CNukeyDlg::OnNoEco()
{
	m_EcoTime.EnableWindow( m_NoEco.GetCheck() == 0 );
}

void CNukeyDlg::OnNoSaver()
{
	m_SaverTime.EnableWindow( m_NoSaver.GetCheck() == 0 );
}

void CNukeyDlg::OnChangeReattestTime() 
{
	CString  s;
	int  t;

	if ( ! ::IsWindow( m_ReattestTime.m_hWnd ) )   return;

	KillTimer( Nukey_Time_onLimit );

	m_ReattestTime.GetWindowText( s );
	t = atoi( s );
	if ( t < 1 )  t = 1;

	m_lockSpan = t;
	m_lockTime = CTime::GetCurrentTime() + CTimeSpan( 0, 0, t, 0 );
	m_limitTimer = SetTimer( Nukey_Time_onLimit, 1000, NULL );
	s.Format( "%d", t * 60 );
	m_Count.SetWindowText( s );
}


 
/***********************************************************************
  <<< [CNukeyDlg::OnCancel] Bn >>> 
************************************************************************/
void CNukeyDlg::OnCancel()
{
	int  i;

	if ( m_limitTimer != NULL )
		{ KillTimer( Nukey_Time_onLimit );  m_limitTimer = NULL; }

	CloseHandle( m_overlapSema );
	if ( m_thread != NULL )  error();

	if ( m_dialogThread != NULL )  CloseHandle( m_dialogThread );

	for ( i = 0; i < Nukey_mKeyFile; i++ )
		free( m_key2_path[i] );

	for ( i = 0; i < m_oldkey_n; i++ )
		free( m_oldkey_path[i] );
	free( m_oldkey_path );

	ReleaseSemaphore( g_appSema, 1, NULL );
	CloseHandle( g_appSema );

	if ( m_hideInfoTimer != NULL ) {
		ShowWindow( SW_HIDE );
		Sleep( m_hideInfoTime - GetTickCount() );
		DeleteTaskTrayIcon();
	}

	CDialog::OnCancel();
}

void CNukeyDlg::OnClose()
{
	// OnCancel Ɖ̂ɗȂ

	CDialog::OnClose();
}


 
void CNukeyDlg::OnCustomize() 
{
	CCustomSaverDlg  dlg;

	dlg.m_parent = this;
	dlg.m_Message1 = m_message1;
	dlg.m_Message2 = m_message2;

	if ( dlg.DoModal() == IDOK ) {
		m_message1 = dlg.m_Message1;
		m_message2 = dlg.m_Message2;
		saveSetting();
	}
}

 
/***********************************************************************
  <<< [CNukeyDlg::OnLateStart] uŎnv{^Ƃ >>> 
************************************************************************/
extern  HANDLE  g_appSema;

void CNukeyDlg::OnLateStart()
{
	m_OK.SetFocus();  /* ̂̊֐̍Ōł͂܂Ȃ */

	if ( MessageBox( "TɋNEBhEĕ\܂B",
			 "nukey security", MB_OKCANCEL ) == IDOK ) {
		//ReleaseSemaphore( g_appSema, 1, NULL );
		ShowWindow( SW_HIDE );

		m_lateStartTimer = SetTimer( Nukey_Time_onLateStart, 5*60*1000, NULL );
	}
}

void CNukeyDlg::OnTimer( UINT nIDEvent )
{
	switch ( nIDEvent ) {
		case  Nukey_Time_onLimit: {
			CString s;
			CTimeSpan  span;
			int  spanSec;

			span = m_lockTime - CTime::GetCurrentTime();
			spanSec = span.GetTotalSeconds();
			if ( spanSec < 0 )  spanSec = 0;
			s.Format( "%d", spanSec );
			m_Count.SetWindowText( s );
			if ( spanSec <= 0 ) {
				m_bSkipConfirm = true;
				PostMessage( WM_COMMAND, IDOK, NULL );
			}
			if ( spanSec <= 15 ) {
				SetForegroundWindow();
			}
			break;
		}

		case  Nukey_Time_onLateStart:
			if ( m_lateStartTimer != 0 ) {
				ShowWindow( SW_SHOW );
				KillTimer( nIDEvent );
				m_lateStartTimer = 0;
			}
			break;

		case  Nukey_Time_onTrayIcon:
			if ( m_hideInfoTimer != 0 ) {
				DeleteTaskTrayIcon();
				KillTimer( nIDEvent );
				m_hideInfoTimer = 0;
			}
			break;
	}
	CDialog::OnTimer(nIDEvent);
}

 
/***********************************************************************
  <<< [CNukeyDlg::OnSeverNow] XN[Z[o[uvr[v{^Ƃ >>> 
************************************************************************/
void CNukeyDlg::OnSaverNow()
{
	SendMessage( WM_SYSCOMMAND, SC_SCREENSAVE, 0 );
	m_OK.SetFocus();
}


/***********************************************************************
  <<< [CNukeyDlg::OnEcoNow] ȓd́ueXgv{^Ƃ >>>
************************************************************************/
void CNukeyDlg::OnEcoNow()
{
	Sleep(700);
	::PostMessage( HWND_BROADCAST, WM_SYSCOMMAND, SC_MONITORPOWER, 1 );
	Sleep(700);
	::PostMessage( HWND_BROADCAST, WM_SYSCOMMAND, SC_MONITORPOWER, 1 );
	m_OK.SetFocus();
}


 
/***********************************************************************
  <<< [CNukeyDlg::saveSetting] ݒۑ >>> 
************************************************************************/
void CNukeyDlg::saveSetting()
{
	IniFile_Write  f;
	char  path[_MAX_PATH];
	char  s[256];
	int  i;

	StrX_getExeFullPath( path, "nukey.ini", sizeof(path) );
	IniFile_Write_init( &f, path );
	IniFile_Write_putSection( &f, "main" );
	s[0] = m_drive;   s[1] = '\0';
	IniFile_Write_putVar( &f, "Version", "i", 200 );
	IniFile_Write_putVar( &f, "Drive", "s", s );
	IniFile_Write_putVar( &f, "LimitTime", "i", m_lockSpan );
	IniFile_Write_putVar( &f, "EcoTime", "i", m_ecoTime );
	IniFile_Write_putVar( &f, "NoEco", "b", m_noEco );
	IniFile_Write_putVar( &f, "SaverTime", "i", m_saverTime );
	IniFile_Write_putVar( &f, "NoSaver", "b", m_noSaver );
	IniFile_Write_putVar( &f, "UseFingerCursor", "b", m_bUseFingerCursor );
	IniFile_Write_putVar( &f, "BaloonText", "s", (const char*)m_baloonText );
	IniFile_Write_putVar( &f, "BaloonText2", "s", (const char*)m_baloonText2 );
	IniFile_Write_putVar( &f, "BaloonTime", "i", m_baloonTime );
	IniFile_Write_putVar( &f, "LockScreen", "i", m_lockScreen );
	IniFile_Write_putVar( &f, "Message1", "s", m_message1 );
	IniFile_Write_putVar( &f, "Message2", "s", m_message2 );
	for ( i = 0; i < m_nBmp; i++ ) {
		IniFile_Write_putVar( &f, "Bmp", "s", m_bmpPath[i] );
		IniFile_Write_putVar( &f, "BmpDrawType", "i", m_bmpDrawType[i] );
		IniFile_Write_putVar( &f, "UnlockRect", "iiii", m_unlockRect[i].left,
			m_unlockRect[i].top, m_unlockRect[i].right, m_unlockRect[i].bottom );
		IniFile_Write_putVar( &f, "BmpTime", "i", m_bmpTime[i] );
	}
	IniFile_Write_putVar( &f, "FolderPath", "s", m_folderPath );
	IniFile_Write_finish( &f );
}
 
/***********************************************************************
  <<< [CNukeyDlg::OnOK] unv{^Ƃ >>> 
************************************************************************/
void CNukeyDlg::OnOK()
{
	CString  s;
	int  n;

	KillTimer( Nukey_Time_onLimit );
	m_limitTimer = NULL;


	/* ݒEBhE擾āAt@Cɕۑ */
	m_drive = m_Drive.GetCurSel() + 'A';
	if ( m_drive == '\\' )  m_drive = 'E';

	m_ReattestTime.GetWindowText( s );
	n = atoi( s );
	if ( n < Limit_Min || n > Limit_Max ) {
		MessageBox( "pX[hĊmFԂ́A1`1440 ̊Ԃɐݒ肵Ă" );
		#if ! ( Limit_Min == 1 && Limit_Max == 1440 )
		#error
		#endif
		return;
	}
	m_lockSpan = n;

	m_EcoTime.GetWindowText( s );
	m_ecoTime = atoi( s );

	m_SaverTime.GetWindowText( s );
	m_saverTime = atoi( s );

	m_noEco = ( m_NoEco.GetCheck() != 0 );
	m_noSaver = ( m_NoSaver.GetCheck() != 0 );

	saveSetting();


	/* ċN̊mF */
	if ( SaveAutoRun() ) {
		if ( MessageBox( "N̐ݒ́Ap\RċNĂLɂȂ܂B\r\n"
				 "ċN܂H", "nukey security", MB_YESNO ) == IDYES ) {
			if ( WinX_exitWindowsEx( EWX_REBOOT ) )
				PostMessage( WM_COMMAND, IDCANCEL, 0 );
			return;
		}
	}


	/* ĎXbh𐶐 */
	if ( m_thread == NULL ) {
		m_thread = CreateThread( NULL, 0, Nukey_lockThread, this, 0, 0 );
		ShowWindow( SW_HIDE );
	}
}


 
/***********************************************************************
  <<< [CNukeyDlg::DefWindowProc] ^XNgCNbNƂ >>> 
************************************************************************/
LRESULT CNukeyDlg::DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	/* ^XNgCċNƂɁAACRēo^ */
	if ( message == m_WM_TaskbarRestart && m_WM_TaskbarRestart != 0 ) {
		AddToTaskTray( Nukey_ActiveState );
	}

	/* ACRNbNƂAĎ~ */
	if ( message == WM_TRAYICONMESSAGE ) {
		if ( lParam == WM_LBUTTONDOWN || lParam == WM_RBUTTONDOWN ) {
			m_bThreadQuit = true;
			WaitForSingleObject( m_thread, INFINITE );
			SetForegroundWindow();
			// MessageBox( "USBtbV[̊Ď~܂", "nukey security", MB_OK );
				// 񃍃bNԂ̐Ԃ邽߁AJbg
		}
	}

	return CDialog::DefWindowProc(message, wParam, lParam);
}


 
/***********************************************************************
  <<< [CNukeyDlg::AddToTaskTray] ^XNgCiʒm̈jɃACRo^ >>> 
************************************************************************/

#undef   _WIN32_IE
#define  _WIN32_IE  0x0500

typedef struct _NOTIFYICONDATA2 {
		DWORD  cbSize;
		HWND   hWnd;
		UINT   uID;
		UINT   uFlags;
		UINT   uCallbackMessage;
		HICON  hIcon;
#if (_WIN32_IE < 0x0500)
		TCHAR  szTip[64];
#else
		TCHAR  szTip[128];
#endif
#if (_WIN32_IE >= 0x0500)
		DWORD  dwState;
		DWORD  dwStateMask;
		TCHAR  szInfo[256];
		union {
				UINT  uTimeout;
				UINT  uVersion;
		} DUMMYUNIONNAME;
		TCHAR  szInfoTitle[64];
		DWORD  dwInfoFlags;
#endif
#if (_WIN32_IE >= 0x600)
		GUID   guidItem;
#endif
} NOTIFYICONDATA2, *PNOTIFYICONDATA2;

#define  NIF_INFO      0x00000010
#define  NIIF_WARNING  0x00000002
#define  NIIF_NOSOUND  0x00000010
#define  NOTIFYICON_VERSION  3

void CNukeyDlg::AddToTaskTray( int iOverMouseMsg )
{
	NOTIFYICONDATA2  notif;

	notif.cbSize = sizeof(NOTIFYICONDATA2);
	notif.hWnd = m_hWnd;
	notif.uID = 0;
	notif.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
	notif.uCallbackMessage = WM_TRAYICONMESSAGE;
	notif.hIcon = m_hIcon;
	switch ( iOverMouseMsg ) {
		case  Nukey_ActiveState:
			strcpy( notif.szTip, "nukey security ғ" );
			break;
		case  Nukey_StoppingState:
			strcpy( notif.szTip, "nukey security ~" );
			break;
	}
	Shell_NotifyIcon( NIM_ADD, (PNOTIFYICONDATA)&notif );
}


void CNukeyDlg::ShowInfoInTaskTray( int iBaloonMsg )
{
	NOTIFYICONDATA2  notif;

	notif.cbSize = sizeof(NOTIFYICONDATA2);
	notif.hWnd = m_hWnd;
	notif.uID = 0;
	notif.uFlags = NIF_INFO;

	strcpy( notif.szInfoTitle, "nukey security" );
	notif.dwInfoFlags = NIIF_WARNING | NIIF_NOSOUND;
	switch ( iBaloonMsg ) {
		case  Nukey_SavingBaloon:
			strcpy( notif.szInfo, m_baloonText );  /* ۑ */
			break;
		case  Nukey_DeletingBaloon:
			strcpy( notif.szInfo, m_baloonText2 );  /* 폜 */
			break;
		case  Nukey_ReatestingBaloon:
			strcpy( notif.szInfo, m_baloonText3 );  /* "nukey security bN\" */
			break;
	}
	notif.uTimeout = m_baloonTime | NOTIFYICON_VERSION;
	// NIM_MODIFY ł́Anotif.szTip ͌Ȃ

	Shell_NotifyIcon( NIM_MODIFY, (PNOTIFYICONDATA)&notif );
}


void  CNukeyDlg::DeleteTaskTrayIcon()
{
	NOTIFYICONDATA  notif;

	notif.cbSize = sizeof(NOTIFYICONDATA);
	notif.hWnd = m_hWnd;
	notif.uID = 0;
	notif.uFlags = 0;
	Shell_NotifyIcon( NIM_DELETE, &notif );
}


 
/***********************************************************************
  <<< [CNukeyDlg::LoadAutoRun] N̐ݒ擾 >>> 
************************************************************************/
void  CNukeyDlg::LoadAutoRun()
{
	LONG   ret;
	HKEY   key;
	DWORD  type;
	DWORD  data;
	DWORD  size;
	CString  s;

	/* WXg NhCȕ擾 */
	ret = RegOpenKeyEx( HKEY_CURRENT_USER, "Software\\Microsoft\\Windows\\CurrentVersion\\Policies\\Explorer", 0L, KEY_READ, &key );
	if ( ret != ERROR_SUCCESS )  goto err;

	size = sizeof(data);
	ret = RegQueryValueEx( key, "NoDriveAutoRun", NULL, &type, (LPBYTE)&data, &size );
	if ( ret != ERROR_SUCCESS )  goto err;
	if ( type != REG_BINARY )  goto err;

	ret = RegCloseKey( key );
	if ( ret != ERROR_SUCCESS )  goto err;


	m_drive = m_Drive.GetCurSel() + 'A';
	if ( m_drive == '\\' )  error();

	m_AutoRun.SetCheck( ( (data >> (m_drive - 'A')) & 1 ) != 0 );
	return;

err:
	m_AutoRun.SetCheck( FALSE );
}


void CNukeyDlg::OnChangeDrive()
{
	LoadAutoRun();
}

void CNukeyDlg::OnSelchangeDrive()
{
	LoadAutoRun();
}


/***********************************************************************
  <<< [CNukeyDlg::SaveAutoRun] N̐ݒݒ肷 >>>
y⑫z
EԂĺAċNKvǂ
************************************************************************/
bool  CNukeyDlg::SaveAutoRun()
{
	LONG   ret;
	HKEY   key;
	DWORD  type;
	DWORD  data;
	DWORD  size;
	CString  s;
	bool   bDisableAutoRun;

	/* WXg NhCȕ擾 */
	ret = RegOpenKeyEx( HKEY_CURRENT_USER, "Software\\Microsoft\\Windows\\CurrentVersion\\Policies\\Explorer", 0L, KEY_READ, &key );
	if ( ret != ERROR_SUCCESS )  { data = 0;  goto next; }

	size = sizeof(data);
	ret = RegQueryValueEx( key, "NoDriveAutoRun", NULL, &type, (LPBYTE)&data, &size );
	if ( ret != ERROR_SUCCESS )  { data = 0;  goto next; }
	if ( type != REG_BINARY )  { data = 0;  goto next; }

	ret = RegCloseKey( key );
	if ( ret != ERROR_SUCCESS )  goto next;

next:

	m_Drive.GetWindowText( s );
	m_drive = *(const char*)s;
	if ( m_drive == '\\' )  error();

	bDisableAutoRun = ( m_AutoRun.GetCheck() != 0 );

	if ( bDisableAutoRun ) {
		if ( data & ( 1 << (m_drive - 'A') ) )  return  false;
		data |= ( 1 << (m_drive - 'A') );
	}
	else {
		if ( !( data & ( 1 << (m_drive - 'A') ) ) )  return  false;
		data &= ~( 1 << (m_drive - 'A') );
	}


	/* WXg NhCȕݒ肷 */
	ret = RegOpenKeyEx( HKEY_CURRENT_USER, "Software\\Microsoft\\Windows\\CurrentVersion\\Policies\\Explorer", 0L, KEY_WRITE | KEY_SET_VALUE , &key );
	if ( ret != ERROR_SUCCESS )  error();

	size = sizeof(data);
	ret = RegSetValueEx( key, "NoDriveAutoRun", NULL, REG_BINARY, (CONST BYTE *)&data, sizeof(data) );
	ret = RegCloseKey( key );

	return  true;
}


 
/***********************************************************************
  <<< [Nukey_lockThread] USB[ĎXbh >>> 
************************************************************************/
#ifdef  NDEBUG
 #define   Overlap_X  0
#else
 #define   Overlap_X  440
#endif

DWORD WINAPI  Nukey_lockThread( void* param )
{
	CNukeyDlg*  m = (CNukeyDlg*)param;
	CNukeyApp*  app = (CNukeyApp*)AfxGetApp();
	char  s[256];
	char  path[256];
	WIN32_FILE_ATTRIBUTE_DATA  attr;
	int  i;
	int  hideBaloonTime = -1;
	CTime  lockTime;
	int    lockSec = -1;
	bool bLimitBaloon;

	m->m_bThreadQuit = false;

	if ( WaitForSingleObject( m->m_overlapSema, 0 ) == WAIT_TIMEOUT )  error();

	m->DeleteTaskTrayIcon();

	m->m_is_read_only_key = false;

	for (;;) {

		if ( ! m->MakeKey() ) {
			if ( ! m->m_bSkipConfirm ) {
				bool  bExit = true;

				if ( MessageBox( NULL, "bNL[炸ɃbN܂H\r\n"
						"iƂ̓pX[hg܂j\r\n\r\n"
						"iӁF̏ԂŐȂ𗣂ꂽ玩IɃbN܂j",
						"nukey security", MB_YESNO | MB_SYSTEMMODAL ) == IDYES )
					bExit = false;

				if ( bExit ) {
					ReleaseSemaphore( m->m_overlapSema, 1, 0 );
					goto  exit2;
				}
			}
		}
		m->m_bSkipConfirm = false;

		GetFileAttributesEx( m->m_key_path, GetFileExInfoStandard, &attr );
		memcpy( &m->m_key_accessTime, &attr.ftLastAccessTime, sizeof(FILETIME) );
		m->m_key_filelen = attr.nFileSizeLow;


		/* 3ȏỎ UUID ͏ */
		/* PC̃L[t@CĎΏۂɂ */
		{
			time_t  t;
			time_t  before3days;
			HANDLE  f;
			WIN32_FIND_DATA  data;
			char  path[_MAX_PATH];
			char  path2[_MAX_PATH];

			time( &before3days );
			TimeDate_setDiff( &t, 0, 0, 3, 0, 0, 0 );
			before3days -= t;

			StrX_cpyFolder( path, m->m_key_path );
			StrX_addFName( path, "*" );
			f = FindFirstFile( path, &data );
			StrX_cutFName( path );

			m->m_key2_n = 0;
			if ( f != INVALID_HANDLE_VALUE ) {
				do {
					if ( data.cFileName[0] == '.' )  continue;

					/* 3ȏÕL[t@C͏ */
					strcpy( path2, path );
					if ( strlen( path2 ) + strlen( data.cFileName ) >= _MAX_PATH - 5 )  continue;  /* 5=]T */
					StrX_addFName( path2, data.cFileName );
					if ( stricmp( path2, m->m_key_path ) == 0 )  continue;
					FileX_getUpdate( path2, &t );
					if ( t < before3days )  { remove( path2 );  continue; }

					if ( strchr( data.cFileName, '.' ) != NULL )  continue;  /* gqƂ͊ĎΏۊO */

					/* L[t@CƂ́AUSB[̊Ďn߂Ȃ */
					if ( m->m_key2_n == Nukey_mKeyFile - 1 ) {
						FindClose( f );

						remove( m->m_key_path );
						ReleaseSemaphore( m->m_overlapSema, 1, 0 );

						sprintf( s, "USB[ɂL[t@C܂B\r\n"
							"XVQlɁAnukey tH_[̃t@C̐%dȉɂĂB",
							Nukey_mKeyFile - 1 );

						MessageBox( NULL, s, "nukey security G[", MB_OK | MB_TOPMOST );

						sprintf( path2, "%s\\explorer.exe \"%s\"", getenv( "windir" ), path );
						WinExec( path2, SW_SHOWNORMAL );

						goto  exit2;
					}

					/* PC̃L[t@CĎΏۂɂ */
					strcpy( m->m_key2_path[m->m_key2_n], path2 );
					GetFileAttributesEx( m->m_key2_path[m->m_key2_n], GetFileExInfoStandard, &attr );
					memcpy( &m->m_key2_accessTime[m->m_key2_n], &attr.ftLastAccessTime, sizeof(FILETIME) );
					m->m_key2_filelen[m->m_key2_n] = attr.nFileSizeLow;
					m->m_key2_n ++;

				} while ( FindNextFile( f, &data ) );
				FindClose( f );
			}
		}


		/* JgfBNĝ߂ɃtH_[폜łȂ悤ɂȂ */
		if ( m->m_folderPath[0] != '\\' || m->m_folderPath[1] != '\\' ) {
			strcpy( path, "E:\\" );  path[0] = m->m_drive;
			_chdir( path );
			_chdrive( *getenv( "windir" ) - 'A' + 1 );
		}

		m->AddToTaskTray( Nukey_ActiveState );
		m->ShowInfoInTaskTray( Nukey_SavingBaloon );
		hideBaloonTime = m->m_baloonTime;
		lockTime = CTime::GetCurrentTime() + CTimeSpan( 0, 0, m->m_lockSpan, 0 );
		bLimitBaloon = false;


		#if 0
		for (;;) {  Sleep(1000);
			attr.ftLastAccessTime.dwLowDateTime = 0;
			GetFileAttributesEx( m->m_key_path, GetFileExInfoStandard, &attr );
			WD( attr.ftLastAccessTime.dwLowDateTime );
		}
		#endif


		/* USB[Ď */
		for (;;) {
			Sleep( 2000 );  /* 2bԊuŃ`FbN */
			hideBaloonTime -= 2000;
			lockSec = ( lockTime - CTime::GetCurrentTime() ).GetTotalSeconds();
			if ( lockSec < 0 )  lockSec = 0;


			/* o[wviWindowsXPpj */
			if ( hideBaloonTime < 0 ) {
				m->DeleteTaskTrayIcon();
				m->AddToTaskTray( Nukey_ActiveState );
				hideBaloonTime = INT_MAX;
			}


			/* USBfBXN邱Ƃo */
			if ( ! GetFileAttributesEx( m->m_key_path, GetFileExInfoStandard, &attr ) ) {
				m->m_iStartMsg = 0;  break;
			}


			/* NbJ[Nt@CJL[t@CύX */
			/*  [memo] FindFirstChangeNotification ł ftLastAccessTime ̕ύX͌ołȂ */
			if ( memcmp( &attr.ftLastAccessTime, &m->m_key_accessTime, sizeof(FILETIME) ) != 0 ||
					 attr.nFileSizeLow != m->m_key_filelen ) {
				remove( m->m_key_path );
				goto  continue2;
			}


			/* NbJ[NAPC̃L[t@CJx */
			if ( ! m->m_bDialogThread ) {
				for ( i = 0; i < m->m_key2_n; i++ ) {
					if ( GetFileAttributesEx( m->m_key2_path[i], GetFileExInfoStandard, &attr ) &&
							 ( memcmp( &attr.ftLastAccessTime, &m->m_key2_accessTime[i], sizeof(FILETIME) ) != 0 ||
								 attr.nFileSizeLow != m->m_key2_filelen[i] ) ) {
						if ( ! m->m_bDialogThread ) {
							if ( m->m_dialogThread != NULL )  CloseHandle( m->m_dialogThread );
							m->m_bDialogThread = true;
							m->m_dialogThread = CreateThread( NULL, 0, Nukey_dialogThread, m, 0, 0 );
						}
					}
				}
			}


			/* pX[h̍ĊmFs邱Ƃ30bOɌx */
			if ( lockSec < 30 && ! bLimitBaloon ) {
				m->DeleteTaskTrayIcon();
				m->AddToTaskTray( Nukey_ReatestingBaloon );
				m->ShowInfoInTaskTray( Nukey_ReatestingBaloon );
				bLimitBaloon = true;
			}

			/* pX[h̍ĊmFs */
			if ( lockSec <= 0 ) {
				LockWorkStation();
				Sleep( 3000 );
				m->m_iStartMsg = 4;
				break;
			}


			/* Ď𒆎~ */
			if ( m->m_bThreadQuit ) {
				remove( m->m_key_path );
				ReleaseSemaphore( m->m_overlapSema, 1, 0 );
				m->DeleteTaskTrayIcon();
				m->AddToTaskTray( Nukey_StoppingState );
				m->ShowInfoInTaskTray( Nukey_DeletingBaloon );
				m->m_hideInfoTimer = m->SetTimer( Nukey_Time_onTrayIcon, m->m_baloonTime, NULL );
				m->m_hideInfoTime = GetTickCount() + m->m_baloonTime;
				goto  exit2;
			}
		}

		/* o[wviWindowsXPpj */
		m->DeleteTaskTrayIcon();
		m->AddToTaskTray( Nukey_ActiveState );


		/* bNʂ\ */
		m->PostMessage( WM_COMMAND, Nukey_Cmd_MakeOverlap, 0 );
			// ō overlap ɃbZ[W΂ȂB

		WaitForSingleObject( m->m_overlapSema, INFINITE );


		/* pX[hAbNƂ */
		if ( m->m_passwordUnlock ) {

			/* USBfBXNꂽ܂܂ȂAL[ɂ */
			if ( ! GetFileAttributesEx( m->m_key_path, GetFileExInfoStandard, &attr ) ) {
				if ( m->m_dupKey_n < Nukey_mDupKeyFile ) {
					m->addDupKey();
					m->m_key_path[0] = '\0';
				}
				m->DeleteTaskTrayIcon();
				ReleaseSemaphore( m->m_overlapSema, 1, 0 );
				goto  exit2;
			}
			/* USBfBXN}ĂAL[ۑāAUSB̊ĎĊJ */
			/* goto  continue2; */
		}

continue2:;
	}
exit2:

	m->PostMessage( WM_COMMAND, Nukey_Cmd_ClosedOverlap, 0 );

	return  0;
}


/***********************************************************************
  <<< [Nukey_dialogThread] _CAO\Xbh >>>
y⑫z
Ex\ł USB̊Ď͑邽߁AXbhɂĂB
************************************************************************/
DWORD WINAPI  Nukey_dialogThread( void* param )
{
	CNukeyDlg*  m = (CNukeyDlg*)param;
	WIN32_FILE_ATTRIBUTE_DATA  attr;
	int  i, n;

	MessageBox( NULL, "nukey security ȊÕvOL[t@CɃANZX܂B\r\n"
		"Anukey tH_[JĂĂB\r\n"
		"EBXo\tgɂ̂m܂񂪁AS肪΁A"
		"L[̏񂪓܂ꂽ\܂B"
		"xׂẴp\RꎞI Windows W̃pX[hEbNɕύXA"
		"̌x\Ăp\R̃ZLeB`FbNĂB",
		"nukey security", MB_OK | MB_ICONEXCLAMATION | MB_TOPMOST );

	n = m->m_key2_n;
	m->m_key2_n = 0;
	for ( i = 0; i < n; i++ ) {
		if ( GetFileAttributesEx( m->m_key2_path[i], GetFileExInfoStandard, &attr ) ) {
			strcpy( m->m_key2_path[m->m_key2_n], m->m_key2_path[i] );
			memcpy( &m->m_key2_accessTime[m->m_key2_n], &attr.ftLastAccessTime, sizeof(FILETIME) );
			m->m_key2_filelen[m->m_key2_n] = attr.nFileSizeLow;
			m->m_key2_n ++;
		}
	}

	m->m_bDialogThread = false;
	return  0;
}


 
/***********************************************************************
  <<< [CNukeyDlg::MakeKey] L[쐬 >>> 
yz
  Ebool  Ԃl;  쐬ǂ
************************************************************************/
bool  CNukeyDlg::MakeKey()
{
	GUID   uuid;
	char   s[256];
	char   path[256];
	DWORD  size;
	int    iKey;
	bool   is_created_key = false;

	for (;;) {

		/* }Ă USB [ɉL[΁ACL[ɂ */
		iKey = CheckDupKey( NULL );
		if ( iKey != -1 ) {
			strcpy( m_key_path, m_dupKey_path[ iKey ] );
			strcpy( m_key_data, m_dupKey_data[ iKey ] );
			memcpy( &m_key_accessTime, &m_dupKey_accessTime[ iKey ], sizeof(FILETIME) );
			m_key_filelen =  m_dupKey_filelen[ iKey ];

			removeDupKey( iKey );

			return  true;
		}

		/* L[ijƂ͍Ȃ */
		if ( m_dupKey_n >= Nukey_mDupKeyFile - 1 ) {
			if ( MessageBox( "pX[hɂAbN܂B"
					 "L[ɂȂĂ USB [}ĂB"
					 "iL[Ƃ́ANA邽߂ "
					 "nukey security ċNĂj",
					 "nukey security", MB_OKCANCEL ) == IDOK )
				continue;
			else
				return  false;
		}
		break;
	}


	/* L[t@C USBfBXNɏ */
	GetKeyFolderPath( path );

	if ( ! m_is_read_only_key ) {

		CoCreateGuid( &uuid );

		strcpy( m_key_path, path );
		StrX_setLast( m_key_path, '\\' );
		StrX_getGUIDStr( &uuid, strchr( m_key_path, '\0' ) );
		{ time_t t;  time(&t);  srand( t ); }
		sprintf( strchr( m_key_path, '\0' ), "-%d-", rand() );
	}


	for (;;) {
		_mkdir( path );
		m_key_file = CreateFile( m_key_path, GENERIC_WRITE, 0, NULL, CREATE_NEW,
			 FILE_ATTRIBUTE_NORMAL | FILE_FLAG_WRITE_THROUGH, 0 );

		if ( m_key_file != INVALID_HANDLE_VALUE ) {  /* L[ꂽƂ */
			CoCreateGuid( &uuid );
			StrX_getGUIDStr( &uuid, m_key_data );
			WriteFile( m_key_file, m_key_data, sizeof(m_key_data), &size, NULL );
			FlushFileBuffers( m_key_file );
			is_created_key = true;
			m_is_read_only_key = false;
			break;
		}

		else if ( m_bSkipConfirm ) {
			return  false;
		}

		else if ( GetFileAttributes( path ) != -1 ) {  /* tH_[݂Ƃ */
			if ( ! m_is_read_only_key ) {
				if ( MessageBox( "L[tH_[ɏ݂ł܂B"
					"ɊJtH_[̒ɂt@ĈAL[Ƃt@CIłB",
					"nukey security", MB_OKCANCEL | MB_SYSTEMMODAL ) == IDCANCEL )
				{
					return  false;
				}

				CFileDialog  dlg( TRUE, "", "", OFN_HIDEREADONLY, "ׂẴt@C (*.*)|*.*||" );

				#ifdef  NDEBUG
					dlg.m_ofn.Flags &= ~OFN_ENABLEHOOK;  /* Win2000ȍ~̐Vt@C_CAOɂ */
				#endif
				dlg.m_ofn.lpstrInitialDir = path;  /* \tH_[ */

				if ( dlg.DoModal() == IDOK ) {
					FILE*   file;
					size_t  read_size;
					char    data[Nukey_dataSize+1];

					StrX_cpy( m_key_path, dlg.GetPathName(), sizeof(m_key_path) );

					file = fopen( m_key_path, "r" );

					if ( file == NULL ) { return  false; }

					read_size = fread( data, 1, Nukey_dataSize, file );
					fclose( file );

					if ( read_size < Nukey_dataSize ) {
						CString  s;

						s.Format( "L[t@CƂĎgA%doCgȏ̃t@CIłB",
							Nukey_dataSize );
						MessageBox( s, "nukey security", MB_OK | MB_SYSTEMMODAL );
						return  false;
					}

					memcpy( m_key_data, data, Nukey_dataSize );
					m_is_read_only_key = true;

					break;
				} else {
					return  false;
				}
			}
			else {
				break;
			}
		}

		else {
			s[0] = m_key_path[0];
			strcpy( s+1, "hCuUSBtbVȂĂB\r\n\r\n"
				"iӁF̏ԂŐȂ𗣂ꂽ玩IɃbN܂j" );
			if ( MessageBox( s, "nukey security", MB_OKCANCEL | MB_SYSTEMMODAL ) == IDCANCEL ) {
				return  false;
			}
		}
	}

	CloseHandle( m_key_file );


	/* t@CړBȂUSB[𔲂uԁHɃANZX̂ */
	if ( is_created_key ) {
		WIN32_FILE_ATTRIBUTE_DATA  attr;

		strcpy( s, m_key_path );
		StrX_bs( m_key_path );
		MoveFile( s, m_key_path );

		do {  /* ړ܂ő҂ */
			Sleep(500);
		} while ( GetFileAttributesEx( m_key_path, GetFileExInfoStandard, &attr ) == 0 );
	}

	return  true;
}


 
/***********************************************************************
  <<< [CNukeyDlg::OnCommand] CEEBhE WM_COMMAND Cxgnh >>> 
************************************************************************/
BOOL CNukeyDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{
	switch ( wParam ) {

	 case Nukey_Cmd_MakeOverlap: {

		CNukeyApp*  app = (CNukeyApp*)AfxGetApp();
		HWND  overlap;

		/* I[o[bvEEBhE쐬 */
		{
			WNDCLASSEX  wc;

			memset( &wc , 0, sizeof(WNDCLASSEX) );
			wc.cbSize = sizeof(WNDCLASSEX);
			wc.lpfnWndProc = Overlap_WndProc;
			wc.hInstance = app->m_hInstance;
			wc.hCursor = LoadCursor( NULL, IDC_ARROW );
			wc.hbrBackground = (HBRUSH)GetStockObject( BLACK_BRUSH );
			wc.lpszClassName = "NukeyOverlap";

			RegisterClassEx( &wc );

			overlap = CreateWindow( "NukeyOverlap", "NukeyOverlap",
					WS_POPUP | WS_VISIBLE, Overlap_X, 0,
					GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN),
					m_hWnd, NULL, app->m_hInstance, this );

			/* őOʂɂBix NOTOPMOST ɂȂƁATOPMOSTɋN^XN}l[WOʂɂj */
			::SetWindowPos( overlap, HWND_NOTOPMOST, Overlap_X, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE );
			::SetWindowPos( overlap, HWND_TOP, Overlap_X, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE );
			::SetWindowPos( overlap, HWND_TOPMOST, Overlap_X, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE );
		}

		::SetTimer( overlap, Nukey_Time_onInterval, 100, NULL );

		/* Alt+TAB  Alt+Ctrl+DEL 𖳌ɂ */
		SystemParametersInfo( SPI_SETSCREENSAVEACTIVE, FALSE, 0, SPIF_SENDWININICHANGE);
			/* OSXN[EZ[o[NȂ悤ɂ */
		SystemParametersInfo( SPI_SCREENSAVERRUNNING, TRUE, NULL, 0 );
		g_StartHook( overlap );

		break;
	 }

	 case Nukey_Cmd_ClosedOverlap: {
		WaitForSingleObject( m_thread, INFINITE );
		CloseHandle( m_thread );
		m_thread = NULL;
		ShowWindow( SW_SHOW );
		m_lockTime = CTime::GetCurrentTime() + CTimeSpan( 0, 0, m_lockSpan, 0 );
		m_limitTimer = SetTimer( Nukey_Time_onLimit, 1000, NULL );
		break;
	 }
	}

	return CDialog::OnCommand(wParam, lParam);
}


 
/***********************************************************************
  <<< [Overlap_WndProc] I[o[bvEEBhẼCxgnh >>> 
************************************************************************/
typedef  struct _Overlap  Overlap;
struct _Overlap {
	RECT  m_offRect;  /* Vbg_E{^̈ʒu */
	DWORD m_nextSecTime;
	DWORD m_createTime;
	DWORD m_mouseOffTime;
	int   m_dontMouseOn;
	DWORD m_screenOffTime;
	DWORD m_saverOnTime;
	DWORD m_nextSaverChkTime;
	DWORD m_unlockTime;
	DWORD m_passwordOffTime;
	int   m_iBmp;
	HWND  m_foreWnd;
	int   m_iMsg;
	int   m_foundOldkey_i;
	bool  m_bPrevScrRunning;
};
static  Overlap  g_overlap;

#define  MouseOffTime   1000
#define  NOCLIP_PAINT  (WM_USER+1)
void  Overlap_drawBitmap( Overlap* me, CNukeyDlg* m );


LRESULT CALLBACK  Overlap_WndProc( HWND wnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	static  CNukeyDlg*  mm;
	Overlap*  me = &g_overlap;
	CNukeyDlg*  m = mm;
	int i, iKey;

	switch ( msg ) {
		case WM_CREATE: {
			DWORD  t = GetTickCount();

			mm = (CNukeyDlg*)( (LPCREATESTRUCT)lParam )->lpCreateParams;
			m = mm;
			me->m_createTime = t;
			me->m_nextSecTime = t + 1000;
			me->m_mouseOffTime = (DWORD)-1;
			me->m_dontMouseOn = 5;
			me->m_screenOffTime = m->m_noEco ?  (DWORD)-1 :  t + m->m_ecoTime * 60000;
			me->m_saverOnTime = m->m_noSaver ?  (DWORD)-1 :  t + m->m_saverTime * 60000;
			me->m_nextSaverChkTime = (DWORD)-1;
			me->m_unlockTime = (DWORD)-1;
			me->m_passwordOffTime = (DWORD)-1;
			me->m_iBmp = 0;
			me->m_foreWnd = wnd;
			me->m_iMsg = m->m_iStartMsg;
			me->m_foundOldkey_i = 0;
			me->m_bPrevScrRunning = false;
			SetCursor( NULL );
			break;
		}

		case WM_PAINT: {
			PAINTSTRUCT ps;
			HDC  dc = BeginPaint( wnd, &ps );

			// ŕ`悷ƁABitblt ͑Ŝɂł̂ɁA
			// eLXgNbv̈悵`łȂƂB
			PostMessage( wnd, WM_COMMAND, NOCLIP_PAINT, 0 );

			EndPaint( wnd, &ps );
			break;
		}


		case WM_COMMAND:
			if ( wParam == NOCLIP_PAINT ) {
			CNukeyApp*  app = (CNukeyApp*)AfxGetApp();
			const char*  msg;
			HDC  dc = GetDC( wnd );
			RECT  rc;
			char  s[256];

			me->m_offRect.left = 0;   me->m_offRect.right = 2;
			me->m_offRect.top = 0;   me->m_offRect.bottom = 2;


			/* bÑrbg}bv\ */
			if ( ( m->m_lockScreen == 2 || m->m_lockScreen == 3 ) ) {
				Overlap_drawBitmap( me, m );
				me->m_offRect = m->m_unlockRect[ me->m_iBmp ];
			}


			/* bÑbZ[W\ */
			rc.left = 0;  rc.right = GetSystemMetrics(SM_CXSCREEN);
			rc.top = (0 + GetSystemMetrics(SM_CYSCREEN)) / 2;   rc.bottom = rc.top;
			rc.top -= 20;

			if ( ( m->m_lockScreen == 1 || m->m_lockScreen == 3 ) && me->m_iMsg != 4 ) {

				msg = m->m_message1;  // " PC ́AL҂ USB tbV[}Ǝg悤ɂȂ܂";
				DrawText( dc, msg, strlen(msg), &rc, DT_CENTER | DT_SINGLELINE | DT_VCENTER | DT_NOCLIP );

				msg = m->m_message2;  // "L[𖳂Ƃ͂NbNăpX[h͂Ă";
				rc.top += 64;  rc.bottom += 64;
				me->m_offRect = rc;
				DrawText( dc, msg, strlen(msg), &rc, DT_CENTER | DT_SINGLELINE | DT_VCENTER );
			}

			switch ( me->m_iMsg ) {
				case 1:
					msg = "L[t@C܂";
					rc.top += 64;  rc.bottom += 64;
					DrawText( dc, msg, strlen(msg), &rc, DT_CENTER | DT_SINGLELINE | DT_VCENTER );

					sprintf( s, "XVQlɁAnukey tH_[̃t@C̐%dȉɂĂB",
							Nukey_mKeyFile - 1 );
					rc.top += 19;  rc.bottom += 19;
					DrawText( dc, s, strlen(s), &rc, DT_CENTER | DT_SINGLELINE | DT_VCENTER );
					break;

				case 2:
					msg = "ߋɉL[܂BNꂽ\܂B";
					rc.top += 64;  rc.bottom += 64;
					DrawText( dc, msg, strlen(msg), &rc, DT_CENTER | DT_SINGLELINE | DT_VCENTER );

					msg = "pX[h͂āAׂẴp\R̃ZLeB`FbNĂB";
					rc.top += 19;  rc.bottom += 19;
					DrawText( dc, msg, strlen(msg), &rc, DT_CENTER | DT_SINGLELINE | DT_VCENTER );

					sprintf( s, "ꂽL[t@CF%s",  m->m_oldkey_path[ me->m_foundOldkey_i ] );
					rc.top += 19;  rc.bottom += 19;
					DrawText( dc, s, strlen(s), &rc, DT_CENTER | DT_SINGLELINE | DT_VCENTER );
					break;

				case 3:
					msg = "L[܂ꂽ\邽߁A";
					rc.top += 64;  rc.bottom += 64;
					DrawText( dc, msg, strlen(msg), &rc, DT_CENTER | DT_SINGLELINE | DT_VCENTER );

					msg = "pX[h͂ăbNĂB";
					rc.top += 19;  rc.bottom += 19;
					DrawText( dc, msg, strlen(msg), &rc, DT_CENTER | DT_SINGLELINE | DT_VCENTER );
					break;

				case 4:
					msg = "pX[hmF܂B";
					rc.top += 64;  rc.bottom += 64;
					DrawText( dc, msg, strlen(msg), &rc, DT_CENTER | DT_SINGLELINE | DT_VCENTER );

					msg = "NbN烍bN܂B";
					rc.top += 19;  rc.bottom += 19;
					me->m_offRect = rc;
					DrawText( dc, msg, strlen(msg), &rc, DT_CENTER | DT_SINGLELINE | DT_VCENTER );
					break;

				case 5:
					msg = " USB [ɂ́AL[܂B";
					rc.top += 64;  rc.bottom += 64;
					DrawText( dc, msg, strlen(msg), &rc, DT_CENTER | DT_SINGLELINE | DT_VCENTER );

					msg = "inukey security ċNAL[ɂȂ\܂Bj";
					rc.top += 19;  rc.bottom += 19;
					DrawText( dc, msg, strlen(msg), &rc, DT_CENTER | DT_SINGLELINE | DT_VCENTER );
					break;
			}

			SelectClipRgn( dc, NULL );
			ReleaseDC( wnd, dc );
			break;
		}

		case WM_MOUSEMOVE: {
			DWORD  t = GetTickCount();
			int  x = LOWORD(lParam);
			int  y = HIWORD(lParam);

			me->m_mouseOffTime = t + MouseOffTime;

			if ( t - me->m_createTime > 5000 ) {

				if ( m->m_noEco )    me->m_screenOffTime = (DWORD)-1;
				else if ( m->m_ecoTime == 0 )  me->m_screenOffTime = t + 10000;
				else  me->m_screenOffTime = t + m->m_ecoTime * 60000;

				if ( m->m_noSaver )    me->m_saverOnTime = (DWORD)-1;
				else if ( m->m_saverTime == 0 )  me->m_saverOnTime = t + 5000;
				else  me->m_saverOnTime = t + m->m_saverTime * 60000;
			}

			if ( me->m_dontMouseOn > 0 ) {
				SetCursor( NULL );
				me->m_dontMouseOn --;
			}
			else {
				if ( m->m_bUseFingerCursor &&
						 me->m_offRect.left <= x && x <= me->m_offRect.right &&
						 me->m_offRect.top <= y && y <= me->m_offRect.bottom )
					SetCursor( m->m_FingerCursor );
				else
					SetCursor( m->m_Arrow );
			}
			break;
		}

		case WM_LBUTTONUP: {
			int  x = LOWORD(lParam);
			int  y = HIWORD(lParam);

			if ( me->m_offRect.left <= x && x <= me->m_offRect.right &&
					 me->m_offRect.top <= y && y <= me->m_offRect.bottom ) {

				if ( me->m_iMsg != 4 ) {
					LockWorkStation();
					Sleep( 3000 );
					me->m_iMsg = 4;
					InvalidateRect( wnd, NULL, TRUE );
					me->m_passwordOffTime = GetTickCount() + 60000;
				}
				else {

					/* ʂ߂ */
					if ( me->m_foreWnd != NULL && me->m_foreWnd != wnd )
						::PostMessage( me->m_foreWnd, WM_CLOSE, 0, 0 );  // XN[Z[o[I

					::PostMessage( HWND_BROADCAST, WM_SYSCOMMAND, SC_MONITORPOWER, -1 );  // fBXvCȓd͂߂

					SystemParametersInfo( SPI_SCREENSAVERRUNNING, FALSE, NULL, 0 );

					SystemParametersInfo( SPI_SETSCREENSAVEACTIVE, TRUE, 0, SPIF_SENDWININICHANGE);
						/* OSXN[EZ[o[N悤ɂ */
					g_StopHook();
					KillTimer( wnd, Nukey_Time_onInterval );

					m->m_passwordUnlock = true;

					::PostMessage( wnd, WM_CLOSE, 0, 0 );
					ReleaseSemaphore( m->m_overlapSema, 1, 0 );
				}
			}
			break;
		}

		case WM_TIMER: {
			DWORD  t = GetTickCount();
			FILE*  f;
			CNukeyApp*  app = (CNukeyApp*)AfxGetApp();
			BOOL  bScrRunning;
			WIN32_FILE_ATTRIBUTE_DATA  attr;


			/* łOɕ\EBhEAbN\XN[Z[o[߂ */
			SystemParametersInfo( SPI_GETSCREENSAVERRUNNING, 0, &bScrRunning, 0 );
			if ( bScrRunning || me->m_nextSaverChkTime != (DWORD)-1 ) {
				if ( me->m_foreWnd == wnd ) {
					if ( t >= me->m_nextSaverChkTime ) {
						char  scr_fname[_MAX_PATH];

						if ( WinX_getExeFNameByWild( "*.scr", scr_fname, sizeof(scr_fname) ) ) {  /* Ԃ */

							/* n߂AXN[Z[o[̃EBhET foreWnd Ɏ擾 */
							HWND  scr_wnd;
							int  n = WinX_getAllAppHWnd( &scr_wnd, sizeof(scr_wnd), scr_fname );

							if ( n > 0 )  me->m_foreWnd = scr_wnd;
							else  me->m_foreWnd = NULL;
									/* XN[Z[o[ɃpX[hݒ肵ĂƂ n == 0 */
									/* foreWnd = NULL ɂȂƁAWinX_getExeFNameByWild ŃXN[Z[o[ */
									/* JNJNɂȂĂ܂B*/
							me->m_nextSaverChkTime = (DWORD)-1;

							for ( i = 0; i < 10; i ++ ) {
								SystemParametersInfo( SPI_GETSCREENSAVERRUNNING, 0, &bScrRunning, 0 );
								Sleep(1);
								if ( bScrRunning )  break;
									/* XN[Z[o[ɃpX[h͂LȂ bScrRunning == false */
							}
						}
						else
							me->m_nextSaverChkTime = GetTickCount() + 1000;  /* XN[Z[o[̋N̂߁AɃ`FbN܂ŏ҂ */
					}
				}
				else  ;  /* XN[Z[o[ĂƂ́AforeWnd ς邽߂̏Ȃ */

			}

			if ( ! bScrRunning ) {

				/* XN[Z[o[IƂ */
				if ( me->m_bPrevScrRunning && ! bScrRunning ) {

					/* x TOPMOST łȂĂx TOPMOST ɂ邱ƂŊmɍłOɂ */
					::SetWindowPos( wnd, HWND_NOTOPMOST, Overlap_X, 0, 0, 0, SWP_NOSIZE );
					::SetWindowPos( wnd, HWND_TOP, Overlap_X, 0, 0, 0, SWP_NOSIZE );
					::SetWindowPos( wnd, HWND_TOPMOST, Overlap_X, 0, 0, 0, SWP_NOSIZE );
				}

				/* ȌAwnd łOɂÂ */
				me->m_foreWnd = wnd;
				if ( me->m_saverOnTime == -1 && ! m->m_noSaver ) {
					if ( m->m_noSaver )    me->m_saverOnTime = (DWORD)-1;
					else if ( m->m_saverTime == 0 )  me->m_saverOnTime = t + 5000;
					else  me->m_saverOnTime = t + m->m_saverTime * 60000;
				}
				me->m_unlockTime = (DWORD)-1;
			}
			me->m_bPrevScrRunning = (bScrRunning != 0);


			/* pɂɁAbN\EBhEXN[Z[o[łOɂ */
			/*iXN[Z[o[NĂƂAwnd OɂƁAXN[Z[o[͏I܂j*/
			if ( me->m_foreWnd != NULL && ! ( bScrRunning && me->m_foreWnd == wnd ) ) {
				::SetWindowPos( me->m_foreWnd, HWND_TOPMOST, Overlap_X, 0,
					GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN), 0 );
				::SetForegroundWindow( me->m_foreWnd );
			}


			/* 1bƂɍs */
			if ( t >= me->m_nextSecTime ) {

				/* ߋɉL[x */
				if ( me->m_iMsg == 0 ) {
					for ( i = 0; i < m->m_oldkey_n; i++ ) {
						if ( GetFileAttributesEx( m->m_oldkey_path[i], GetFileExInfoStandard, &attr ) ) {
							if ( me->m_foreWnd != NULL && me->m_foreWnd != wnd )
								::PostMessage( me->m_foreWnd, WM_CLOSE, 0, 0 );  // XN[Z[o[I
							me->m_iMsg = 2;
							me->m_foundOldkey_i = i;
							InvalidateRect( wnd, NULL, TRUE );
							break;
						}
					}
				}


				/* USBfBXN}ꂽƂo */
				iKey = m->CheckDupKey( &attr );
				if ( iKey == -1 ) {
					if ( me->m_iMsg == 0 && GetFileAttributesEx( m->m_key_path, GetFileExInfoStandard, &attr ) ) {
						if ( memcmp( &attr.ftLastAccessTime, &m->m_key_accessTime, sizeof(FILETIME) ) != 0 )
							{ attr.ftLastAccessTime.dwLowDateTime = 0;  attr.ftLastAccessTime.dwHighDateTime = 0; }
						f = fopen( m->m_key_path, "r" );
					}
					else  f = NULL;
				}
				if ( iKey != -1 || f != NULL ) {
					char  data[Nukey_dataSize+1];
					int  nFile;

					if ( iKey == -1 ) {
						fread( data, Nukey_dataSize, 1, f );
						fclose( f );
					}
					else {  /* Ɠւ */
						FILETIME  t;
						int  len;
						char  s[_MAX_PATH];

						strcpy( s, m->m_dupKey_path[ iKey ] );  strcpy( m->m_dupKey_path[ iKey ], m->m_key_path );
						strcpy( m->m_key_path, s );
						strcpy( s, m->m_dupKey_data[ iKey ] );  strcpy( m->m_dupKey_data[ iKey ], m->m_key_data );
						strcpy( m->m_key_data, s );
						memcpy( &t, &m->m_dupKey_accessTime[ iKey ], sizeof(FILETIME) );
						memcpy( &m->m_dupKey_accessTime[ iKey ], &m->m_key_accessTime, sizeof(FILETIME) );
						memcpy( &m->m_key_accessTime, &t, sizeof(FILETIME) );
						len = m->m_dupKey_filelen[ iKey ];  m->m_dupKey_filelen[ iKey ] = m->m_key_filelen;
						m->m_key_filelen = len;
					}

					nFile = m->GetNKeyFile();

					if ( nFile > Nukey_mKeyFile && me->m_iMsg == 0 ) {
						if ( me->m_foreWnd != NULL && me->m_foreWnd != wnd )
							::PostMessage( me->m_foreWnd, WM_CLOSE, 0, 0 );  // XN[Z[o[I
						me->m_iMsg = 1;
						InvalidateRect( wnd, NULL, TRUE );
					}


					/* L[t@CAbNʂ */
					if ( me->m_iMsg == 0 && ( iKey != -1 || memcmp( data, m->m_key_data, Nukey_dataSize ) == 0 ) ) {

						/* ANZXtقȂĂx\ */
						if ( attr.ftLastAccessTime.dwLowDateTime == 0 &&  attr.ftLastAccessTime.dwHighDateTime == 0 ) {
							if ( me->m_iMsg == 0 ) {
								me->m_iMsg = 3;
								InvalidateRect( wnd, NULL, TRUE );
							}
						}

						/* L[t@CAbNʂ */
						else {

							/* L[L^Ă */
							if ( ! m->m_is_read_only_key ) {
								m->m_oldkey_path = (char**)realloc( m->m_oldkey_path, sizeof(char*) * (m->m_oldkey_n + 1) );
								m->m_oldkey_path[ m->m_oldkey_n ] = (char*)malloc( sizeof(char*) * (strlen(m->m_key_path)+1) );
								strcpy( m->m_oldkey_path[ m->m_oldkey_n ], m->m_key_path );
								m->m_oldkey_n++;
							}

							/* ʂ߂ */
							if ( me->m_foreWnd != NULL && me->m_foreWnd != wnd )
								::PostMessage( me->m_foreWnd, WM_CLOSE, 0, 0 );  // XN[Z[o[I

							::PostMessage( HWND_BROADCAST, WM_SYSCOMMAND, SC_MONITORPOWER, -1 );  // fBXvCȓd͂߂

							SystemParametersInfo( SPI_SCREENSAVERRUNNING, FALSE, NULL, 0 );

							SystemParametersInfo( SPI_SETSCREENSAVEACTIVE, TRUE, 0, SPIF_SENDWININICHANGE);
								/* OSXN[EZ[o[N悤ɂ */
							g_StopHook();
							KillTimer( wnd, Nukey_Time_onInterval );
							remove( m->m_key_path );

							m->m_passwordUnlock = false;

							::PostMessage( wnd, WM_CLOSE, 0, 0 );
							ReleaseSemaphore( m->m_overlapSema, 1, 0 );
						}
					}
				}

				/* L[ȂƂ */
				else {
					char   folderPath[256];

					m->GetKeyFolderPath( folderPath );

					if ( me->m_iMsg == 4 ) {
						if ( t >= me->m_passwordOffTime ) {
							me->m_passwordOffTime = (DWORD)-1;
							me->m_iMsg = 0;
							InvalidateRect( wnd, NULL, TRUE );
						}
					}
					else if ( me->m_iMsg == 5 ) {
						if ( ! FileX_isDir( folderPath ) ) {
							me->m_iMsg = 0;
							InvalidateRect( wnd, NULL, TRUE );
						}
					}
					else if ( me->m_iMsg == 0 ) {
						if ( FileX_isDir( folderPath ) ) {
							me->m_iMsg = 5;
							InvalidateRect( wnd, NULL, TRUE );
						}
					}
					else {
						if ( ! FileX_isExist( m->m_key_path ) ) {
							me->m_iMsg = 0;
							InvalidateRect( wnd, NULL, TRUE );
						}
					}
				}


				/* ԂAfBXvCȓd͂ɂ */
				if ( t >= me->m_screenOffTime && me->m_iMsg == 0 ) {
					::PostMessage( HWND_BROADCAST, WM_SYSCOMMAND, SC_MONITORPOWER, 1 );
					me->m_screenOffTime = (DWORD)-1;
					Sleep(700);
					::PostMessage( HWND_BROADCAST, WM_SYSCOMMAND, SC_MONITORPOWER, 1 );
					if ( me->m_foreWnd != NULL && me->m_foreWnd != wnd )
						::PostMessage( me->m_foreWnd, WM_CLOSE, 0, 0 );  // XN[Z[o[I
				}


				/* ԂAXN[Z[o[ċN */
				if ( t >= me->m_saverOnTime && me->m_iMsg == 0 ) {
					me->m_saverOnTime = (DWORD)-1;
					bScrRunning = true;
					m->SendMessage( WM_SYSCOMMAND, SC_SCREENSAVE, 0 );
					me->m_nextSaverChkTime = GetTickCount() + 1000;
				}


				/* ԂA}EX */
				if ( t >= me->m_mouseOffTime ) {
					SetCursor( NULL );
					me->m_mouseOffTime = (DWORD)-1;
				}

				/* rbg}bv؂ւ */
				if ( ( m->m_lockScreen == 2 || m->m_lockScreen == 3 ) &&
						 ( m->m_noEco || me->m_screenOffTime != (DWORD)-1 ) &&
						 ( ! bScrRunning ) ) {
					if ( m->m_nBmp == 1 ) {
						if ( m->m_bmpDrawType[0] == 1 ) {
							DWORD  diff = t - me->m_createTime;

							if ( diff % m->m_bmpTime[0] < 1000 ) {
								InvalidateRect( wnd, NULL, TRUE );
							}
						}
					}
					else {
						DWORD  diff = t - me->m_createTime;
						int  loopTime;

						loopTime = 0;
						for ( i = 0;  i < m->m_nBmp;  i++ ) {
							loopTime += m->m_bmpTime[i];
						}
						diff = diff % loopTime;

						for ( i = 0;  i < m->m_nBmp;  i++ ) {
							if ( diff < m->m_bmpTime[i] )  break;
							diff -= m->m_bmpTime[i];
						}
						if ( i != me->m_iBmp ) {
							me->m_iBmp = i;
							InvalidateRect( wnd, NULL, TRUE );
						}
					}
				}

				me->m_nextSecTime = t + 1000;
			}
			break;
		}

		default:
			return DefWindowProc( wnd, msg, wParam, lParam );
	}
	return  0;
}


 
/***********************************************************************
  <<< [Overlap_drawBitmap] I[o[bvEEBhEɉ摜\ >>> 
************************************************************************/
void  Overlap_drawBitmap( Overlap* me, CNukeyDlg* m )
{
	const char*  bmp_path = (const char*)m->m_bmpPath[ me->m_iBmp ];
	HDC  dc;
	RECT  rc;
	char  path2[_MAX_PATH];

	StrX_getExeFullPath( path2, bmp_path, sizeof(path2) );
	if ( ! FileX_isExist( path2 ) )  return;

	dc = ::GetDC( me->m_foreWnd );
	::GetClientRect( me->m_foreWnd, &rc );

	DrawBitmap( dc, bmp_path, &rc, m->m_bmpDrawType[ me->m_iBmp ] );

	::ReleaseDC( me->m_foreWnd, dc );
}


 
/***********************************************************************
  <<< [DrawBitmap] rbg}bv`悷 >>> 
yz
  EHDC    dc;    \Ώۂ̃foCXReLXg
  Echar*  path;  rbg}bvt@C̃pX
  ERECT*  rc;    \͈
  Eint  type;    0=A1=_ʒuA2=ׂA3=rc̑Ŝ
y⑫z
E`悷OɃNA͂܂B
************************************************************************/
void  DrawBitmap( HDC dc, const char* path, RECT* rc, int type )
{
	HBITMAP  bmp;
	HDC    bmp_dc;
	FILE*  f;
	BITMAPFILEHEADER  head;
	BITMAPINFOHEADER* infoH;
	BITMAPINFO*       info;
	void*  bits;
	int  x, y;
	int  w, h;
	HWND  desktop = ::GetDesktopWindow();
	HDC   desktopDC = ::GetDC( desktop );
	HGDIOBJ  old;
	char  path2[_MAX_PATH];


	info = (BITMAPINFO*)malloc( sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD) * 256 );
	infoH = &info->bmiHeader;

	StrX_getExeFullPath( path2, path, sizeof(path2) );
	f = fopen( path2, "rb" );

	fread( &head, 1, sizeof(BITMAPFILEHEADER), f );    /* BITMAPFILEHEADER ǂݍ */
	fread( info, 1, sizeof(BITMAPINFOHEADER), f );     /* BITMAPINFOHEADER ǂݍ */
	if ( infoH->biBitCount != 24 )
		fread( info->bmiColors, 1, (1 << infoH->biBitCount) * sizeof(RGBQUAD), f );  /* J[pbgǂݍ */

	bmp = CreateDIBSection( dc, info, DIB_RGB_COLORS, &bits, NULL, 0 );
	fseek( f, head.bfOffBits, SEEK_SET );
	fread( bits, 1, (head.bfSize - head.bfOffBits) & ~0x3, f );  /* rbg}bvf[^ǂݍ */

	bmp_dc = CreateCompatibleDC( dc );
	old = SelectObject( bmp_dc, bmp );
	::SetStretchBltMode( dc, HALFTONE );

	w = (rc->right - rc->left) * infoH->biWidth / GetDeviceCaps( desktopDC, HORZRES );
	h = (rc->bottom - rc->top) * infoH->biHeight / GetDeviceCaps( desktopDC, VERTRES );

	switch ( type ) {
	 case 0:
		x = ( ( rc->right - rc->left ) - w ) / 2;
		y = ( ( rc->bottom - rc->top ) - h ) / 2;
		::StretchBlt( dc, x, y, w, h, bmp_dc, 0, 0, infoH->biWidth, infoH->biHeight, SRCCOPY );
		break;

	 case 1:
		x = rand() * ( ( rc->right - rc->left ) - w ) / RAND_MAX + rc->left;
		y = rand() * ( ( rc->bottom - rc->top ) - h ) / RAND_MAX + rc->top;
		::StretchBlt( dc, x, y, w, h, bmp_dc, 0, 0, infoH->biWidth, infoH->biHeight, SRCCOPY );
		break;

	 case 2:
		for ( y = rc->top; y < rc->bottom; y += h ) {
			for ( x = rc->left; x < rc->right; x += w ) {
				::StretchBlt( dc, x, y, w, h, bmp_dc, 0, 0, infoH->biWidth, infoH->biHeight, SRCCOPY );
			}
		}
		break;

	 case 3:
		if ( (rc->right - rc->left) * infoH->biHeight > (rc->bottom - rc->top) * infoH->biWidth ) {
			h = (rc->bottom - rc->top);
			w = infoH->biWidth * h / infoH->biHeight;
			x = ( ( rc->right - rc->left ) - w ) / 2;
			y = rc->top;
		}
		else {
			w = (rc->right - rc->left);
			h = infoH->biHeight * w / infoH->biWidth;
			x = rc->left;
			y = ( ( rc->bottom - rc->top ) - h ) / 2;
		}
		::StretchBlt( dc, x, y, w, h,
			 bmp_dc, 0, 0, infoH->biWidth, infoH->biHeight, SRCCOPY );
		break;
	}

	SelectObject( bmp_dc, old );
	DeleteDC( bmp_dc );
	DeleteObject( bmp );
	fclose( f );
	::ReleaseDC( desktop, desktopDC );
	free( info );
}



 
/***********************************************************************
  <<< [CNukeyDlg::OnMakeDupKey] uv{^Ƃ >>> 
************************************************************************/
void CNukeyDlg::OnMakeDupKey()
{
	char*  title = "쐬폜";
	char*  title1 = "쐬";
	char*  title2 = "폜";
	WIN32_FILE_ATTRIBUTE_DATA  attr;
	int  iKey;
	char   s[256];
	char   folderPath[256];

	m_OK.SetFocus();

	GetKeyFolderPath( folderPath );
	sprintf( s, "ɂUSB[A܂͍ł͂ȂUSB["
			" %c:hCuɑ}ĉ", folderPath[0] );
	if ( MessageBox( s, title, MB_OKCANCEL ) == IDCANCEL )  return;


	if ( GetNKeyFile() >= Nukey_mKeyFile ) {
		char  path2[_MAX_PATH];

		sprintf( s, "USB[ɂL[t@C܂B\r\n"
			"XVQlɁAnukey tH_[̃t@C̐%dȉɂĂB",
			Nukey_mKeyFile - 1 );

		MessageBox( s, "nukey security G[", MB_OK | MB_TOPMOST );

		sprintf( path2, "%s\\explorer.exe \"%s\"", getenv( "windir" ), folderPath );
		WinExec( path2, SW_SHOWNORMAL );
		return;
	}


	iKey = CheckDupKey( NULL );

	if ( iKey == -1 ) {


		/* hCuɃANZXł邩mF */
		if ( m_folderPath[0] == '\\' && m_folderPath[1] == '\\' ) {
			strcpy( s, m_folderPath );
		}
		else {
			if ( m_folderPath[0] == '\\' )  strcpy( s, "E:" );
			else  strcpy( s, "E:\\" );
			strcat( s, m_folderPath );
			s[0] = m_drive;
		}
		_mkdir( s );
		while ( ! FileX_isExist( s ) ) {
			if ( MessageBox( CString( s ) + " ɃANZXł܂", title, MB_RETRYCANCEL ) == IDCANCEL )
				return;
			_mkdir( s );
		}


		if ( m_dupKey_n >= Nukey_mDupKeyFile ) {
			sprintf( s, "́A%dȏ쐬ł܂B\r\n"
				"XUSB[}Ă߂ĉB", Nukey_mDupKeyFile );
			MessageBox( s, title1, MB_OK );
			return;
		}

		if ( MessageBox( "USB[͂܂ł͂܂B쐬܂B\r\n"
				 "\r\niAł͂ȂUSB[}Ă͂ȂA"
				 "xbNāAUSB[ŃbNĂ݂ĂBj", title1, MB_YESNO ) == IDNO ) {
			MessageBox( "܂łB\r\n"
				"XUSB[}Ă߂ĉB", title1, MB_OK );
			return;
		}


		/* 쐬 */
		if ( ! MakeKey() ) {
			MessageBox( "̍쐬Ɏs܂B\r\n"
				"XUSB[}Ă߂ĉB", title1, MB_OK );
			return;
		}

		GetFileAttributesEx( m_key_path, GetFileExInfoStandard, &attr );
		memcpy( &m_key_accessTime, &attr.ftLastAccessTime, sizeof(FILETIME) );
		m_key_filelen = attr.nFileSizeLow;

		addDupKey();

		MessageBox( "̍쐬ɐ܂B\r\n"
			"Rs[^ċNꂽA͎gȂȂ̂ŒӂĂB\r\n"
			"XUSB[}Ă߂ĉB",
			title1, MB_OK );
	}
	else {
		if ( MessageBox( "USB[͍łBł͂Ȃ܂B", title2, MB_YESNO ) == IDNO ) {
			MessageBox( "܂łB\r\n"
				"XUSB[}Ă߂ĉB", title2, MB_OK );
			return;
		}

		remove( m_dupKey_path[ iKey ] );

		removeDupKey( iKey );

		MessageBox( "ł͂Ȃ܂B\r\n"
			"XUSB[}Ă߂ĉB", title2, MB_OK );
	}
}



 
/***********************************************************************
  <<< [CNukeyDlg::CheckDupKey] hCuɁuv邩mF >>> 
yz
  EWIN32_FILE_ATTRIBUTE_DATA* attr;  ̑BNULL=݂̂݊mFit@C̒g͌Ȃj
  Eint  Ԃl;   ̔zԍB-1=͖
************************************************************************/
int  CNukeyDlg::CheckDupKey( WIN32_FILE_ATTRIBUTE_DATA* attr )
{
	int  i;
	FILE*  f;
	char  data[Nukey_dataSize+1];

	if ( attr == NULL ) {
		for ( i = 0; i < m_dupKey_n; i++ ) {
			if ( FileX_isExist( m_dupKey_path[i] ) )  return  i;
		}
	}
	else {
		for ( i = 0; i < m_dupKey_n; i++ ) {
			if ( ! GetFileAttributesEx( m_dupKey_path[i], GetFileExInfoStandard, attr ) )
				continue;
			if ( memcmp( &attr->ftLastAccessTime, &m_dupKey_accessTime[i], sizeof(FILETIME) ) != 0 )
				{ attr->ftLastAccessTime.dwLowDateTime = 0;  attr->ftLastAccessTime.dwHighDateTime = 0; }

			f = fopen( m_dupKey_path[i], "r" );
			if ( f != NULL ) {
				fread( data, Nukey_dataSize, 1, f );
				fclose( f );

				if ( memcmp( data, m_dupKey_data[i], Nukey_dataSize ) == 0 )  return  i;
			}
		}
	}
	return  -1;
}


 
/***********************************************************************
  <<< [CNukeyDlg::addDupKey] L[폜 >>> 
************************************************************************/
void  CNukeyDlg::addDupKey()
{
	strcpy( m_dupKey_path[ m_dupKey_n ], m_key_path );
	strcpy( m_dupKey_data[ m_dupKey_n ], m_key_data );
	memcpy( &m_dupKey_accessTime[ m_dupKey_n ], &m_key_accessTime, sizeof(FILETIME) );
	m_dupKey_filelen[ m_dupKey_n ] = m_key_filelen;
	m_dupKey_n++;
}


/***********************************************************************
  <<< [CNukeyDlg::removeDupKey] L[폜 >>>
************************************************************************/
void  CNukeyDlg::removeDupKey( int iKey )
{
	ASSERT( iKey < m_dupKey_n );

	m_dupKey_n --;
	for ( iKey;  iKey < m_dupKey_n;  iKey++ ) {
		strcpy( m_dupKey_path[ iKey ], m_dupKey_path[ iKey+1 ] );
		strcpy( m_dupKey_data[ iKey ], m_dupKey_data[ iKey+1 ] );
		memcpy( &m_dupKey_accessTime[ iKey ], &m_dupKey_accessTime[ iKey+1 ], sizeof(FILETIME) );
		m_dupKey_filelen[ iKey ] =  m_dupKey_filelen[ iKey+1 ];
	}
}
 
/***********************************************************************
  <<< [CNukeyDlg::GetKeyFolderPath] L[tH_[̃pX擾 >>> 
y⑫z
Epath ̃TCÝA_MAX_PATH ȏł邱ƁB
************************************************************************/
void  CNukeyDlg::GetKeyFolderPath( char* path )
{
	if ( m_folderPath[0] == '\\' && m_folderPath[1] == '\\' ) {
		strcpy( path, m_folderPath );
	}
	else {
		if ( m_folderPath[0] == '\\' )  strcpy( path, "E:" );
		else  strcpy( path, "E:\\" );
		strcat( path, m_folderPath );
		path[0] = m_drive;
	}
}
 
/***********************************************************************
  <<< [CNukeyDlg::GetNKeyFile] L[̃t@C̐Ԃ >>> 
y⑫z
Eő吔́ANukey_mKeyFile łA
************************************************************************/
int  CNukeyDlg::GetNKeyFile()
{
	HANDLE  f;
	int  nFile;
	WIN32_FIND_DATA  data;
	char  path[_MAX_PATH];

	GetKeyFolderPath( path );
	StrX_addFName( path, "*" );
	f = FindFirstFile( path, &data );

	nFile = 0;
	if ( f != INVALID_HANDLE_VALUE ) {
		do {
			if ( data.cFileName[0] == '.' )  continue;
			if ( strchr( data.cFileName, '.' ) != NULL )  continue;  /* gqƂ͑ΏۊO */
			nFile++;
		} while ( FindNextFile( f, &data ) );
		FindClose( f );
	}

	return  nFile;
}
 
/***********************************************************************
  <<< [LoadHookDLL] tbNsDLL[h >>> 
************************************************************************/
HINSTANCE  LoadHookDLL( const char* dll_folder )
{
	HINSTANCE  DLL;
	char  cwd[_MAX_PATH];

	_getcwd( cwd, sizeof(cwd) );

	if ( dll_folder != NULL )
		_chdir( dll_folder );  /* gq DLL̂ƂɕKv */
	DLL = LoadLibrary( "hook.dll" );
	_chdir( cwd );

	if ( DLL == NULL ) {
		MessageBox( NULL, "NUKEY-HOOK.DLL ܂", "", MB_OK );
		if ( dll_folder != NULL )
			MessageBox( NULL, dll_folder, "", MB_OK );
		exit(3);
	}

	g_StartHook = (StartHook_F)GetProcAddress( DLL, "StartHook" );
	g_StopHook = (StopHook_F)GetProcAddress( DLL, "StopHook" );
	g_GetAltCtrlDel = (GetAltCtrlDel_F)GetProcAddress( DLL, "GetAltCtrlDel" );
	return  DLL;
}


 
/***********************************************************************
  <<< [StrX_getGUIDStr] GUID\̂GUIDɕϊ >>> 
yz
  EGIUD*  guid;       GUID \
  Echar*  guid_str;  iójGUID i "629DF19D-63EA-43e8-A9E0-ABF2A040C14A"j
y⑫z
Eguid_str ́A37oCgȏ̗̈w肵ĂB
************************************************************************/
void  StrX_getGUIDStr( GUID* guid, char* uuid_str )
{
	sprintf( uuid_str, "%08X-%04X-%04X-%02X%02X-%02X%02X%02X%02X%02X%02X",
		guid->Data1, guid->Data2, guid->Data3, guid->Data4[0], guid->Data4[1],
		guid->Data4[2], guid->Data4[3], guid->Data4[4], guid->Data4[5],
		guid->Data4[6], guid->Data4[7] );
}


 
/***********************************************************************
  <<< [StrX_getGUIDFromStr] GUID񂩂GUID\̂ɕϊ >>> 
yz
  EGIUD*  guid;     iójGUID \
  Echar*  guid_str;  GUID i "629DF19D-63EA-43e8-A9E0-ABF2A040C14A"j
y⑫z
Eguid_str  { } ܂܂ĂĂ܂܂B
************************************************************************/
void  StrX_getGUIDFromStr( GUID* guid, char* uuid_str )
{
	char s[10];
	char*  p;
	int  n;

	p = uuid_str;
	if ( *p == '{' )  p++;

	memcpy( s, p, 8 );  s[8] = '\0';
	sscanf( s, "%08X", &guid->Data1 );
	p += 9;

	memcpy( s, p, 4 );  s[4] = '\0';
	sscanf( s, "%04X", &n );  guid->Data2 = n;
	p += 5;

	memcpy( s, p, 4 );  s[4] = '\0';
	sscanf( s, "%04X", &n );  guid->Data3 = n;
	p += 5;

	s[2] = '\0';
	memcpy( s, p, 2 );  sscanf( s, "%02X", &n );  guid->Data4[0] = n;  p += 2;
	memcpy( s, p, 2 );  sscanf( s, "%02X", &n );  guid->Data4[1] = n;  p += 3;
	memcpy( s, p, 2 );  sscanf( s, "%02X", &n );  guid->Data4[2] = n;  p += 2;
	memcpy( s, p, 2 );  sscanf( s, "%02X", &n );  guid->Data4[3] = n;  p += 2;
	memcpy( s, p, 2 );  sscanf( s, "%02X", &n );  guid->Data4[4] = n;  p += 2;
	memcpy( s, p, 2 );  sscanf( s, "%02X", &n );  guid->Data4[5] = n;  p += 2;
	memcpy( s, p, 2 );  sscanf( s, "%02X", &n );  guid->Data4[6] = n;  p += 2;
	memcpy( s, p, 2 );  sscanf( s, "%02X", &n );  guid->Data4[7] = n;
}


 
/************************************************************************
  <<< [TimeDate_setDiff] Ԃ m ֐ݒ肷 >>> 
yz
  Etime_t*  m;   ݒi[ϐւ̃AhX
  Eint  year;       Nij[0`64]
  Eint  month;       [0`12]
  Eint  day;         [0`31]
  Eint  hour;        [0`23]
  Eint  min;         [0`59]
  Eint  sec;        b [0`59]
  Eint  Ԃl;     0=, 1=͈͊O
y⑫z
EԂ́Atime_t ^̎ɑ΂āAZƂɎg܂B
*************************************************************************/
int  TimeDate_setDiff( time_t* m, int year, int month, int day,
	int hour, int min, int sec )
{
	time_t  f;
	int  r;

	r = TimeDate_set( m, year + 1970, month + 1, day + 2, hour, min, sec );
	TimeDate_set( &f, 1970, 1, 2, 0,0,0 );
	*m -= f;

	return  r;
}


 
static void  TimeDate_setLocaleByOS()
{
	static bool  bFirst = true;

	if ( bFirst ) {
		setlocale( LC_ALL, "" );
		_tzset();
		bFirst = false;
	}
}

/************************************************************************
  <<< [TimeDate_set]  m ֐ݒ肷 >>> 
yz
  Etime_t*  m;   ݒi[ϐւ̃AhX
  Eint  year;       Nij[1970`2036]
  Eint  month;       [1`12]
  Eint  day;         [1`31]
  Eint  hour;        [0`23]
  Eint  min;         [0`59]
  Eint  sec;        b [0`59]
  Eint  Ԃl;     0=, 1=͈͊O
y⑫z
E 1970 N 1  1  0  2036 N 2  5  0 ܂Őݒł܂B
Ew肵⎞Ȃǂ͈͊ȌꍇAIɌvZĐK܂B
*************************************************************************/
int  TimeDate_set( time_t* m, int year, int month, int day,
	int hour, int min, int sec )
{
	struct tm  xmas;
	time_t  holiday;

	TimeDate_setLocaleByOS();
	xmas.tm_sec = sec;
	xmas.tm_min = min;
	xmas.tm_hour = hour;
	xmas.tm_mday = day;
	xmas.tm_mon = month - 1;
	xmas.tm_year = year - 1900;
	xmas.tm_isdst = -1;

	holiday = mktime( &xmas );
	if ( holiday == (time_t)-1 )  return  1;

	*m = holiday;
	return  0;
}


 
/************************************************************************
  <<< [FileX_getUpdate] t@C̍XV擾 >>> 
yz
  Etime_t*  date;  XVi[AhX
y⑫z
E΃pXɂĎw肷ꍇAݎs̃tH_[̑΃pX
	Ȃ܂B
Et@C݂ȂꍇA얢`łB
Etime_t ^́Actime  difftime Ȃǂ̕W֐ɎgƂo܂B
*************************************************************************/
void  FileX_getUpdate( const char* fName, time_t* date )
{
	int  r;
	struct _stat  status;

	r = _stat( fName, &status );
	if ( r != 0 ) {
		error();
	}

	*date = status.st_mtime;
}


 
/***********************************************************************
  <<< [WinX_getAllAppHWnd] w̃vÕEBhEnḧꗗ擾 >>> 
yz
  EHWND*  hs;        iójEBhEnh̏W
  Eint    hs_size;    hs ̃[TCY
  Echar*  exe_fname;  st@C
  Eint  Ԃl;       i[vf
************************************************************************/
int  WinX_getAllAppHWnd( HWND* hs, int hs_size, const char* exe_fname )
{
	HWND   wnd;
	HWND*  hs_first = hs;
	HWND*  hs_over = (HWND*)( (char*)hs + hs_size );
	char   path[_MAX_PATH];


	for ( wnd = GetTopWindow( GetDesktopWindow() );
				wnd != NULL;
				wnd = GetNextWindow( wnd, GW_HWNDNEXT ) ) {  /* EnumWindow ̕S炵 */
		WinX_getExeFNameOfWnd( wnd, path );
		if ( exe_fname == NULL || stricmp( path, exe_fname ) == 0 ) {
			*hs = wnd;
			hs++;
			if ( hs >= hs_over )  break;
		}
	}
	return  hs - hs_first;
}


 
/**************************************************************************
  <<< [WinX_getExeFNameOfWnd] wEBhE̎st@C̃pX擾 >>> 
yz
  EHWND  hWnd;       ׂEBhEnh
  Echar*  exe_fname; iójst@C̃t@Ci[TCÝA_MAX_PATHj
  Ebool  Ԃl;     ǂ
y⑫z
Eexe_fname ́ApXł͂Ȃt@CłB
EWindows NT4.0ȑOł͎g܂B
EQl http://techtips.belution.com/ja/vc/0022/
***************************************************************************/
#include <tlhelp32.h>

bool  WinX_getExeFNameOfWnd( HWND wnd, char* exe_fname )
{
	bool    ret = false;
	DWORD   wnd_procId;
	HANDLE  snapshot;
	PROCESSENTRY32  proc;

	/* ToolHelp ֐|C^ */
	HANDLE (WINAPI *CreateSnapshot)( DWORD, DWORD );
	BOOL (WINAPI *Process32First)( HANDLE, LPPROCESSENTRY32 );
	BOOL (WINAPI *Process32Next)( HANDLE, LPPROCESSENTRY32 );

	/* EBhẼvZXID擾 */
	GetWindowThreadProcessId( wnd , &wnd_procId );

	/* DLL ֐̃AhX擾 */
	CreateSnapshot = (HANDLE(WINAPI*)(DWORD,DWORD)) GetProcAddress(
		 GetModuleHandle("kernel32.dll"), "CreateToolhelp32Snapshot" );
	Process32First= (BOOL(WINAPI*)(HANDLE,LPPROCESSENTRY32)) GetProcAddress(
		 GetModuleHandle("kernel32.dll"), "Process32First" );
	Process32Next= (BOOL(WINAPI*)(HANDLE,LPPROCESSENTRY32))GetProcAddress(
		 GetModuleHandle("kernel32.dll"), "Process32Next" );

	if ( !CreateSnapshot || !Process32First || !Process32Next )
		return FALSE;


	/* SvZXAvEBhE */
	snapshot = CreateSnapshot( TH32CS_SNAPPROCESS , 0 );  /* open */
	if ( snapshot == (HANDLE)-1 )  error();

	proc.dwSize = sizeof(PROCESSENTRY32);
	if ( Process32First( snapshot, &proc ) ) {
		do {
			if ( proc.th32ProcessID == wnd_procId ) {
				strcpy( exe_fname, proc.szExeFile );
				ret = true;
				break;
			}
		} while ( Process32Next( snapshot, &proc ) );
	}
	CloseHandle( snapshot );

	return  ret;
}


 
/**************************************************************************
  <<< [WinX_getExeFNameByWild] s̃t@C̖OP擾 >>> 
yz
  Echar*  exe_fname_wild;  s̃t@C̖ÕChJ[h
  Echar*  out_exe_fname;   iójs̃t@C
  Eint    out_size;        out_exe_fname ẅ̃[TCY
  Ebool  Ԃl;           ǂ
y⑫z
Eexe_fname_wild  out_exe_fname ́ApXł͂Ȃt@CłB
***************************************************************************/
#include <tlhelp32.h>

bool  WinX_getExeFNameByWild( const char* exe_fname_wild, char* out_exe_fname,
	int out_size )
{
	bool    ret = false;
	HANDLE  snapshot;
	PROCESSENTRY32  proc;

	/* ToolHelp ֐|C^ */
	static HANDLE (WINAPI *CreateSnapshot)( DWORD, DWORD );
	static BOOL (WINAPI *Process32First)( HANDLE, LPPROCESSENTRY32 );
	static BOOL (WINAPI *Process32Next)( HANDLE, LPPROCESSENTRY32 );

	/* DLL ֐̃AhX擾 */
	CreateSnapshot = (HANDLE(WINAPI*)(DWORD,DWORD)) GetProcAddress(
		 GetModuleHandle("kernel32.dll"), "CreateToolhelp32Snapshot" );
	Process32First= (BOOL(WINAPI*)(HANDLE,LPPROCESSENTRY32)) GetProcAddress(
		 GetModuleHandle("kernel32.dll"), "Process32First" );
	Process32Next= (BOOL(WINAPI*)(HANDLE,LPPROCESSENTRY32))GetProcAddress(
		 GetModuleHandle("kernel32.dll"), "Process32Next" );

	if ( !CreateSnapshot || !Process32First || !Process32Next )
		return false;


	/* SvZXAvst@C */
	snapshot = CreateSnapshot( TH32CS_SNAPPROCESS , 0 );  /* open */
	if ( snapshot == (HANDLE)-1 )  error();

	proc.dwSize = sizeof(PROCESSENTRY32);
	if ( Process32First( snapshot, &proc ) ) {
		do {
			if ( StrX_cmpWildI( exe_fname_wild, proc.szExeFile ) == 0 ) {
				ret = true;
				StrX_cpy( out_exe_fname, proc.szExeFile, out_size );
				break;
			}
		} while ( Process32Next( snapshot, &proc ) );
	}
	CloseHandle( snapshot );

	return  ret;
}


 
/**************************************************************************
  <<< [WinX_exitWindowsEx] Vbg_EăVbg_EȂǂs >>> 
yz
  Eint   flag;    Vbg_EiExitWindowsEx API ̃wvQƁj
  Ebool  Ԃl;  ǂ
y⑫z
E֐߂܂Bs֐߂܂B
***************************************************************************/
bool  WinX_exitWindowsEx( int flag )
{
	HANDLE  processToken;
	LUID    luid;
	TOKEN_PRIVILEGES*  priv = (TOKEN_PRIVILEGES*)
			malloc( sizeof(TOKEN_PRIVILEGES) + sizeof(LUID_AND_ATTRIBUTES) );


	if ( ! OpenProcessToken( GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES, &processToken ) )
		goto err;

	if ( ! LookupPrivilegeValue( NULL, SE_SHUTDOWN_NAME, &luid  ) )  /* LUID擾 */
		goto err;


	/* SE_SHUTDOWN_NAME LɂƂf[^쐬 */
	priv->PrivilegeCount = 1;
	priv->Privileges[0].Luid = luid;
	priv->Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;


	/* ANZXg[N̕ύXs */
	if ( ! AdjustTokenPrivileges( processToken, FALSE, priv, 0, NULL, NULL ) )
		goto err;

	if ( ! CloseHandle( processToken ) )
		goto err;


	free( priv );

	ExitWindowsEx( flag, 0 );

	return  true;

err:
	free( priv );
	return  false;
}


 
BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_SageP.SetHref( "http://www.sage-p.com/" );
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}


 
